/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 7 "src/parse.y" /* yacc.c:339  */

#undef PARSER_DEBUG

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
/*
 * Force yacc to use our memory management.  This is a little evil because
 * the macros assume that "parser_state *p" is in scope
 */
#define YYMALLOC(n)    mrb_malloc(p->mrb, (n))
#define YYFREE(o)      mrb_free(p->mrb, (o))
#define YYSTACK_USE_ALLOCA 0

#include <ctype.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "mruby.h"
#include "mruby/compile.h"
#include "mruby/proc.h"
#include "node.h"

#define YYLEX_PARAM p

typedef mrb_ast_node node;
typedef struct mrb_parser_state parser_state;
typedef struct mrb_parser_heredoc_info parser_heredoc_info;

static int yylex(void *lval, parser_state *p);
static void yyerror(parser_state *p, const char *s);
static void yywarn(parser_state *p, const char *s);
static void yywarning(parser_state *p, const char *s);
static void backref_error(parser_state *p, node *n);
static void tokadd(parser_state *p, int c);

#ifndef isascii
#define isascii(c) (((c) & ~0x7f) == 0)
#endif

#define identchar(c) (isalnum(c) || (c) == '_' || !isascii(c))

typedef unsigned int stack_type;

#define BITSTACK_PUSH(stack, n) ((stack) = ((stack)<<1)|((n)&1))
#define BITSTACK_POP(stack)     ((stack) = (stack) >> 1)
#define BITSTACK_LEXPOP(stack)  ((stack) = ((stack) >> 1) | ((stack) & 1))
#define BITSTACK_SET_P(stack)   ((stack)&1)

#define COND_PUSH(n)    BITSTACK_PUSH(p->cond_stack, (n))
#define COND_POP()      BITSTACK_POP(p->cond_stack)
#define COND_LEXPOP()   BITSTACK_LEXPOP(p->cond_stack)
#define COND_P()        BITSTACK_SET_P(p->cond_stack)

#define CMDARG_PUSH(n)  BITSTACK_PUSH(p->cmdarg_stack, (n))
#define CMDARG_POP()    BITSTACK_POP(p->cmdarg_stack)
#define CMDARG_LEXPOP() BITSTACK_LEXPOP(p->cmdarg_stack)
#define CMDARG_P()      BITSTACK_SET_P(p->cmdarg_stack)

#define sym(x) ((mrb_sym)(intptr_t)(x))
#define nsym(x) ((node*)(intptr_t)(x))

static inline mrb_sym
intern_cstr_gen(parser_state *p, const char *s)
{
  return mrb_intern_cstr(p->mrb, s);
}
#define intern_cstr(s) intern_cstr_gen(p,(s))

static inline mrb_sym
intern_gen(parser_state *p, const char *s, size_t len)
{
  return mrb_intern(p->mrb, s, len);
}
#define intern(s,len) intern_gen(p,(s),(len))

static inline mrb_sym
intern_gen_c(parser_state *p, const char c)
{
  return mrb_intern(p->mrb, &c, 1);
}
#define intern_c(c) intern_gen_c(p,(c))

static void
cons_free_gen(parser_state *p, node *cons)
{
  cons->cdr = p->cells;
  p->cells = cons;
}
#define cons_free(c) cons_free_gen(p, (c))

static void*
parser_palloc(parser_state *p, size_t size)
{
  void *m = mrb_pool_alloc(p->pool, size);

  if (!m) {
    longjmp(p->jmp, 1);
  }
  return m;
}

static node*
cons_gen(parser_state *p, node *car, node *cdr)
{
  node *c;

  if (p->cells) {
    c = p->cells;
    p->cells = p->cells->cdr;
  }
  else {
    c = (node *)parser_palloc(p, sizeof(mrb_ast_node));
  }

  c->car = car;
  c->cdr = cdr;
  c->lineno = p->lineno;
  c->filename_index = p->current_filename_index;
  return c;
}
#define cons(a,b) cons_gen(p,(a),(b))

static node*
list1_gen(parser_state *p, node *a)
{
  return cons(a, 0);
}
#define list1(a) list1_gen(p, (a))

static node*
list2_gen(parser_state *p, node *a, node *b)
{
  return cons(a, cons(b,0));
}
#define list2(a,b) list2_gen(p, (a),(b))

static node*
list3_gen(parser_state *p, node *a, node *b, node *c)
{
  return cons(a, cons(b, cons(c,0)));
}
#define list3(a,b,c) list3_gen(p, (a),(b),(c))

static node*
list4_gen(parser_state *p, node *a, node *b, node *c, node *d)
{
  return cons(a, cons(b, cons(c, cons(d, 0))));
}
#define list4(a,b,c,d) list4_gen(p, (a),(b),(c),(d))

static node*
list5_gen(parser_state *p, node *a, node *b, node *c, node *d, node *e)
{
  return cons(a, cons(b, cons(c, cons(d, cons(e, 0)))));
}
#define list5(a,b,c,d,e) list5_gen(p, (a),(b),(c),(d),(e))

static node*
list6_gen(parser_state *p, node *a, node *b, node *c, node *d, node *e, node *f)
{
  return cons(a, cons(b, cons(c, cons(d, cons(e, cons(f, 0))))));
}
#define list6(a,b,c,d,e,f) list6_gen(p, (a),(b),(c),(d),(e),(f))

static node*
append_gen(parser_state *p, node *a, node *b)
{
  node *c = a;

  if (!a) return b;
  while (c->cdr) {
    c = c->cdr;
  }
  if (b) {
    c->cdr = b;
  }
  return a;
}
#define append(a,b) append_gen(p,(a),(b))
#define push(a,b) append_gen(p,(a),list1(b))

static char*
parser_strndup(parser_state *p, const char *s, size_t len)
{
  char *b = (char *)parser_palloc(p, len+1);

  memcpy(b, s, len);
  b[len] = '\0';
  return b;
}
#define strndup(s,len) parser_strndup(p, s, len)

static char*
parser_strdup(parser_state *p, const char *s)
{
  return parser_strndup(p, s, strlen(s));
}
#undef strdup
#define strdup(s) parser_strdup(p, s)

// xxx -----------------------------

static node*
local_switch(parser_state *p)
{
  node *prev = p->locals;

  p->locals = cons(0, 0);
  return prev;
}

static void
local_resume(parser_state *p, node *prev)
{
  p->locals = prev;
}

static void
local_nest(parser_state *p)
{
  p->locals = cons(0, p->locals);
}

static void
local_unnest(parser_state *p)
{
  p->locals = p->locals->cdr;
}

static int
local_var_p(parser_state *p, mrb_sym sym)
{
  node *l = p->locals;

  while (l) {
    node *n = l->car;
    while (n) {
      if (sym(n->car) == sym) return 1;
      n = n->cdr;
    }
    l = l->cdr;
  }
  return 0;
}

static void
local_add_f(parser_state *p, mrb_sym sym)
{
  p->locals->car = push(p->locals->car, nsym(sym));
}

static void
local_add(parser_state *p, mrb_sym sym)
{
  if (!local_var_p(p, sym)) {
    local_add_f(p, sym);
  }
}

// (:scope (vars..) (prog...))
static node*
new_scope(parser_state *p, node *body)
{
  return cons((node*)NODE_SCOPE, cons(p->locals->car, body));
}

// (:begin prog...)
static node*
new_begin(parser_state *p, node *body)
{
  if (body)
    return list2((node*)NODE_BEGIN, body);
  return cons((node*)NODE_BEGIN, 0);
}

#define newline_node(n) (n)

// (:rescue body rescue else)
static node*
new_rescue(parser_state *p, node *body, node *resq, node *els)
{
  return list4((node*)NODE_RESCUE, body, resq, els);
}

// (:ensure body ensure)
static node*
new_ensure(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_ENSURE, cons(a, cons(0, b)));
}

// (:nil)
static node*
new_nil(parser_state *p)
{
  return list1((node*)NODE_NIL);
}

// (:true)
static node*
new_true(parser_state *p)
{
  return list1((node*)NODE_TRUE);
}

// (:false)
static node*
new_false(parser_state *p)
{
  return list1((node*)NODE_FALSE);
}

// (:alias new old)
static node*
new_alias(parser_state *p, mrb_sym a, mrb_sym b)
{
  return cons((node*)NODE_ALIAS, cons(nsym(a), nsym(b)));
}

// (:if cond then else)
static node*
new_if(parser_state *p, node *a, node *b, node *c)
{
  return list4((node*)NODE_IF, a, b, c);
}

// (:unless cond then else)
static node*
new_unless(parser_state *p, node *a, node *b, node *c)
{
  return list4((node*)NODE_IF, a, c, b);
}

// (:while cond body)
static node*
new_while(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_WHILE, cons(a, b));
}

// (:until cond body)
static node*
new_until(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_UNTIL, cons(a, b));
}

// (:for var obj body)
static node*
new_for(parser_state *p, node *v, node *o, node *b)
{
  return list4((node*)NODE_FOR, v, o, b);
}

// (:case a ((when ...) body) ((when...) body))
static node*
new_case(parser_state *p, node *a, node *b)
{
  node *n = list2((node*)NODE_CASE, a);
  node *n2 = n;

  while (n2->cdr) {
    n2 = n2->cdr;
  }
  n2->cdr = b;
  return n;
}

// (:postexe a)
static node*
new_postexe(parser_state *p, node *a)
{
  return cons((node*)NODE_POSTEXE, a);
}

// (:self)
static node*
new_self(parser_state *p)
{
  return list1((node*)NODE_SELF);
}

// (:call a b c)
static node*
new_call(parser_state *p, node *a, mrb_sym b, node *c)
{
  return list4((node*)NODE_CALL, a, nsym(b), c);
}

// (:fcall self mid args)
static node*
new_fcall(parser_state *p, mrb_sym b, node *c)
{
  return list4((node*)NODE_FCALL, new_self(p), nsym(b), c);
}

// (:super . c)
static node*
new_super(parser_state *p, node *c)
{
  return cons((node*)NODE_SUPER, c);
}

// (:zsuper)
static node*
new_zsuper(parser_state *p)
{
  return list1((node*)NODE_ZSUPER);
}

// (:yield . c)
static node*
new_yield(parser_state *p, node *c)
{
  if (c) {
    if (c->cdr) {
      yyerror(p, "both block arg and actual block given");
    }
    return cons((node*)NODE_YIELD, c->car);
  }
  return cons((node*)NODE_YIELD, 0);
}

// (:return . c)
static node*
new_return(parser_state *p, node *c)
{
  return cons((node*)NODE_RETURN, c);
}

// (:break . c)
static node*
new_break(parser_state *p, node *c)
{
  return cons((node*)NODE_BREAK, c);
}

// (:next . c)
static node*
new_next(parser_state *p, node *c)
{
  return cons((node*)NODE_NEXT, c);
}

// (:redo)
static node*
new_redo(parser_state *p)
{
  return list1((node*)NODE_REDO);
}

// (:retry)
static node*
new_retry(parser_state *p)
{
  return list1((node*)NODE_RETRY);
}

// (:dot2 a b)
static node*
new_dot2(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_DOT2, cons(a, b));
}

// (:dot3 a b)
static node*
new_dot3(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_DOT3, cons(a, b));
}

// (:colon2 b c)
static node*
new_colon2(parser_state *p, node *b, mrb_sym c)
{
  return cons((node*)NODE_COLON2, cons(b, nsym(c)));
}

// (:colon3 . c)
static node*
new_colon3(parser_state *p, mrb_sym c)
{
  return cons((node*)NODE_COLON3, nsym(c));
}

// (:and a b)
static node*
new_and(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_AND, cons(a, b));
}

// (:or a b)
static node*
new_or(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_OR, cons(a, b));
}

// (:array a...)
static node*
new_array(parser_state *p, node *a)
{
  return cons((node*)NODE_ARRAY, a);
}

// (:splat . a)
static node*
new_splat(parser_state *p, node *a)
{
  return cons((node*)NODE_SPLAT, a);
}

// (:hash (k . v) (k . v)...)
static node*
new_hash(parser_state *p, node *a)
{
  return cons((node*)NODE_HASH, a);
}

// (:sym . a)
static node*
new_sym(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_SYM, nsym(sym));
}

static mrb_sym
new_strsym(parser_state *p, node* str)
{
  const char *s = (const char*)str->cdr->car;
  size_t len = (size_t)str->cdr->cdr;

  return mrb_intern(p->mrb, s, len);
}

// (:lvar . a)
static node*
new_lvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_LVAR, nsym(sym));
}

// (:gvar . a)
static node*
new_gvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_GVAR, nsym(sym));
}

// (:ivar . a)
static node*
new_ivar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_IVAR, nsym(sym));
}

// (:cvar . a)
static node*
new_cvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_CVAR, nsym(sym));
}

// (:const . a)
static node*
new_const(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_CONST, nsym(sym));
}

// (:undef a...)
static node*
new_undef(parser_state *p, mrb_sym sym)
{
  return list2((node*)NODE_UNDEF, nsym(sym));
}

// (:class class super body)
static node*
new_class(parser_state *p, node *c, node *s, node *b)
{
  return list4((node*)NODE_CLASS, c, s, cons(p->locals->car, b));
}

// (:sclass obj body)
static node*
new_sclass(parser_state *p, node *o, node *b)
{
  return list3((node*)NODE_SCLASS, o, cons(p->locals->car, b));
}

// (:module module body)
static node*
new_module(parser_state *p, node *m, node *b)
{
  return list3((node*)NODE_MODULE, m, cons(p->locals->car, b));
}

// (:def m lv (arg . body))
static node*
new_def(parser_state *p, mrb_sym m, node *a, node *b)
{
  return list5((node*)NODE_DEF, nsym(m), p->locals->car, a, b);
}

// (:sdef obj m lv (arg . body))
static node*
new_sdef(parser_state *p, node *o, mrb_sym m, node *a, node *b)
{
  return list6((node*)NODE_SDEF, o, nsym(m), p->locals->car, a, b);
}

// (:arg . sym)
static node*
new_arg(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_ARG, nsym(sym));
}

// (m o r m2 b)
// m: (a b c)
// o: ((a . e1) (b . e2))
// r: a
// m2: (a b c)
// b: a
static node*
new_args(parser_state *p, node *m, node *opt, mrb_sym rest, node *m2, mrb_sym blk)
{
  node *n;

  n = cons(m2, nsym(blk));
  n = cons(nsym(rest), n);
  n = cons(opt, n);
  return cons(m, n);
}

// (:block_arg . a)
static node*
new_block_arg(parser_state *p, node *a)
{
  return cons((node*)NODE_BLOCK_ARG, a);
}

// (:block arg body)
static node*
new_block(parser_state *p, node *a, node *b)
{
  return list4((node*)NODE_BLOCK, p->locals->car, a, b);
}

// (:lambda arg body)
static node*
new_lambda(parser_state *p, node *a, node *b)
{
  return list4((node*)NODE_LAMBDA, p->locals->car, a, b);
}

// (:asgn lhs rhs)
static node*
new_asgn(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_ASGN, cons(a, b));
}

// (:masgn mlhs=(pre rest post)  mrhs)
static node*
new_masgn(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_MASGN, cons(a, b));
}

// (:asgn lhs rhs)
static node*
new_op_asgn(parser_state *p, node *a, mrb_sym op, node *b)
{
  return list4((node*)NODE_OP_ASGN, a, nsym(op), b);
}

// (:int . i)
static node*
new_int(parser_state *p, const char *s, int base)
{
  return list3((node*)NODE_INT, (node*)strdup(s), (node*)(intptr_t)base);
}

// (:float . i)
static node*
new_float(parser_state *p, const char *s)
{
  return cons((node*)NODE_FLOAT, (node*)strdup(s));
}

// (:str . (s . len))
static node*
new_str(parser_state *p, const char *s, int len)
{
  return cons((node*)NODE_STR, cons((node*)strndup(s, len), (node*)(intptr_t)len));
}

// (:dstr . a)
static node*
new_dstr(parser_state *p, node *a)
{
  return cons((node*)NODE_DSTR, a);
}

// (:str . (s . len))
static node*
new_xstr(parser_state *p, const char *s, int len)
{
  return cons((node*)NODE_XSTR, cons((node*)strndup(s, len), (node*)(intptr_t)len));
}

// (:xstr . a)
static node*
new_dxstr(parser_state *p, node *a)
{
  return cons((node*)NODE_DXSTR, a);
}

// (:dsym . a)
static node*
new_dsym(parser_state *p, node *a)
{
  return cons((node*)NODE_DSYM, new_dstr(p, a));
}

// (:str . (a . a))
static node*
new_regx(parser_state *p, const char *p1, const char* p2)
{
  return cons((node*)NODE_REGX, cons((node*)p1, (node*)p2));
}

// (:dregx . a)
static node*
new_dregx(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_DREGX, cons(a, b));
}

// (:backref . n)
static node*
new_back_ref(parser_state *p, int n)
{
  return cons((node*)NODE_BACK_REF, (node*)(intptr_t)n);
}

// (:nthref . n)
static node*
new_nth_ref(parser_state *p, int n)
{
  return cons((node*)NODE_NTH_REF, (node*)(intptr_t)n);
}

// (:heredoc . a)
static node*
new_heredoc(parser_state *p)
{
  parser_heredoc_info *inf = (parser_heredoc_info *)parser_palloc(p, sizeof(parser_heredoc_info));
  return cons((node*)NODE_HEREDOC, (node*)inf);
}

static void
new_bv(parser_state *p, mrb_sym id)
{
}

static node*
new_literal_delim(parser_state *p)
{
  return cons((node*)NODE_LITERAL_DELIM, 0);
}

// (:words . a)
static node*
new_words(parser_state *p, node *a)
{
  return cons((node*)NODE_WORDS, a);
}

// (:symbols . a)
static node*
new_symbols(parser_state *p, node *a)
{
  return cons((node*)NODE_SYMBOLS, a);
}

// xxx -----------------------------

// (:call a op)
static node*
call_uni_op(parser_state *p, node *recv, char *m)
{
  return new_call(p, recv, intern_cstr(m), 0);
}

// (:call a op b)
static node*
call_bin_op(parser_state *p, node *recv, char *m, node *arg1)
{
  return new_call(p, recv, intern_cstr(m), list1(list1(arg1)));
}

static void
args_with_block(parser_state *p, node *a, node *b)
{
  if (b) {
    if (a->cdr) {
      yyerror(p, "both block arg and actual block given");
    }
    a->cdr = b;
  }
}

static void
call_with_block(parser_state *p, node *a, node *b)
{
  node *n;

  if (a->car == (node*)NODE_SUPER ||
      a->car == (node*)NODE_ZSUPER) {
    if (!a->cdr) a->cdr = cons(0, b);
    else {
      args_with_block(p, a->cdr, b);
    }
  }
  else {
    n = a->cdr->cdr->cdr;
    if (!n->car) n->car = cons(0, b);
    else {
      args_with_block(p, n->car, b);
    }
  }
}

static node*
negate_lit(parser_state *p, node *n)
{
  return cons((node*)NODE_NEGATE, n);
}

static node*
cond(node *n)
{
  return n;
}

static node*
ret_args(parser_state *p, node *n)
{
  if (n->cdr) {
    yyerror(p, "block argument should not be given");
    return NULL;
  }
  if (!n->car->cdr) return n->car->car;
  return new_array(p, n->car);
}

static void
assignable(parser_state *p, node *lhs)
{
  if ((int)(intptr_t)lhs->car == NODE_LVAR) {
    local_add(p, sym(lhs->cdr));
  }
}

static node*
var_reference(parser_state *p, node *lhs)
{
  node *n;

  if ((int)(intptr_t)lhs->car == NODE_LVAR) {
    if (!local_var_p(p, sym(lhs->cdr))) {
      n = new_fcall(p, sym(lhs->cdr), 0);
      cons_free(lhs);
      return n;
    }
  }

  return lhs;
}

typedef enum mrb_string_type  string_type;

static node*
new_strterm(parser_state *p, string_type type, int term, int paren)
{
  return cons((node*)(intptr_t)type, cons((node*)0, cons((node*)(intptr_t)paren, (node*)(intptr_t)term)));
}

static void
end_strterm(parser_state *p)
{
  cons_free(p->lex_strterm->cdr->cdr);
  cons_free(p->lex_strterm->cdr);
  cons_free(p->lex_strterm);
  p->lex_strterm = NULL;
}

parser_heredoc_info *
parsing_heredoc_inf(parser_state *p)
{
  node *nd = p->parsing_heredoc;
  if (nd == NULL)
    return NULL;
  /* mrb_assert(nd->car->car == NODE_HEREDOC); */
  return (parser_heredoc_info*)nd->car->cdr;
}

static void
heredoc_treat_nextline(parser_state *p)
{
  if (p->heredocs_from_nextline == NULL)
    return;
  if (p->parsing_heredoc == NULL) {
    node *n;
    p->parsing_heredoc = p->heredocs_from_nextline;
    p->lex_strterm_before_heredoc = p->lex_strterm;
    p->lex_strterm = new_strterm(p, parsing_heredoc_inf(p)->type, 0, 0);
    n = p->all_heredocs;
    if (n) {
      while (n->cdr)
	n = n->cdr;
      n->cdr = p->parsing_heredoc;
    } else {
      p->all_heredocs = p->parsing_heredoc;
    }
  } else {
    node *n, *m;
    m = p->heredocs_from_nextline;
    while (m->cdr)
      m = m->cdr;
    n = p->all_heredocs;
    mrb_assert(n != NULL);
    if (n == p->parsing_heredoc) {
      m->cdr = n;
      p->all_heredocs = p->heredocs_from_nextline;
      p->parsing_heredoc = p->heredocs_from_nextline;
    } else {
      while (n->cdr != p->parsing_heredoc) {
	n = n->cdr;
	mrb_assert(n != NULL);
      }
      m->cdr = n->cdr;
      n->cdr = p->heredocs_from_nextline;
      p->parsing_heredoc = p->heredocs_from_nextline;
    }
  }
  p->heredocs_from_nextline = NULL;
}

static void
heredoc_end(parser_state *p)
{
  p->parsing_heredoc = p->parsing_heredoc->cdr;
  if (p->parsing_heredoc == NULL) {
    p->lstate = EXPR_BEG;
    p->cmd_start = TRUE;
    end_strterm(p);
    p->lex_strterm = p->lex_strterm_before_heredoc;
    p->lex_strterm_before_heredoc = NULL;
    p->heredoc_end_now = TRUE;
  } else {
    /* next heredoc */
    p->lex_strterm->car = (node*)(intptr_t)parsing_heredoc_inf(p)->type;
  }
}
#define is_strterm_type(p,str_func) ((int)(intptr_t)((p)->lex_strterm->car) & (str_func))

// xxx -----------------------------


#line 1042 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    keyword_class = 258,
    keyword_module = 259,
    keyword_def = 260,
    keyword_undef = 261,
    keyword_begin = 262,
    keyword_rescue = 263,
    keyword_ensure = 264,
    keyword_end = 265,
    keyword_if = 266,
    keyword_unless = 267,
    keyword_then = 268,
    keyword_elsif = 269,
    keyword_else = 270,
    keyword_case = 271,
    keyword_when = 272,
    keyword_while = 273,
    keyword_until = 274,
    keyword_for = 275,
    keyword_break = 276,
    keyword_next = 277,
    keyword_redo = 278,
    keyword_retry = 279,
    keyword_in = 280,
    keyword_do = 281,
    keyword_do_cond = 282,
    keyword_do_block = 283,
    keyword_do_LAMBDA = 284,
    keyword_return = 285,
    keyword_yield = 286,
    keyword_super = 287,
    keyword_self = 288,
    keyword_nil = 289,
    keyword_true = 290,
    keyword_false = 291,
    keyword_and = 292,
    keyword_or = 293,
    keyword_not = 294,
    modifier_if = 295,
    modifier_unless = 296,
    modifier_while = 297,
    modifier_until = 298,
    modifier_rescue = 299,
    keyword_alias = 300,
    keyword_BEGIN = 301,
    keyword_END = 302,
    keyword__LINE__ = 303,
    keyword__FILE__ = 304,
    keyword__ENCODING__ = 305,
    tIDENTIFIER = 306,
    tFID = 307,
    tGVAR = 308,
    tIVAR = 309,
    tCONSTANT = 310,
    tCVAR = 311,
    tLABEL = 312,
    tINTEGER = 313,
    tFLOAT = 314,
    tCHAR = 315,
    tXSTRING = 316,
    tREGEXP = 317,
    tSTRING = 318,
    tSTRING_PART = 319,
    tSTRING_MID = 320,
    tNTH_REF = 321,
    tBACK_REF = 322,
    tREGEXP_END = 323,
    tUPLUS = 324,
    tUMINUS = 325,
    tPOW = 326,
    tCMP = 327,
    tEQ = 328,
    tEQQ = 329,
    tNEQ = 330,
    tGEQ = 331,
    tLEQ = 332,
    tANDOP = 333,
    tOROP = 334,
    tMATCH = 335,
    tNMATCH = 336,
    tDOT2 = 337,
    tDOT3 = 338,
    tAREF = 339,
    tASET = 340,
    tLSHFT = 341,
    tRSHFT = 342,
    tCOLON2 = 343,
    tCOLON3 = 344,
    tOP_ASGN = 345,
    tASSOC = 346,
    tLPAREN = 347,
    tLPAREN_ARG = 348,
    tRPAREN = 349,
    tLBRACK = 350,
    tLBRACE = 351,
    tLBRACE_ARG = 352,
    tSTAR = 353,
    tAMPER = 354,
    tLAMBDA = 355,
    tSYMBEG = 356,
    tREGEXP_BEG = 357,
    tWORDS_BEG = 358,
    tSYMBOLS_BEG = 359,
    tSTRING_BEG = 360,
    tXSTRING_BEG = 361,
    tSTRING_DVAR = 362,
    tLAMBEG = 363,
    tHEREDOC_BEG = 364,
    tHEREDOC_END = 365,
    tLITERAL_DELIM = 366,
    tHD_LITERAL_DELIM = 367,
    tHD_STRING_PART = 368,
    tHD_STRING_MID = 369,
    tLOWEST = 370,
    tUMINUS_NUM = 371,
    idNULL = 372,
    idRespond_to = 373,
    idIFUNC = 374,
    idCFUNC = 375,
    id_core_set_method_alias = 376,
    id_core_set_variable_alias = 377,
    id_core_undef_method = 378,
    id_core_define_method = 379,
    id_core_define_singleton_method = 380,
    id_core_set_postexe = 381,
    tLAST_TOKEN = 382
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 987 "src/parse.y" /* yacc.c:355  */

    node *nd;
    mrb_sym id;
    int num;
    unsigned int stack;
    const struct vtable *vars;

#line 1215 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (parser_state *p);



/* Copy the second part of user declarations.  */

#line 1231 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11399

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  154
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  157
/* YYNRULES -- Number of rules.  */
#define YYNRULES  552
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  968

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   382

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     153,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   130,     2,     2,     2,   128,   123,     2,
     149,   150,   126,   124,   147,   125,   146,   127,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   118,   152,
     120,   116,   119,   117,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   145,     2,   151,   122,     2,   148,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   143,   121,   144,   131,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   129,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1146,  1146,  1146,  1156,  1162,  1166,  1170,  1174,  1180,
    1182,  1181,  1193,  1219,  1225,  1229,  1233,  1237,  1243,  1243,
    1247,  1251,  1255,  1259,  1263,  1267,  1271,  1276,  1277,  1281,
    1285,  1289,  1293,  1297,  1302,  1306,  1311,  1315,  1319,  1323,
    1326,  1330,  1337,  1338,  1342,  1346,  1350,  1354,  1357,  1364,
    1365,  1368,  1369,  1373,  1372,  1385,  1389,  1394,  1398,  1403,
    1407,  1412,  1416,  1420,  1424,  1428,  1434,  1438,  1444,  1445,
    1451,  1455,  1459,  1463,  1467,  1471,  1475,  1479,  1483,  1487,
    1493,  1494,  1500,  1504,  1510,  1514,  1520,  1524,  1528,  1532,
    1536,  1540,  1546,  1552,  1559,  1563,  1567,  1571,  1575,  1579,
    1585,  1591,  1598,  1602,  1605,  1609,  1613,  1619,  1620,  1621,
    1622,  1627,  1634,  1635,  1638,  1642,  1642,  1648,  1649,  1650,
    1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,
    1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,
    1671,  1672,  1673,  1674,  1675,  1676,  1679,  1679,  1679,  1680,
    1680,  1681,  1681,  1681,  1682,  1682,  1682,  1682,  1683,  1683,
    1683,  1684,  1684,  1684,  1685,  1685,  1685,  1685,  1686,  1686,
    1686,  1686,  1687,  1687,  1687,  1687,  1688,  1688,  1688,  1688,
    1689,  1689,  1689,  1689,  1690,  1690,  1693,  1697,  1701,  1705,
    1709,  1713,  1717,  1721,  1725,  1730,  1735,  1740,  1744,  1748,
    1752,  1756,  1760,  1764,  1768,  1772,  1776,  1780,  1784,  1788,
    1792,  1796,  1800,  1804,  1808,  1812,  1816,  1820,  1824,  1828,
    1832,  1836,  1840,  1844,  1848,  1852,  1856,  1860,  1864,  1868,
    1874,  1881,  1882,  1886,  1890,  1896,  1902,  1903,  1906,  1907,
    1908,  1912,  1916,  1922,  1926,  1930,  1934,  1938,  1944,  1944,
    1955,  1961,  1965,  1971,  1975,  1979,  1983,  1987,  1991,  1997,
    2001,  2005,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,
    2023,  2022,  2033,  2033,  2037,  2037,  2041,  2045,  2049,  2053,
    2057,  2061,  2065,  2069,  2073,  2077,  2081,  2085,  2089,  2090,
    2096,  2095,  2108,  2115,  2122,  2122,  2122,  2128,  2128,  2128,
    2134,  2140,  2145,  2147,  2144,  2154,  2153,  2166,  2171,  2165,
    2184,  2183,  2196,  2195,  2208,  2209,  2208,  2222,  2226,  2230,
    2234,  2240,  2247,  2248,  2249,  2252,  2253,  2256,  2257,  2265,
    2266,  2272,  2276,  2279,  2283,  2289,  2293,  2299,  2303,  2307,
    2311,  2315,  2319,  2323,  2327,  2331,  2337,  2341,  2345,  2349,
    2353,  2357,  2361,  2365,  2369,  2373,  2377,  2381,  2385,  2389,
    2393,  2399,  2400,  2407,  2412,  2417,  2424,  2428,  2434,  2435,
    2438,  2443,  2446,  2450,  2456,  2460,  2467,  2466,  2479,  2489,
    2493,  2498,  2505,  2509,  2513,  2517,  2521,  2525,  2529,  2533,
    2537,  2544,  2543,  2554,  2553,  2565,  2573,  2582,  2585,  2592,
    2595,  2599,  2600,  2603,  2607,  2610,  2614,  2617,  2618,  2619,
    2620,  2623,  2624,  2625,  2629,  2635,  2636,  2642,  2647,  2646,
    2657,  2661,  2667,  2671,  2677,  2681,  2687,  2690,  2691,  2694,
    2695,  2698,  2704,  2710,  2711,  2714,  2721,  2720,  2734,  2738,
    2745,  2749,  2756,  2763,  2764,  2765,  2766,  2767,  2771,  2777,
    2781,  2787,  2788,  2789,  2793,  2799,  2803,  2807,  2811,  2815,
    2821,  2827,  2831,  2835,  2839,  2843,  2847,  2854,  2863,  2864,
    2867,  2872,  2871,  2880,  2887,  2893,  2899,  2903,  2907,  2911,
    2915,  2919,  2923,  2927,  2931,  2935,  2939,  2943,  2947,  2951,
    2956,  2962,  2967,  2972,  2977,  2984,  2988,  2995,  2999,  3005,
    3009,  3015,  3022,  3029,  3033,  3039,  3043,  3049,  3050,  3053,
    3058,  3065,  3066,  3069,  3076,  3080,  3087,  3092,  3092,  3117,
    3118,  3124,  3128,  3134,  3138,  3144,  3145,  3146,  3149,  3150,
    3151,  3152,  3155,  3156,  3157,  3160,  3161,  3164,  3165,  3168,
    3169,  3172,  3175,  3178,  3179,  3180,  3183,  3184,  3188,  3187,
    3194,  3195,  3199
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "keyword_class", "keyword_module",
  "keyword_def", "keyword_undef", "keyword_begin", "keyword_rescue",
  "keyword_ensure", "keyword_end", "keyword_if", "keyword_unless",
  "keyword_then", "keyword_elsif", "keyword_else", "keyword_case",
  "keyword_when", "keyword_while", "keyword_until", "keyword_for",
  "keyword_break", "keyword_next", "keyword_redo", "keyword_retry",
  "keyword_in", "keyword_do", "keyword_do_cond", "keyword_do_block",
  "keyword_do_LAMBDA", "keyword_return", "keyword_yield", "keyword_super",
  "keyword_self", "keyword_nil", "keyword_true", "keyword_false",
  "keyword_and", "keyword_or", "keyword_not", "modifier_if",
  "modifier_unless", "modifier_while", "modifier_until", "modifier_rescue",
  "keyword_alias", "keyword_BEGIN", "keyword_END", "keyword__LINE__",
  "keyword__FILE__", "keyword__ENCODING__", "tIDENTIFIER", "tFID", "tGVAR",
  "tIVAR", "tCONSTANT", "tCVAR", "tLABEL", "tINTEGER", "tFLOAT", "tCHAR",
  "tXSTRING", "tREGEXP", "tSTRING", "tSTRING_PART", "tSTRING_MID",
  "tNTH_REF", "tBACK_REF", "tREGEXP_END", "tUPLUS", "tUMINUS", "tPOW",
  "tCMP", "tEQ", "tEQQ", "tNEQ", "tGEQ", "tLEQ", "tANDOP", "tOROP",
  "tMATCH", "tNMATCH", "tDOT2", "tDOT3", "tAREF", "tASET", "tLSHFT",
  "tRSHFT", "tCOLON2", "tCOLON3", "tOP_ASGN", "tASSOC", "tLPAREN",
  "tLPAREN_ARG", "tRPAREN", "tLBRACK", "tLBRACE", "tLBRACE_ARG", "tSTAR",
  "tAMPER", "tLAMBDA", "tSYMBEG", "tREGEXP_BEG", "tWORDS_BEG",
  "tSYMBOLS_BEG", "tSTRING_BEG", "tXSTRING_BEG", "tSTRING_DVAR", "tLAMBEG",
  "tHEREDOC_BEG", "tHEREDOC_END", "tLITERAL_DELIM", "tHD_LITERAL_DELIM",
  "tHD_STRING_PART", "tHD_STRING_MID", "tLOWEST", "'='", "'?'", "':'",
  "'>'", "'<'", "'|'", "'^'", "'&'", "'+'", "'-'", "'*'", "'/'", "'%'",
  "tUMINUS_NUM", "'!'", "'~'", "idNULL", "idRespond_to", "idIFUNC",
  "idCFUNC", "id_core_set_method_alias", "id_core_set_variable_alias",
  "id_core_undef_method", "id_core_define_method",
  "id_core_define_singleton_method", "id_core_set_postexe", "tLAST_TOKEN",
  "'{'", "'}'", "'['", "'.'", "','", "'`'", "'('", "')'", "']'", "';'",
  "'\\n'", "$accept", "program", "$@1", "top_compstmt", "top_stmts",
  "top_stmt", "@2", "bodystmt", "compstmt", "stmts", "stmt", "$@3",
  "command_asgn", "expr", "expr_value", "command_call", "block_command",
  "cmd_brace_block", "$@4", "command", "mlhs", "mlhs_inner", "mlhs_basic",
  "mlhs_item", "mlhs_list", "mlhs_post", "mlhs_node", "lhs", "cname",
  "cpath", "fname", "fsym", "undef_list", "$@5", "op", "reswords", "arg",
  "arg_value", "aref_args", "paren_args", "opt_paren_args",
  "opt_call_args", "call_args", "command_args", "@6", "block_arg",
  "opt_block_arg", "args", "mrhs", "primary", "$@7", "$@8", "$@9", "@10",
  "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "@17", "@18", "@19",
  "@20", "@21", "$@22", "@23", "primary_value", "then", "do", "if_tail",
  "opt_else", "for_var", "f_marg", "f_marg_list", "f_margs", "block_param",
  "opt_block_param", "block_param_def", "opt_bv_decl", "bv_decls", "bvar",
  "f_larglist", "lambda_body", "do_block", "$@24", "block_call",
  "method_call", "brace_block", "$@25", "$@26", "case_body", "cases",
  "opt_rescue", "exc_list", "exc_var", "opt_ensure", "literal", "string",
  "string_rep", "string_interp", "@27", "xstring", "regexp", "heredoc",
  "opt_heredoc_bodies", "heredoc_bodies", "heredoc_body",
  "heredoc_string_rep", "heredoc_string_interp", "@28", "words", "symbol",
  "basic_symbol", "sym", "symbols", "numeric", "variable", "var_lhs",
  "var_ref", "backref", "superclass", "$@29", "f_arglist", "f_args",
  "f_bad_arg", "f_norm_arg", "f_arg_item", "f_arg", "f_opt", "f_block_opt",
  "f_block_optarg", "f_optarg", "restarg_mark", "f_rest_arg",
  "blkarg_mark", "f_block_arg", "opt_f_block_arg", "singleton", "$@30",
  "assoc_list", "assocs", "assoc", "operation", "operation2", "operation3",
  "dot_or_colon", "opt_terms", "opt_nl", "rparen", "rbracket", "trailer",
  "term", "nl", "$@31", "terms", "none", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    61,    63,    58,    62,
      60,   124,    94,    38,    43,    45,    42,    47,    37,   371,
      33,   126,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   123,   125,    91,    46,    44,    96,    40,
      41,    93,    59,    10
};
# endif

#define YYPACT_NINF -766

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-766)))

#define YYTABLE_NINF -553

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-553)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -766,   139,  1626,  -766,  7609,  9465,  9801,  5895,  6978,  -766,
    9117,  9117,  5356,  -766,  -766,  9577,  8305,  8305,  -766,  -766,
    8305,  3464,  3020,  -766,  -766,  -766,  -766,    70,  6978,  -766,
      -1,  -766,  -766,  6029,  3168,  -766,  -766,  6163,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  9233,  9233,    97,  4652,  9117,
    8421,  8653,  7255,  -766,  6686,   685,   718,   859,   903,   569,
    -766,   124,  9349,  9233,  -766,    42,  -766,  1039,  -766,   306,
    -766,  -766,   131,    68,  -766,   128,  9689,  -766,   188,  3147,
      11,   229,    16,    59,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,   375,   219,  -766,   547,   111,  -766,
    -766,  -766,  -766,  -766,   162,   175,   180,   233,   284,  9117,
     281,  4805,   305,  -766,    38,  -766,   267,  -766,  -766,   111,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,    43,    47,
      85,   137,  -766,  -766,  -766,  -766,  -766,  -766,   212,   220,
    -766,   234,  -766,   238,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,    16,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  6832,  -766,  -766,
     167,  -766,  3801,   291,   306,    56,   255,   399,    25,   295,
      28,    56,  -766,  -766,    42,   371,  -766,  -766,   242,  9117,
    9117,   355,  -766,  -766,   404,   395,    94,   102,  9233,  9233,
    9233,  9233,  -766,  3147,   335,  -766,  -766,   292,   293,  -766,
    -766,  -766,  5240,  -766,  8305,  8305,  -766,  -766,  5494,  9117,
    -766,  -766,   285,  4958,  -766,   418,   372,   553,  7841,  4652,
     300,    42,  1039,   303,   342,  -766,   306,   303,   310,   165,
     178,  -766,   335,   329,   178,  -766,   419,  9913,   312,   420,
     452,   455,   758,  -766,  -766,  -766,  -766,   921,  -766,  -766,
    -766,  -766,  -766,  -766,   237,   691,  -766,  -766,   930,  -766,
     954,  -766,   957,  -766,   648,   405,   424,  -766,  -766,  -766,
    -766,  5610,  9117,  9117,  9117,  9117,  7841,  9117,  9117,  -766,
    -766,  8769,  -766,  4652,  7374,   346,  8769,  9233,  9233,  9233,
    9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,
    9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,  9233,
    9233,  9233,  9233, 10198,  8305, 10279,  -766,  -766, 11251,  -766,
    -766,  -766,  9349,  9349,  -766,   392,  -766,   306,  -766,   495,
    -766,  -766,  -766,    42,  -766,  -766,  -766, 10360,  8305, 10441,
    3801,  9117,  1057,  -766,   435,  -766,   489,   493,    50,  -766,
    3945,   496,  9233, 10522,  8305, 10603,  9233,  9233,  4223,   237,
     371,  8885,   500,  -766,    54,    54,   103, 10684,  8305, 10765,
    -766,  -766,  -766,  -766,  9233,  7493,  -766,  -766,  8537,  -766,
     303,   365,  -766,  -766,   303,  -766,   373,   381,  -766,    45,
    -766,  -766,  6978,  4361,   374, 10522, 10603,  9233,  1039,   303,
    -766,  -766,  5745,   390,   303,  -766,  -766,  7725,  -766,  -766,
    8653,  -766,  -766,  -766,   495,   128,  9913,  -766,  9913, 10846,
    8305, 10927,   409,  -766,  -766,  -766,  -766,  1199,  -766,  -766,
    -766,  -766,   790,    66,  -766,  -766,  -766,  -766,   391,  -766,
     408,   483,   410,   488,  -766,  -766,   498,  4958,  -766,  -766,
    -766,   237,  -766,   246,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  9233,  9233,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,    33,  9233,  -766,   411,   415,  -766,   303,  9913,   428,
    -766,  -766,  -766,   430,  2548,  -766,  -766,   372,  6997,  6997,
    6997,  6997,  1121,  1121, 10135,  1428,  6997,  6997,  3295,  3295,
     727,   727,  2408,  1121,  1121,   665,   665,   876,   264,   264,
     372,   372,   372,  3556,  6418,  3648,  6539,  -766,   175,  -766,
     303,   557,  -766,   615,  -766,  -766,  3316,  -766,  -766,  2070,
      33,    33,  -766,  2732,  -766,  3147,  -766,  -766,    42,  -766,
    9117,  3801,   308,   387,  -766,   175,   303,   175,   559,    45,
     790,  3801,    42,  7124,  6978,  -766,  9001,   536,  -766,   422,
    -766,  2999,  6297,  2872,   303,    53,   207,   536,  -766,   237,
     582,    34,  -766,  -766,  -766,  -766,  -766,   145,   154,   303,
     130,   142,  9117,  -766,  9233,   335,  -766,  7957,   293,  -766,
    -766,  -766,  -766,  7493,  8537,  -766,  -766,   450,  -766,  3147,
      17,  1039,  -766,   178,   346,  -766,   308,   387,   303,   135,
     146,  9233,  -766,  1199,    95,  -766,   446,   303,  -766,   303,
    5102,  4958,  -766,   790,  -766,  -766,   790,  -766,  -766,   449,
    -766,  -766,  -766,   459,  4958,  -766,  -766,  -766,   372,   372,
    -766,   642,  5102,  -766,  -766,   461,  8073,  -766,  -766,  9913,
    9349,  9233,   509,  9349,  9349,  -766,   392,   460,   617,  9349,
    9349,  -766,  -766,   392,  -766,    59,   131,  5102,  4958,  9233,
      33,  -766,    42,   632,  -766,  -766,  -766,   303,   634,  -766,
    -766,  -766,   411,  -766,   558,  -766,  4514,   639,  -766,  9117,
     641,  -766,  9233,  9233,   226,  9233,  9233,   652,  -766,  8189,
    4084,  5102,  5102,   155,    54,  -766,  9233,  -766,  -766,   524,
    -766,  -766,   378,  -766,   303,   992,   525,  1207,  -766,   527,
     523,   668,   535,  -766,   538,   544,  -766,   552,  -766,   554,
     552,  -766,   539,   566,   303,   589,   556,  -766,   564,   567,
    -766,   705,  9233,   573,  -766,  3147,  9233,  -766,  3147,  -766,
    3147,  -766,  -766,  9349,  -766,  3147,  -766,  3147,  -766,  -766,
    -766,   713,   580,  3147,  4958,  3801,  -766,  -766,  -766,  -766,
    1057, 10025,    56,  -766,  -766,  5102,  -766,  -766,    56,  -766,
    9233,  -766,  -766,   115,   716,   717,  -766,  -766,  8537,  -766,
     581,   992,   429,  -766,  -766,   974,  -766,  -766,   790,  -766,
     449,  -766,   449,  -766,   449,  -766,  -766,  -766, 10137,   609,
    -766,  1065,  -766,  1065,  -766,   449,  -766,  -766,   590,  3147,
    -766,  3147,  -766,  -766,   619,   756,  3801,   712,  -766,   541,
     452,   455,  3801,  -766,  3945,  -766,  -766,  -766,  -766,  -766,
    5102,   992,   581,   992,   622,  -766,   192,  -766,  -766,   552,
     623,   552,   552,   721,   543,  -766,   633,   638,   552,  -766,
     647,   552,  -766,  -766,   789,   495, 11008,  8305, 11089,   493,
     422,   791,   581,   992,   974,  -766,  -766,   449,  -766,  -766,
    -766,  -766, 11170,  1065,  -766,   449,  -766,  -766,   449,  -766,
    -766,  -766,    81,   387,   303,    64,    83,  -766,  -766,  -766,
     581,  -766,   552,   655,   657,   552,   661,   552,   552,   121,
    -766,  -766,   449,  -766,  -766,  -766,   552,  -766
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     0,     1,     0,     0,     0,     0,     0,   270,
       0,     0,   537,   294,   297,     0,   317,   318,   319,   320,
     281,   248,   248,   463,   462,   464,   465,   539,     0,    10,
       0,   467,   466,   455,   527,   457,   456,   459,   458,   451,
     452,   411,   412,   468,   469,     0,     0,     0,     0,   274,
     552,   552,    78,   290,     0,     0,     0,     0,     0,     0,
     426,     0,     0,     0,     3,   537,     6,     9,    27,    39,
      42,    50,    49,     0,    66,     0,    70,    80,     0,    47,
     229,     0,    51,   288,   262,   263,   264,   265,   266,   409,
     408,   440,   410,   407,   461,     0,   267,   268,   248,     5,
       8,   317,   318,   281,   284,   389,     0,   102,   103,     0,
       0,     0,     0,   105,     0,   321,     0,   461,   268,     0,
     310,   156,   166,   157,   179,   153,   172,   162,   161,   182,
     183,   177,   160,   159,   155,   180,   184,   185,   164,   154,
     167,   171,   173,   165,   158,   174,   181,   176,   175,   168,
     178,   163,   152,   170,   169,   151,   149,   150,   146,   147,
     148,   107,   109,   108,   141,   142,   138,   120,   121,   122,
     129,   126,   128,   123,   124,   143,   144,   130,   131,   135,
     125,   127,   117,   118,   119,   132,   133,   134,   136,   137,
     139,   140,   145,   517,   312,   110,   111,   516,     0,   175,
     168,   178,   163,   146,   147,   107,   108,     0,   112,   114,
      20,   113,     0,     0,    48,     0,     0,     0,   461,     0,
     268,     0,   546,   548,   537,     0,   550,   547,   538,     0,
       0,     0,   332,   331,     0,     0,   461,   268,     0,     0,
       0,     0,   243,   230,   253,    64,   247,   552,   552,   521,
      65,    63,   539,    62,     0,   552,   388,    61,   539,     0,
     540,    18,     0,     0,   207,     0,   208,   278,     0,     0,
       0,   537,    15,   539,    68,    14,   272,   539,     0,   543,
     543,   231,     0,     0,   543,   519,     0,     0,    76,     0,
      86,    93,   490,   445,   444,   446,   447,     0,   443,   442,
     424,   418,   417,   420,     0,     0,   415,   438,     0,   449,
       0,   413,     0,   422,     0,   453,   454,    46,   222,   223,
       4,   538,     0,     0,     0,     0,     0,     0,     0,   376,
     378,     0,    82,     0,    74,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   552,     0,   536,   535,     0,   393,
     391,   289,     0,     0,   382,    55,   287,   307,   102,   103,
     104,   453,   454,     0,   471,   305,   470,     0,   552,     0,
       0,     0,   490,   314,     0,   115,     0,   552,   278,   323,
       0,   322,     0,     0,   552,     0,     0,     0,     0,   427,
       0,     0,     0,   551,     0,     0,   278,     0,   552,     0,
     302,   524,   254,   250,     0,     0,   244,   252,     0,   245,
     539,     0,   283,   249,   539,   239,   552,   552,   238,   539,
     286,    45,     0,     0,     0,     0,     0,     0,    17,   539,
     276,    13,   538,    67,   539,   275,   279,   545,   232,   544,
     545,   234,   280,   520,    92,    84,     0,    79,     0,     0,
     552,     0,   496,   493,   492,   491,   494,     0,   508,   512,
     511,   507,   490,     0,   373,   495,   497,   499,   552,   505,
     552,   510,   552,     0,   489,   448,     0,     0,   431,   436,
     435,   421,   429,     0,   433,   425,   416,   439,   450,   414,
     423,     0,     0,     7,    21,    22,    23,    24,    25,    43,
      44,   552,     0,    28,    37,     0,    38,   539,     0,    72,
      83,    41,    40,     0,   186,   253,    36,   204,   212,   217,
     218,   219,   214,   216,   226,   227,   220,   221,   197,   198,
     224,   225,   539,   213,   215,   209,   210,   211,   199,   200,
     201,   202,   203,   528,   533,   529,   534,   387,   248,   385,
     539,   528,   530,   529,   531,   386,   248,   528,   529,   248,
     552,   552,    29,   188,    35,   196,    53,    56,     0,   473,
       0,     0,   102,   103,   106,     0,   539,   552,     0,   539,
     490,     0,     0,     0,     0,   271,   552,   552,   399,   552,
     324,   186,   532,   529,   539,   528,   529,   552,   549,   428,
       0,     0,   301,   326,   295,   325,   298,   532,   277,   539,
     528,   529,     0,   523,     0,   255,   251,     0,   552,   522,
     282,   541,   235,   240,   242,   285,    19,     0,    26,   195,
      69,    16,   273,   543,    85,    77,    89,    91,   539,   528,
     529,     0,   496,     0,   344,   335,   337,   539,   333,   539,
       0,     0,   291,     0,   482,   515,     0,   485,   509,     0,
     487,   513,   441,     0,     0,   430,   432,   434,   205,   206,
     364,   539,     0,   362,   361,   261,     0,    81,    75,     0,
       0,     0,     0,     0,     0,   384,    59,     0,   390,     0,
       0,   237,   383,    57,   236,   379,    52,     0,     0,     0,
     552,   308,     0,     0,   390,   311,   518,   539,     0,   475,
     315,   116,   400,   401,   552,   402,     0,   552,   329,     0,
       0,   327,     0,     0,   390,     0,     0,     0,   300,     0,
       0,     0,     0,   390,     0,   256,     0,   257,   246,   552,
      11,   233,    87,   501,   539,     0,   342,     0,   498,     0,
     366,     0,     0,   500,   552,   552,   514,   552,   506,   552,
     552,   419,     0,   496,   539,     0,   552,   503,   552,   552,
     360,     0,     0,   259,    73,   187,     0,    34,   193,    33,
     194,    60,   542,     0,    31,   191,    32,   192,    58,   380,
     381,     0,     0,   189,     0,     0,   472,   306,   474,   313,
     490,     0,     0,   404,   330,     0,    12,   406,     0,   292,
       0,   293,   255,   552,     0,     0,   303,   258,   241,   334,
     345,     0,   340,   336,   372,     0,   375,   374,     0,   478,
       0,   480,     0,   486,     0,   483,   488,   437,     0,     0,
     363,   351,   353,     0,   356,     0,   358,   377,   260,   228,
      30,   190,   394,   392,     0,     0,     0,     0,   403,     0,
      94,   101,     0,   405,     0,   396,   397,   395,   296,   299,
       0,     0,   343,     0,   338,   370,   539,   368,   371,   552,
     552,   552,   552,     0,   502,   365,   552,   552,   552,   504,
     552,   552,    54,   309,     0,   100,     0,   552,     0,   552,
     552,     0,   341,     0,     0,   367,   479,     0,   476,   481,
     484,   278,     0,     0,   348,     0,   350,   357,     0,   354,
     359,   316,   532,    99,   539,   528,   529,   398,   328,   304,
     339,   369,   552,   532,   277,   552,   552,   552,   552,   390,
     477,   349,     0,   346,   352,   355,   552,   347
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -766,  -766,  -766,   376,  -766,    20,  -766,  -369,   321,  -766,
      27,  -766,  -313,   189,    76,   -45,  -766,  -584,  -766,   -15,
     801,  -168,   -14,   -61,  -276,  -418,   -19,  2012,   -74,   811,
      13,   -18,  -766,  -766,  -242,  -766,  1550,   314,  -766,    -8,
     244,  -361,   100,    -9,  -766,  -374,  -232,    86,  -299,     3,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,  -766,
    -766,  -766,  -766,  -766,  -766,  -766,  -766,   608,  -196,  -387,
     -95,  -546,  -766,  -703,  -665,   163,  -766,  -456,  -766,  -599,
    -766,   -97,  -766,  -766,   116,  -766,  -766,  -766,   -76,  -766,
    -766,  -391,  -766,   -86,  -766,  -766,  -766,  -766,  -766,   687,
     817,  -766,  -766,  -766,  -766,  -766,  -199,  -441,  -766,   331,
    -766,  -766,  -766,    18,  -766,  -766,  -766,  1760,   209,   828,
    2050,  -766,  -766,    19,  -270,  -752,  -397,  -605,   297,  -634,
    -765,   -21,   169,  -766,  -600,  -766,  -239,   315,  -766,  -766,
    -766,    24,  -376,  1122,  -333,  -766,   649,   -27,   -23,   601,
    -551,  -222,    -6,     0,  -766,     1,    -2
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    64,    65,    66,   262,   396,   397,   271,
     272,   442,    68,    69,   215,    70,    71,   587,   720,    72,
      73,   273,    74,    75,    76,   467,    77,   216,   113,   114,
     208,   209,   210,   604,   195,   196,    79,   244,   278,   567,
     712,   434,   435,   253,   254,   246,   426,   436,   526,    80,
     212,   454,   277,   292,   229,   751,   230,   752,   632,   890,
     591,   588,   815,   390,   392,   603,   820,   265,   400,   624,
     740,   741,   235,   665,   666,   667,   784,   692,   693,   769,
     896,   897,   483,   672,   330,   521,    82,    83,   376,   581,
     580,   412,   887,   607,   734,   822,   826,    84,    85,   305,
     306,   497,    86,    87,    88,   618,   637,   502,   503,   504,
     684,    89,    90,    91,   299,    92,    93,   218,   219,    96,
     220,   385,   590,   601,   602,   485,   486,   487,   488,   489,
     787,   788,   490,   491,   492,   493,   776,   674,   198,   391,
     283,   437,   249,   119,   595,   569,   368,   225,   431,   432,
     708,   458,   401,   260,   409,   228,   275
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      99,   242,   242,   570,   259,   242,   226,   371,   115,   115,
     261,   466,   227,   257,   256,   335,   429,   317,   115,   620,
     194,   598,   484,   531,   100,   408,   211,   596,   626,    67,
     568,    67,   576,   288,   274,   579,   380,   536,   320,   383,
     248,   248,   778,   614,   248,   724,   211,   399,   281,   285,
     655,   636,   639,   494,   636,   115,   597,   629,   461,   226,
     685,   737,   463,   744,   843,   227,   321,   298,   773,   399,
     568,   747,   576,   775,   280,   284,   779,   -96,   753,   115,
     668,   623,   327,   328,   639,   369,   597,   221,   224,   375,
     374,   789,   785,   898,   -97,   670,   -98,   256,   909,  -321,
     840,   449,   247,   247,   366,   501,   247,   762,   386,   658,
     698,   374,   690,   597,   227,  -460,   245,   250,   407,   -94,
     251,   566,   801,   574,   717,   718,   574,  -101,  -100,   808,
     736,  -463,   411,   -67,   -95,  -462,   279,   369,   597,     3,
     447,   -94,   263,   745,  -101,   566,   662,   574,   473,   474,
     475,   476,   267,   494,   691,   -96,  -321,  -321,   384,   329,
     -88,   566,   367,   574,   -81,   527,  -100,   -98,   909,   -96,
     -97,   -90,   898,  -464,   671,   566,   892,   574,   685,   -99,
     -95,   749,   315,   316,   331,   859,   222,   223,   843,  -463,
     222,   223,   466,  -462,   222,   223,   685,   410,   223,   214,
     214,   214,   370,   566,   574,   429,   222,   223,   222,   223,
     619,    95,   669,    95,   778,   227,   -96,   -96,   226,   258,
     298,   227,   723,   223,   227,  -465,   465,   566,   922,   574,
    -528,  -464,   728,   -97,   -97,   -98,   -98,   242,   276,   242,
     242,   -86,   765,   494,   451,   427,   427,   773,   900,   -93,
     -92,   -88,   466,   438,   370,   274,   773,    95,   950,  -525,
     255,   907,   -90,   910,   814,   226,   668,   766,   639,   636,
     636,   227,   452,   -95,   -95,   332,   248,   -88,   248,   459,
     459,   794,   -88,  -465,   459,   -88,   523,   885,   -88,   -90,
     115,   532,   -89,   -90,  -528,   448,   -90,   746,   377,   -90,
    -467,   -91,   -87,  -529,   336,   414,   415,   733,  -466,   372,
    -526,   252,   457,   594,   395,   529,   830,   363,   223,   274,
      95,  -455,  -455,   -98,   255,   460,  -459,   582,   584,   258,
     727,   223,   378,   956,  -532,   337,   379,   115,   247,   924,
     247,   513,   -95,   327,   328,   223,   398,   498,    67,   242,
     499,   500,   430,   518,   433,   387,   686,   575,  -467,   499,
     500,   494,   438,   381,   382,   282,  -466,   836,   668,   270,
     668,   402,  -459,   242,   364,   365,  -525,   589,  -455,  -455,
    -455,   575,  -525,   227,  -459,   406,   438,   531,   411,   242,
     360,   361,   362,   959,   413,   608,  -532,   575,   514,   515,
     516,   517,   438,   242,  -390,   654,   758,   465,   625,   625,
     416,   575,   388,   389,   227,   227,   438,   525,   214,   214,
     420,    95,   525,   466,   646,   750,   424,  -526,   443,  -459,
    -459,   761,   270,  -526,   427,   427,   739,   736,   575,   425,
     428,    99,   886,   337,   668,   894,   875,   439,   441,   638,
     450,  -532,   790,  -532,  -532,   242,   223,  -528,   -66,   468,
     211,   456,   639,   575,   636,  -460,  -390,   465,   438,   115,
      67,   115,    95,   462,   464,  -277,   511,    95,    95,   651,
     662,   653,   473,   474,   475,   476,   675,   403,   675,   586,
     675,   -94,   417,   530,   668,   512,   668,   621,   495,   605,
     662,   606,   473,   474,   475,   476,   445,   914,   469,   610,
     622,   214,   214,   214,   214,   641,   519,   520,   648,   694,
     643,  -390,   -86,  -390,  -390,   661,   668,   758,   644,   702,
      95,   115,  -277,  -277,   678,    95,  -529,   -81,   673,   681,
    -461,   477,    95,  -268,   404,   405,   700,   707,   479,   418,
     419,   736,   421,   422,   423,   676,   944,   679,  -253,   706,
     705,   682,   696,   404,   446,   470,   471,   713,   711,   725,
     716,   711,   480,   707,   714,   699,   893,   714,   694,   694,
     599,   494,   721,  -278,   444,   597,   731,   705,   227,   711,
     270,   707,   748,   767,   760,   714,   729,  -461,  -461,    95,
    -268,  -268,   227,   781,   735,   738,   707,   738,  -254,    95,
      81,   802,    81,   116,   116,   738,   730,    95,   217,   217,
     217,   227,   211,   234,   217,   217,   882,   796,   217,   916,
     313,   932,   884,   301,   302,   707,   427,   373,   465,   809,
    -278,  -278,   817,   447,   819,   524,   770,   709,   825,   821,
     535,   829,    95,   459,   270,   532,    81,   217,   797,   799,
     289,    95,   831,  -101,   804,   806,   722,   759,   770,  -100,
     217,   838,   841,   -96,   566,   845,   574,   844,   846,   847,
     303,   304,   858,   857,   289,   848,   917,   918,   388,   389,
     566,   850,   525,   783,   -93,   473,   474,   475,   476,   852,
     -92,   854,   115,   861,   -88,   710,    95,   803,   754,   510,
     860,   863,   301,   302,   865,   867,   816,   217,   694,    81,
    -255,   609,   227,   872,   873,   535,   888,   889,   891,   617,
     905,   -98,   823,   -95,   477,   827,   337,  -256,   633,   635,
     478,   479,   282,   308,   310,   312,   314,   300,   625,   301,
     302,   350,   351,   505,   227,   301,   302,   427,   870,   303,
     304,   770,   -90,   912,   -87,   480,   913,   915,   481,   923,
     927,   635,   675,   675,   282,   675,   931,   675,   675,   214,
     933,   307,   301,   302,   675,   935,   675,   675,   357,   358,
     359,   360,   361,   362,   938,   223,   303,   304,   337,   941,
      95,   949,   303,   304,  -528,   677,  -529,   680,   962,   472,
      95,   473,   474,   475,   476,   828,   232,   120,   683,   647,
      81,   214,   227,   715,   115,   948,   764,   951,   227,   303,
     304,   738,   810,   947,   687,   197,   695,   217,   217,   876,
     906,   472,   774,   473,   474,   475,   476,   393,     0,     0,
     477,   358,   359,   360,   361,   362,   478,   479,     0,   440,
     217,   115,   217,   217,     0,     0,   217,   217,     0,     0,
       0,    81,     0,   925,   453,     0,    81,    81,   455,    95,
      95,   480,   477,     0,   481,     0,     0,     0,   478,   479,
       0,     0,     0,    95,     0,   289,     0,   675,   675,   675,
     675,    95,   242,     0,   675,   675,   675,   482,   675,   675,
     575,     0,     0,   480,     0,   438,   481,   608,   738,     0,
     732,   707,   309,   301,   302,     0,    95,    95,   214,    81,
     217,   217,   217,   217,    81,   217,   217,     0,     0,   217,
       0,    81,   289,     0,   217,    95,     0,   337,   755,     0,
     675,   757,     0,   675,   675,   675,   675,   635,   282,    95,
      95,    95,   350,   351,   675,     0,   311,   301,   302,     0,
     303,   304,   217,   777,     0,   763,   780,     0,     0,     0,
     217,   217,     0,     0,   495,   301,   302,     0,   786,     0,
       0,   771,   772,   507,   301,   302,   217,     0,    81,   217,
     358,   359,   360,   361,   362,   782,     0,     0,    81,     0,
     793,     0,   217,   791,   303,   304,    81,   508,   301,   302,
     509,   301,   302,    95,    95,   895,   217,   473,   474,   475,
     476,   640,   303,   304,    95,   642,     0,     0,   811,   812,
     645,   303,   304,   662,     0,   473,   474,   475,   476,     0,
     650,    81,     0,     0,     0,   652,     0,   824,     0,     0,
      81,     0,     0,   832,     0,   303,   304,     0,   303,   304,
     837,   833,   834,   835,   289,     0,   289,     0,   217,   322,
     323,   324,   325,   326,   663,    95,     0,     0,     0,   849,
     851,    95,   853,    95,   855,   856,     0,     0,     0,    95,
       0,   862,     0,   864,   866,    81,   868,     0,   472,     0,
     473,   474,   475,   476,   496,     0,   783,     0,   473,   474,
     475,   476,   506,     0,    98,   506,    98,   506,   697,   506,
       0,   506,    98,    98,    98,   874,   289,     0,    98,    98,
       0,     0,    98,     0,     0,   899,   883,   901,     0,   477,
       0,   902,   282,     0,     0,   478,   479,   477,     0,     0,
     908,     0,   911,   478,   479,     0,     0,     0,     0,     0,
      98,    98,     0,     0,     0,     0,     0,     0,     0,     0,
     480,     0,     0,   481,    98,     0,     0,     0,   480,     0,
       0,   481,   337,     0,     0,     0,     0,     0,   217,    81,
     726,     0,     0,   919,     0,   920,   600,   350,   351,    81,
       0,   921,     0,     0,   926,   928,   929,   930,     0,     0,
       0,   934,   936,   937,   952,   939,   940,     0,     0,     0,
     955,    98,   957,    98,     0,   958,     0,     0,     0,     0,
     217,     0,   355,   356,   357,   358,   359,   360,   361,   362,
     662,     0,   473,   474,   475,   476,     0,     0,   662,   966,
     473,   474,   475,   476,     0,     0,     0,   960,   768,     0,
     961,   963,   964,   965,     0,     0,     0,     0,    81,    81,
       0,   967,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   663,    81,     0,     0,     0,     0,   664,     0,   663,
      81,     0,     0,     0,     0,   842,     0,   289,   217,     0,
       0,   217,   217,     0,     0,     0,     0,   217,   217,     0,
       0,     0,     0,     0,     0,    81,    81,     0,   818,     0,
       0,     0,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,     0,     0,   217,     0,     0,
       0,    98,    98,     0,     0,     0,     0,     0,    81,    81,
      81,     0,     0,     0,     0,   839,     0,     0,     0,     0,
       0,     0,     0,     0,    98,     0,    98,    98,     0,     0,
      98,    98,     0,     0,     0,    98,     0,     0,     0,     0,
      98,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,    81,     0,     0,     0,     0,     0,   879,
       0,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,    98,    98,    98,    98,    98,    98,
      98,     0,     0,    98,     0,    98,     0,     0,    98,     0,
       0,     0,     0,     0,     0,     0,   904,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,     0,    98,     0,     0,     0,
      81,     0,    81,     0,    98,    98,     0,     0,    81,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   346,   347,
      98,     0,    98,    98,   350,   351,     0,     0,     0,     0,
       0,     0,    98,     0,     0,   217,    98,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,    98,   243,   243,     0,     0,
     243,     0,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,     0,     0,   264,   266,     0,     0,     0,
     243,   243,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   318,   319,     0,     0,     0,     0,     0,    98,
       0,     0,     0,     0,     0,     0,  -552,     4,     0,     5,
       6,     7,     8,     9,     0,     0,     0,    10,    11,     0,
       0,     0,    12,     0,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,    20,    21,    22,    23,
      24,    25,    26,     0,     0,    27,     0,     0,     0,     0,
       0,    28,    29,    30,    31,    32,     0,    33,    34,    35,
      36,    37,    38,     0,    39,    40,    41,     0,     0,    42,
       0,     0,    43,    44,     0,    45,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,    98,     0,    47,     0,     0,    48,    49,
       0,    50,    51,    98,    52,     0,    53,    54,    55,    56,
      57,    58,    59,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,    61,    62,    63,     0,     0,
       0,     0,    94,     0,    94,   117,   117,   117,     0,     0,
       0,     0,     0,     0,     0,   236,     0,     0,  -552,  -552,
       0,     0,     0,     0,     0,     0,     0,     0,   243,   243,
     243,   318,    98,    98,     0,     0,     0,     0,     0,     0,
       0,     0,   243,     0,   243,   243,    98,     0,    94,     0,
       0,     0,   290,     0,    98,     0,     0,     0,     0,     0,
       0,     0,    98,     0,     0,    98,    98,     0,     0,     0,
       0,    98,    98,     0,     0,     0,   290,     0,     0,    98,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    98,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    94,    98,    98,    98,     0,     0,     0,     0,     0,
       0,   243,     0,     0,     0,     0,   534,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   243,     0,     0,     0,     0,     0,
       0,     0,   583,   585,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98,    98,   243,     0,
       0,     0,     0,     0,     0,     0,     0,    98,     0,     0,
       0,     0,   611,     0,   243,     0,   583,   585,     0,     0,
       0,   243,     0,     0,     0,     0,     0,     0,   243,     0,
       0,     0,    94,     0,   243,   243,     0,     0,   243,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   649,    98,     0,
       0,     0,     0,     0,    98,     0,    98,   243,     0,     0,
     243,     0,    98,     0,    78,     0,    78,     0,     0,     0,
     243,     0,     0,    94,     0,     0,     0,   233,    94,    94,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
       0,     0,     0,     0,     0,     0,     0,   290,     0,     0,
       0,     0,    97,     0,    97,   118,   118,     0,     0,     0,
      78,   688,   689,     0,     0,   237,     0,     0,     0,     0,
    -552,     0,   243,     0,     0,     0,     0,     0,  -552,  -552,
    -552,    94,     0,  -552,  -552,  -552,    94,  -552,     0,     0,
       0,     0,     0,    94,   290,     0,  -552,  -552,    97,     0,
       0,     0,   291,     0,     0,     0,     0,  -552,  -552,     0,
    -552,  -552,  -552,  -552,  -552,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,   291,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,     0,     0,     0,     0,     0,   243,     0,  -552,     0,
      94,    97,     0,     0,     0,     0,     0,     0,    94,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   243,     0,     0,   243,     0,     0,
       0,     0,     0,   243,   243,     0,     0,     0,     0,     0,
       0,     0,     0,    94,     0,     0,     0,     0,     0,     0,
       0,   243,    94,  -552,  -552,     0,  -552,     0,     0,   255,
    -552,     0,  -552,  -552,    78,     0,   290,     0,   290,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   243,     0,     0,     0,
     611,   795,     0,   798,   800,     0,     0,    94,     0,   805,
     807,     0,    97,     0,     0,     0,     0,     0,     0,   813,
       0,     0,     0,     0,     0,    78,     0,     0,     0,     0,
      78,    78,     0,     0,     0,     0,     0,     0,   290,     0,
       0,     0,   798,   800,     0,   805,   807,     0,     0,   243,
       0,     0,     0,     0,     0,     0,   243,     0,     0,     0,
       0,     0,     0,    97,     0,     0,     0,     0,    97,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,   291,    78,     0,
       0,     0,   243,     0,     0,    78,   869,     0,   533,     0,
       0,    94,     0,   871,     0,     0,     0,     0,     0,     0,
       0,    94,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,     0,     0,     0,     0,    97,     0,     0,     0,
     871,     0,     0,    97,   291,     0,     0,     0,   243,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,    94,     0,     0,     0,     0,     0,     0,     0,     0,
      97,     0,     0,     0,    94,     0,     0,     0,     0,     0,
      97,     0,    94,     0,     0,    78,     0,     0,    97,   290,
       0,     0,     0,     0,    78,     0,     0,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    94,    94,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,     0,    97,   350,   351,    94,     0,     0,     0,
       0,     0,    97,     0,     0,     0,     0,     0,     0,    78,
      94,    94,    94,     0,     0,     0,   291,     0,   291,     0,
       0,     0,     0,     0,     0,   352,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    94,    94,     0,     0,   291,     0,
       0,   880,     0,     0,     0,    94,     0,     0,     0,     0,
       0,     0,   701,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,   117,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,     0,     0,   350,   351,    94,     0,     0,     0,
       0,    97,    94,     0,    94,     0,     0,     0,     0,     0,
      94,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   352,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,     0,     0,     0,
       0,     0,    78,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -230,    78,     0,     0,     0,
       0,     0,     0,     0,    78,     0,     0,     0,     0,     0,
       0,     0,   533,     0,     0,     0,     0,     0,     0,     0,
      97,    97,     0,     0,     0,     0,     0,     0,     0,    78,
      78,     0,     0,     0,    97,     0,     0,     0,     0,     0,
       0,     0,    97,     0,     0,     0,     0,     0,    78,   291,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    78,    78,     0,     0,    97,    97,     0,
       0,     0,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    97,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      97,    97,    97,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,     0,     0,   350,   351,
       0,     0,     0,     0,     0,     0,    78,    78,     0,     0,
       0,     0,     0,   878,     0,     0,     0,    78,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   352,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,     0,     0,     0,    97,    97,     0,     0,     0,     0,
       0,   881,  -277,     0,     0,    97,     0,     0,     0,     0,
    -277,  -277,  -277,     0,     0,  -277,  -277,  -277,    78,  -277,
       0,     0,     0,     0,    78,     0,    78,     0,     0,  -277,
    -277,  -277,    78,     0,     0,     0,     0,     0,   118,  -277,
    -277,     0,  -277,  -277,  -277,  -277,  -277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    97,     0,     0,     0,
       0,     0,    97,     0,    97,     0,     0,     0,     0,     0,
      97,     0,     0,  -277,  -277,  -277,  -277,  -277,  -277,  -277,
    -277,  -277,  -277,  -277,  -277,  -277,     0,     0,  -277,  -277,
    -277,     0,   743,  -277,     0,     0,     0,     0,     0,  -277,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -277,     0,     0,     0,     0,     0,     0,     0,   -99,  -277,
    -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,
    -277,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -277,  -277,  -277,  -277,
    -389,     0,  -277,  -277,  -277,  -277,     0,     0,  -389,  -389,
    -389,     0,     0,  -389,  -389,  -389,     0,  -389,     0,     0,
       0,     0,     0,   701,     0,     0,  -389,  -389,  -389,     0,
       0,     0,     0,     0,     0,     0,     0,  -389,  -389,     0,
    -389,  -389,  -389,  -389,  -389,     0,     0,     0,     0,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,     0,     0,   350,   351,     0,     0,     0,
       0,  -389,  -389,  -389,  -389,  -389,  -389,  -389,  -389,  -389,
    -389,  -389,  -389,  -389,     0,     0,  -389,  -389,  -389,     0,
       0,  -389,     0,     0,     0,     0,   352,  -389,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -389,     0,  -389,
    -389,  -389,  -389,  -389,  -389,  -389,  -389,  -389,  -389,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -389,  -389,  -389,  -389,  -389,  -269,   255,
    -389,  -389,  -389,  -389,     0,     0,  -269,  -269,  -269,     0,
       0,  -269,  -269,  -269,     0,  -269,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -269,  -269,  -269,     0,     0,
       0,     0,     0,     0,     0,  -269,  -269,     0,  -269,  -269,
    -269,  -269,  -269,     0,     0,     0,     0,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,     0,     0,   350,   351,     0,     0,     0,     0,  -269,
    -269,  -269,  -269,  -269,  -269,  -269,  -269,  -269,  -269,  -269,
    -269,  -269,     0,     0,  -269,  -269,  -269,     0,     0,  -269,
       0,     0,     0,     0,   352,  -269,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,  -269,     0,     0,     0,
       0,     0,     0,     0,     0,  -269,  -269,  -269,  -269,  -269,
    -269,  -269,  -269,  -269,  -269,  -269,  -269,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -269,  -269,  -269,  -269,  -552,     0,  -269,  -269,
    -269,  -269,     0,     0,  -552,  -552,  -552,     0,     0,  -552,
    -552,  -552,     0,  -552,     0,     0,     0,     0,     0,     0,
       0,     0,  -552,  -552,  -552,     0,     0,     0,     0,     0,
       0,     0,     0,  -552,  -552,     0,  -552,  -552,  -552,  -552,
    -552,     0,     0,     0,     0,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,  -553,  -553,     0,
       0,   350,   351,     0,     0,     0,     0,  -552,  -552,  -552,
    -552,  -552,  -552,  -552,  -552,  -552,  -552,  -552,  -552,  -552,
       0,     0,  -552,  -552,  -552,     0,     0,  -552,     0,     0,
       0,     0,     0,  -552,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -552,     0,  -552,  -552,  -552,  -552,  -552,
    -552,  -552,  -552,  -552,  -552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -552,
    -552,  -552,  -552,  -552,  -284,   255,  -552,  -552,  -552,  -552,
       0,     0,  -284,  -284,  -284,     0,     0,  -284,  -284,  -284,
       0,  -284,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -284,  -284,     0,     0,     0,     0,     0,     0,     0,
       0,  -284,  -284,     0,  -284,  -284,  -284,  -284,  -284,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -284,  -284,  -284,  -284,  -284,
    -284,  -284,  -284,  -284,  -284,  -284,  -284,  -284,     0,     0,
    -284,  -284,  -284,     0,     0,  -284,  -532,     0,     0,     0,
       0,  -284,     0,     0,  -532,  -532,  -532,     0,     0,     0,
    -532,  -532,     0,  -532,     0,     0,     0,     0,     0,     0,
       0,  -284,  -532,  -284,  -284,  -284,  -284,  -284,  -284,  -284,
    -284,  -284,  -284,  -532,  -532,     0,  -532,  -532,  -532,  -532,
    -532,     0,     0,     0,     0,     0,     0,     0,  -284,  -284,
    -284,  -284,     0,   252,  -284,  -284,  -284,  -284,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,
       0,     0,  -532,  -532,  -532,     0,   703,     0,  -277,     0,
       0,     0,     0,     0,     0,     0,  -277,  -277,  -277,     0,
       0,     0,  -277,  -277,     0,  -277,     0,     0,     0,     0,
       0,     0,   -97,  -532,     0,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -277,  -277,     0,  -277,  -277,
    -277,  -277,  -277,     0,     0,     0,     0,     0,     0,  -532,
    -532,  -532,  -532,   -89,     0,     0,  -532,     0,  -532,  -532,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -277,
    -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,  -277,
    -277,  -277,     0,     0,  -277,  -277,  -277,     0,   704,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -99,  -277,     0,  -277,  -277,  -277,
    -277,  -277,  -277,  -277,  -277,  -277,  -277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -277,  -277,  -277,   -91,     0,     0,  -277,     0,
    -277,  -277,   268,     0,     5,     6,     7,     8,     9,  -552,
    -552,  -552,    10,    11,     0,     0,  -552,    12,     0,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,    20,    21,    22,    23,    24,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,    28,     0,    30,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
      45,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      47,     0,     0,    48,    49,     0,    50,    51,     0,    52,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      61,    62,    63,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   268,     0,     5,     6,
       7,     8,     9,  -552,  -552,  -552,    10,    11,     0,  -552,
    -552,    12,     0,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,    48,    49,     0,
      50,    51,     0,    52,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,    63,     0,     0,     0,
       0,     0,     0,     0,     0,   268,     0,     5,     6,     7,
       8,     9,     0,     0,  -552,    10,    11,  -552,  -552,  -552,
      12,  -552,    13,    14,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,    20,    21,    22,    23,    24,    25,
      26,     0,     0,    27,     0,     0,     0,     0,     0,    28,
       0,    30,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,     0,     0,    42,     0,     0,
      43,    44,     0,    45,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,     0,     0,    48,    49,     0,    50,
      51,     0,    52,     0,    53,    54,    55,    56,    57,    58,
      59,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    61,    62,    63,     0,     0,     0,     0,
       0,     0,     0,     0,   268,     0,     5,     6,     7,     8,
       9,     0,     0,  -552,    10,    11,  -552,  -552,  -552,    12,
       0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,    20,    21,    22,    23,    24,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,    28,     0,
      30,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    47,     0,     0,    48,    49,     0,    50,    51,
       0,    52,     0,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    61,    62,    63,     0,     0,     0,     0,     0,
       0,     0,     4,     0,     5,     6,     7,     8,     9,     0,
       0,     0,    10,    11,     0,  -552,  -552,    12,     0,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,    20,    21,    22,    23,    24,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,    28,    29,    30,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
      45,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      47,     0,     0,    48,    49,     0,    50,    51,     0,    52,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      61,    62,    63,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -552,     0,     0,     0,     0,
       0,     0,     0,  -552,  -552,   268,     0,     5,     6,     7,
       8,     9,     0,  -552,  -552,    10,    11,     0,     0,     0,
      12,     0,    13,    14,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,    20,    21,    22,    23,    24,    25,
      26,     0,     0,    27,     0,     0,     0,     0,     0,    28,
       0,    30,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,     0,     0,    42,     0,     0,
      43,    44,     0,    45,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,     0,     0,    48,    49,     0,    50,
      51,     0,    52,     0,    53,    54,    55,    56,    57,    58,
      59,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    61,    62,    63,     0,     0,     0,     0,
       0,     0,     0,   268,     0,     5,     6,     7,     8,     9,
       0,     0,     0,    10,    11,     0,  -552,  -552,    12,     0,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,    20,    21,    22,    23,    24,    25,    26,     0,
       0,    27,     0,     0,     0,     0,     0,    28,     0,    30,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,     0,     0,    42,     0,     0,    43,    44,
       0,    45,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,     0,     0,   269,    49,     0,    50,    51,     0,
      52,     0,    53,    54,    55,    56,    57,    58,    59,     0,
       0,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    61,    62,    63,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -552,     0,  -552,  -552,   268,     0,     5,     6,
       7,     8,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,     0,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,    48,    49,     0,
      50,    51,     0,    52,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,    63,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -552,     0,  -552,  -552,   268,
       0,     5,     6,     7,     8,     9,     0,     0,     0,    10,
      11,     0,     0,     0,    12,     0,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,    20,    21,
      22,    23,    24,    25,    26,     0,     0,    27,     0,     0,
       0,     0,     0,    28,     0,    30,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,     0,
       0,    42,     0,     0,    43,    44,     0,    45,    46,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    47,     0,     0,
      48,    49,     0,    50,    51,     0,    52,     0,    53,    54,
      55,    56,    57,    58,    59,     0,     0,    60,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,    62,    63,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -552,   268,     0,     5,     6,     7,     8,     9,
    -552,  -552,  -552,    10,    11,     0,     0,     0,    12,     0,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,    20,    21,    22,    23,    24,    25,    26,     0,
       0,    27,     0,     0,     0,     0,     0,    28,     0,    30,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,     0,     0,    42,     0,     0,    43,    44,
       0,    45,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,     0,     0,    48,    49,     0,    50,    51,     0,
      52,     0,    53,    54,    55,    56,    57,    58,    59,     0,
       0,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    61,    62,    63,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     6,     7,     0,     9,     0,     0,
       0,    10,    11,     0,  -552,  -552,    12,     0,    13,    14,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
      20,    21,    22,    23,    24,    25,    26,     0,     0,   106,
       0,     0,     0,     0,     0,     0,     0,     0,    31,    32,
       0,    33,    34,    35,    36,    37,    38,   238,    39,    40,
      41,     0,     0,    42,     0,     0,    43,    44,     0,    45,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
       0,     0,   111,    49,     0,    50,    51,     0,   239,   240,
      53,    54,    55,    56,    57,    58,    59,     0,     0,    60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
       6,     7,     0,     9,     0,     0,     0,    10,    11,    61,
     241,    63,    12,     0,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,    20,    21,    22,    23,
      24,    25,    26,   223,     0,    27,     0,     0,     0,     0,
       0,     0,     0,     0,    31,    32,     0,    33,    34,    35,
      36,    37,    38,     0,    39,    40,    41,     0,     0,    42,
       0,     0,    43,    44,     0,    45,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,     0,     0,   111,    49,
       0,    50,    51,     0,     0,     0,    53,    54,    55,    56,
      57,    58,    59,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,    62,    63,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     6,     7,
       0,     9,     0,     0,     0,    10,    11,     0,   222,   223,
      12,     0,    13,    14,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,    20,    21,    22,    23,    24,    25,
      26,     0,     0,    27,     0,     0,     0,     0,     0,     0,
       0,     0,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,     0,     0,    42,     0,     0,
      43,    44,     0,    45,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   213,     0,     0,   111,    49,     0,    50,
      51,     0,     0,     0,    53,    54,    55,    56,    57,    58,
      59,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     6,     7,     8,     9,     0,     0,
       0,    10,    11,    61,    62,    63,    12,     0,    13,    14,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
      20,    21,    22,    23,    24,    25,    26,   223,     0,    27,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
       0,    33,    34,    35,    36,    37,    38,     0,    39,    40,
      41,     0,     0,    42,     0,     0,    43,    44,     0,    45,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    47,
       0,     0,    48,    49,     0,    50,    51,     0,    52,     0,
      53,    54,    55,    56,    57,    58,    59,     0,     0,    60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    61,
      62,    63,     0,     0,     0,     0,     0,     0,     5,     6,
       7,     8,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,   413,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,    48,    49,     0,
      50,    51,     0,    52,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,    63,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   413,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,     0,     0,     0,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
     155,   156,   157,   158,   159,   160,   161,   162,    35,    36,
     163,    38,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,     0,     0,   175,
     176,   177,   178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,     0,   190,   191,     0,     0,     0,
       0,     0,  -525,  -525,  -525,     0,  -525,     0,     0,     0,
    -525,  -525,     0,   192,   193,  -525,     0,  -525,  -525,  -525,
    -525,  -525,  -525,  -525,     0,  -525,     0,     0,     0,  -525,
    -525,  -525,  -525,  -525,  -525,  -525,     0,     0,  -525,     0,
       0,     0,     0,     0,     0,     0,     0,  -525,  -525,     0,
    -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,  -525,
       0,     0,  -525,     0,     0,  -525,  -525,     0,  -525,  -525,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -525,     0,
       0,  -525,  -525,     0,  -525,  -525,     0,  -525,  -525,  -525,
    -525,  -525,  -525,  -525,  -525,  -525,     0,     0,  -525,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -525,  -525,
    -525,     0,     0,     0,     0,     0,  -526,  -526,  -526,     0,
    -526,     0,  -525,     0,  -526,  -526,     0,     0,  -525,  -526,
       0,  -526,  -526,  -526,  -526,  -526,  -526,  -526,     0,  -526,
       0,     0,     0,  -526,  -526,  -526,  -526,  -526,  -526,  -526,
       0,     0,  -526,     0,     0,     0,     0,     0,     0,     0,
       0,  -526,  -526,     0,  -526,  -526,  -526,  -526,  -526,  -526,
    -526,  -526,  -526,  -526,     0,     0,  -526,     0,     0,  -526,
    -526,     0,  -526,  -526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -526,     0,     0,  -526,  -526,     0,  -526,  -526,
       0,  -526,  -526,  -526,  -526,  -526,  -526,  -526,  -526,  -526,
       0,     0,  -526,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -526,  -526,  -526,     0,     0,     0,     0,     0,
    -528,  -528,  -528,     0,  -528,     0,  -526,     0,  -528,  -528,
       0,     0,  -526,  -528,     0,  -528,  -528,  -528,  -528,  -528,
    -528,  -528,     0,     0,     0,     0,     0,  -528,  -528,  -528,
    -528,  -528,  -528,  -528,     0,     0,  -528,     0,     0,     0,
       0,     0,     0,     0,     0,  -528,  -528,     0,  -528,  -528,
    -528,  -528,  -528,  -528,  -528,  -528,  -528,  -528,     0,     0,
    -528,     0,     0,  -528,  -528,     0,  -528,  -528,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -528,   742,     0,  -528,
    -528,     0,  -528,  -528,     0,  -528,  -528,  -528,  -528,  -528,
    -528,  -528,  -528,  -528,     0,     0,  -528,     0,     0,     0,
       0,     0,     0,   -97,     0,     0,     0,     0,     0,     0,
       0,  -530,  -530,  -530,     0,  -530,  -528,  -528,  -528,  -530,
    -530,     0,     0,     0,  -530,     0,  -530,  -530,  -530,  -530,
    -530,  -530,  -530,     0,     0,     0,  -528,     0,  -530,  -530,
    -530,  -530,  -530,  -530,  -530,     0,     0,  -530,     0,     0,
       0,     0,     0,     0,     0,     0,  -530,  -530,     0,  -530,
    -530,  -530,  -530,  -530,  -530,  -530,  -530,  -530,  -530,     0,
       0,  -530,     0,     0,  -530,  -530,     0,  -530,  -530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -530,     0,     0,
    -530,  -530,     0,  -530,  -530,     0,  -530,  -530,  -530,  -530,
    -530,  -530,  -530,  -530,  -530,     0,     0,  -530,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -531,  -531,  -531,     0,  -531,  -530,  -530,  -530,
    -531,  -531,     0,     0,     0,  -531,     0,  -531,  -531,  -531,
    -531,  -531,  -531,  -531,     0,     0,     0,  -530,     0,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,     0,     0,  -531,     0,
       0,     0,     0,     0,     0,     0,     0,  -531,  -531,     0,
    -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,  -531,
       0,     0,  -531,     0,     0,  -531,  -531,     0,  -531,  -531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -531,     0,
       0,  -531,  -531,     0,  -531,  -531,     0,  -531,  -531,  -531,
    -531,  -531,  -531,  -531,  -531,  -531,     0,     0,  -531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -531,  -531,
    -531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -531,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,     0,   145,   146,   147,   199,
     200,   201,   202,   152,   153,   154,     0,     0,     0,     0,
       0,   155,   156,   157,   203,   204,   160,   205,   162,   293,
     294,   206,   295,     0,     0,     0,     0,     0,     0,   296,
       0,     0,     0,     0,     0,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,     0,     0,
     175,   176,   177,   178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   179,     0,     0,     0,     0,     0,
       0,   297,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,     0,   190,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,     0,   145,   146,   147,   199,   200,   201,   202,   152,
     153,   154,     0,     0,     0,     0,     0,   155,   156,   157,
     203,   204,   160,   205,   162,   293,   294,   206,   295,     0,
       0,     0,     0,     0,     0,   296,     0,     0,     0,     0,
       0,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,     0,     0,   175,   176,   177,   178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     179,     0,     0,     0,     0,     0,     0,   394,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,     0,   190,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,     0,   145,   146,
     147,   199,   200,   201,   202,   152,   153,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   203,   204,   160,   205,
     162,     0,     0,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
       0,     0,   175,   176,   177,   178,     0,     0,   337,  -553,
    -553,  -553,  -553,   342,   343,     0,   179,  -553,  -553,   207,
       0,     0,     0,   350,   351,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,     0,   190,   191,
       0,     0,     0,     0,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   192,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,     0,     0,     0,   145,   146,   147,   199,   200,   201,
     202,   152,   153,   154,     0,     0,     0,     0,     0,   155,
     156,   157,   203,   204,   160,   205,   162,     0,     0,   206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,     0,     0,   175,   176,
     177,   178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   179,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,     0,   190,   191,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,   192,    13,    14,    15,   101,   102,    18,    19,
       0,     0,     0,     0,     0,   103,   104,   105,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   286,     0,     0,   111,    49,     0,
      50,    51,     0,     0,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     6,     7,
       0,     9,     0,     0,   112,    10,    11,     0,     0,     0,
      12,     0,    13,    14,    15,   101,   102,    18,    19,     0,
       0,     0,   287,     0,   103,   104,   105,    23,    24,    25,
      26,     0,     0,   106,     0,     0,     0,     0,     0,     0,
       0,     0,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,     0,     0,    42,     0,     0,
      43,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   286,     0,     0,   111,    49,     0,    50,
      51,     0,     0,     0,    53,    54,    55,    56,    57,    58,
      59,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,   112,    10,    11,     0,     0,     0,    12,
       0,    13,    14,    15,   101,   102,    18,    19,     0,     0,
       0,   528,     0,   103,   104,   105,    23,    24,    25,    26,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
     238,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,     0,     0,   111,    49,     0,    50,    51,
       0,   634,   240,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,   498,     0,     0,   499,   500,     0,     0,
       0,     0,     5,     6,     7,     8,     9,     0,     0,     0,
      10,    11,    61,   241,    63,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,    28,    29,    30,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
       0,     0,    42,     0,     0,    43,    44,     0,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    47,     0,
       0,    48,    49,     0,    50,    51,     0,    52,     0,    53,
      54,    55,    56,    57,    58,    59,     0,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,    61,    62,
      63,    12,     0,    13,    14,    15,   101,   102,    18,    19,
       0,     0,     0,     0,     0,   103,   104,   105,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,   238,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,     0,     0,   111,    49,     0,
      50,    51,     0,   634,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,   498,     0,     0,   499,   500,
       0,     0,     0,     0,     5,     6,     7,     8,     9,     0,
       0,     0,    10,    11,    61,   241,    63,    12,     0,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,    20,    21,    22,    23,    24,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,    28,     0,    30,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
      45,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      47,     0,     0,    48,    49,     0,    50,    51,     0,    52,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
      61,    62,    63,    12,     0,    13,    14,    15,   101,   102,
      18,    19,     0,     0,     0,     0,     0,   103,   104,   105,
      23,    24,    25,    26,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,     0,     0,
      42,     0,     0,    43,    44,     0,    45,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,     0,     0,   111,
      49,     0,    50,    51,     0,   756,     0,    53,    54,    55,
      56,    57,    58,    59,     0,     0,    60,   498,     0,     0,
     499,   500,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,    61,   241,    63,    12,
       0,    13,    14,    15,   101,   102,    18,    19,     0,     0,
       0,     0,     0,   103,   104,   105,    23,    24,    25,    26,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,     0,     0,   111,    49,     0,    50,    51,
       0,   792,     0,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,   498,     0,     0,   499,   500,     0,     0,
       0,     0,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,    61,   241,    63,    12,     0,    13,    14,    15,
     101,   102,    18,    19,     0,     0,     0,     0,     0,   103,
     104,   105,    23,    24,    25,    26,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
       0,     0,    42,     0,     0,    43,    44,     0,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,     0,
       0,   111,    49,     0,    50,    51,     0,   634,     0,    53,
      54,    55,    56,    57,    58,    59,     0,     0,    60,   498,
       0,     0,   499,   500,     0,     0,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,    61,   241,
      63,    12,     0,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,   238,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,     0,     0,   111,    49,     0,
      50,    51,     0,   239,   240,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,    61,   241,    63,    12,     0,    13,
      14,    15,   101,   102,    18,    19,     0,     0,     0,     0,
       0,   103,   104,   105,    23,    24,    25,    26,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,     0,    33,    34,    35,    36,    37,    38,   238,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
      45,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,     0,     0,   111,    49,     0,    50,    51,     0,   239,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
      61,   241,    63,    12,     0,    13,    14,    15,   101,   102,
      18,    19,     0,     0,     0,     0,     0,   103,   104,   105,
      23,    24,    25,    26,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,   238,    39,    40,    41,     0,     0,
      42,     0,     0,    43,    44,     0,    45,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,     0,     0,   111,
      49,     0,    50,    51,     0,     0,   240,    53,    54,    55,
      56,    57,    58,    59,     0,     0,    60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,    61,   241,    63,    12,
       0,    13,    14,    15,   101,   102,    18,    19,     0,     0,
       0,     0,     0,   103,   104,   105,    23,    24,    25,    26,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
     238,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,     0,     0,   111,    49,     0,    50,    51,
       0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,    61,   241,    63,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
       0,     0,    42,     0,     0,    43,    44,     0,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,     0,
       0,   111,    49,     0,    50,    51,     0,   522,     0,    53,
      54,    55,    56,    57,    58,    59,     0,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,    61,   241,
      63,    12,     0,    13,    14,    15,   101,   102,    18,    19,
       0,     0,     0,     0,     0,   103,   104,   105,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,     0,     0,   111,    49,     0,
      50,    51,     0,   239,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,    61,   241,    63,    12,     0,    13,
      14,    15,   101,   102,    18,    19,     0,     0,     0,     0,
       0,   103,   104,   105,    23,    24,    25,    26,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
      45,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,     0,     0,   111,    49,     0,    50,    51,     0,   522,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
      61,   241,    63,    12,     0,    13,    14,    15,    16,    17,
      18,    19,     0,     0,     0,     0,     0,    20,    21,    22,
      23,    24,    25,    26,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,     0,     0,
      42,     0,     0,    43,    44,     0,    45,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,     0,     0,   111,
      49,     0,    50,    51,     0,     0,     0,    53,    54,    55,
      56,    57,    58,    59,     0,     0,    60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,    61,    62,    63,    12,
       0,    13,    14,    15,   101,   102,    18,    19,     0,     0,
       0,     0,     0,   103,   104,   105,    23,    24,    25,    26,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,     0,     0,   111,    49,     0,    50,    51,
       0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,    61,   241,    63,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
       0,     0,    42,     0,     0,    43,    44,     0,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,     0,
       0,   111,    49,     0,    50,    51,     0,     0,     0,    53,
      54,    55,    56,    57,    58,    59,     0,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,    61,   241,
      63,    12,     0,    13,    14,    15,   101,   102,    18,    19,
       0,     0,     0,     0,     0,   103,   104,   105,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,   107,    34,    35,    36,
     108,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   109,     0,     0,   110,     0,     0,   111,    49,     0,
      50,    51,     0,     0,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
       0,     0,     0,    12,   112,    13,    14,    15,   101,   102,
      18,    19,     0,     0,     0,     0,     0,   103,   104,   105,
      23,    24,    25,    26,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,     0,     0,
      42,     0,     0,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   231,     0,     0,    48,
      49,     0,    50,    51,     0,    52,     0,    53,    54,    55,
      56,    57,    58,    59,     0,     0,    60,     0,     0,     0,
       0,     0,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,     0,     0,     0,    12,   112,    13,    14,    15,
     101,   102,    18,    19,     0,     0,     0,     0,     0,   103,
     104,   105,    23,    24,    25,    26,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
       0,     0,    42,     0,     0,    43,    44,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   286,     0,
       0,   333,    49,     0,    50,    51,     0,   334,     0,    53,
      54,    55,    56,    57,    58,    59,     0,     0,    60,     0,
       0,     0,     0,     0,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,     0,     0,     0,    12,   112,    13,
      14,    15,   101,   102,    18,    19,     0,     0,     0,     0,
       0,   103,   104,   105,    23,    24,    25,    26,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,     0,   107,    34,    35,    36,   108,    38,     0,    39,
      40,    41,     0,     0,    42,     0,     0,    43,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     110,     0,     0,   111,    49,     0,    50,    51,     0,     0,
       0,    53,    54,    55,    56,    57,    58,    59,     0,     0,
      60,     0,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,     0,     0,     0,    12,
     112,    13,    14,    15,   101,   102,    18,    19,     0,     0,
       0,     0,     0,   103,   104,   105,    23,    24,    25,    26,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,     0,     0,    42,     0,     0,    43,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   286,     0,     0,   333,    49,     0,    50,    51,
       0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
       0,     0,    60,     0,     0,     0,     0,     0,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,   112,    13,    14,    15,   101,   102,    18,    19,
       0,     0,     0,     0,     0,   103,   104,   105,    23,    24,
      25,    26,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,     0,     0,    42,     0,
       0,    43,    44,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   877,     0,     0,   111,    49,     0,
      50,    51,     0,     0,     0,    53,    54,    55,    56,    57,
      58,    59,     0,     0,    60,     0,     0,     0,     0,     0,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
       0,     0,     0,    12,   112,    13,    14,    15,   101,   102,
      18,    19,     0,     0,     0,     0,     0,   103,   104,   105,
      23,    24,    25,    26,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,     0,     0,
      42,     0,     0,    43,    44,     0,   337,   338,   339,   340,
     341,   342,   343,     0,     0,   346,   347,     0,     0,     0,
       0,   350,   351,     0,     0,     0,   903,     0,     0,   111,
      49,     0,    50,    51,     0,     0,     0,    53,    54,    55,
      56,    57,    58,    59,     0,     0,    60,     0,     0,   563,
     564,     0,     0,   565,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,     0,     0,   112,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
       0,     0,   175,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   179,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,     0,   190,   191,
     571,   572,     0,     0,   573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   255,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,     0,     0,   175,   176,   177,   178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,     0,   190,
     191,   592,   564,     0,     0,   593,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   255,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,     0,     0,   175,   176,   177,   178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   179,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,     0,
     190,   191,   577,   572,     0,     0,   578,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   255,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
       0,   173,   174,     0,     0,   175,   176,   177,   178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   179,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
       0,   190,   191,   612,   564,     0,     0,   613,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     255,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,     0,     0,   175,   176,   177,   178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     179,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,     0,   190,   191,   615,   572,     0,     0,   616,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   255,   164,   165,   166,   167,   168,   169,   170,   171,
     172,     0,     0,   173,   174,     0,     0,   175,   176,   177,
     178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,     0,   190,   191,   627,   564,     0,     0,   628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   255,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,     0,     0,   175,   176,
     177,   178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   179,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,     0,   190,   191,   630,   572,     0,     0,
     631,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   255,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,     0,     0,   175,
     176,   177,   178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,     0,   190,   191,   656,   564,     0,
       0,   657,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   255,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,     0,     0,
     175,   176,   177,   178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   179,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,     0,   190,   191,   659,   572,
       0,     0,   660,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   255,   164,   165,   166,   167,
     168,   169,   170,   171,   172,     0,     0,   173,   174,     0,
       0,   175,   176,   177,   178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   179,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,     0,   190,   191,   942,
     564,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   255,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
       0,     0,   175,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   179,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,     0,   190,   191,
     945,   572,     0,     0,   946,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   255,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,     0,     0,   175,   176,   177,   178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,     0,   190,
     191,   953,   564,     0,     0,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   255,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,     0,     0,   175,   176,   177,   178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   179,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,     0,
     190,   191,   577,   572,     0,     0,   578,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   255,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
       0,   173,   174,     0,     0,   175,   176,   177,   178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   179,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
       0,   190,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192
};

static const yytype_int16 yycheck[] =
{
       2,    16,    17,   364,    27,    20,    12,    83,     5,     6,
      28,   287,    12,    22,    22,    76,   248,    62,    15,   410,
       7,   390,   292,   336,     4,   221,     8,   388,   415,     2,
     363,     4,   365,    52,    48,   368,   110,   336,    65,     1,
      16,    17,   676,   404,    20,   596,    28,    13,    50,    51,
     468,   425,   428,   292,   428,    52,   389,   418,   280,    65,
     501,   607,   284,   614,   767,    65,    65,    54,   673,    13,
     403,   617,   405,   673,    50,    51,   676,    13,   629,    76,
     477,    27,    37,    38,   460,    26,   419,    11,    12,    98,
      98,   691,   691,   845,    13,    29,    13,   105,   863,    88,
     765,   269,    16,    17,    88,   304,    20,   658,   114,   470,
     528,   119,    79,   446,   114,    90,    16,    17,    90,    25,
      20,   363,   706,   365,   580,   581,   368,    25,    25,   713,
      15,    88,    17,   116,    13,    88,    50,    26,   471,     0,
      90,   116,   143,    90,   116,   387,    51,   389,    53,    54,
      55,    56,    55,   392,   121,    25,   145,   146,   120,    28,
      25,   403,   146,   405,   147,   333,   116,    25,   933,   116,
      25,    25,   924,    88,   108,   417,   841,   419,   619,    25,
      25,   147,    58,    59,   116,   784,   152,   153,   891,   146,
     152,   153,   468,   146,   152,   153,   637,   224,   153,    10,
      11,    12,   143,   445,   446,   437,   152,   153,   152,   153,
     409,     2,   482,     4,   848,   215,   152,   153,   224,   149,
     207,   221,   591,   153,   224,    88,   287,   469,   893,   471,
     149,   146,   601,   152,   153,   152,   153,   252,    49,   254,
     255,   147,   147,   482,   271,   247,   248,   852,   848,   147,
     147,   116,   528,   255,   143,   269,   861,    48,   923,    26,
     149,   861,   116,   863,   720,   271,   663,   664,   644,   643,
     644,   271,   271,   152,   153,   147,   252,   147,   254,   279,
     280,   699,   147,   146,   284,   150,   331,   833,   153,   147,
     287,   336,   147,   147,   149,   268,   150,    90,   109,   153,
      88,   147,   147,   149,   116,   229,   230,   606,    88,    90,
      26,   149,   147,   387,   147,   334,    90,    88,   153,   333,
     111,    88,    88,   116,   149,   147,    88,   372,   373,   149,
     600,   153,    51,   933,    26,    71,    55,   334,   252,   147,
     254,   321,   116,    37,    38,   153,    55,   110,   321,   364,
     113,   114,   252,   326,   254,    88,   110,   365,   146,   113,
     114,   600,   364,    58,    59,    51,   146,   754,   765,    48,
     767,   116,    88,   388,   145,   146,   143,   383,   145,   146,
     146,   389,   149,   383,   146,    90,   388,   700,    17,   404,
     126,   127,   128,   944,   152,   397,    88,   405,   322,   323,
     324,   325,   404,   418,    26,   466,   638,   468,   414,   415,
      55,   419,   145,   146,   414,   415,   418,   331,   229,   230,
      25,   212,   336,   699,   442,   621,    91,   143,   143,   145,
     146,   653,   111,   149,   436,   437,    14,    15,   446,   147,
     147,   443,   833,    71,   841,   842,   815,   258,   259,   425,
     150,   143,   691,   145,   146,   470,   153,   149,   116,   147,
     442,   151,   838,   471,   838,    90,    88,   528,   470,   466,
     443,   468,   263,   144,    55,    88,    71,   268,   269,   452,
      51,   457,    53,    54,    55,    56,   488,    88,   490,    97,
     492,   116,    88,   147,   891,    71,   893,   411,    63,    10,
      51,     8,    53,    54,    55,    56,    88,   876,    88,    13,
      10,   322,   323,   324,   325,   150,   327,   328,   144,   521,
     147,   143,   147,   145,   146,   116,   923,   759,   147,   552,
     321,   528,   145,   146,    51,   326,   149,   147,   147,    51,
      88,    92,   333,    88,   145,   146,   116,   570,    99,   145,
     146,    15,   238,   239,   240,   147,   917,   147,   147,   568,
     568,    63,   147,   145,   146,   145,   146,   576,   576,    10,
     579,   579,   123,   596,   576,   147,   147,   579,   580,   581,
     391,   820,   588,    88,   263,   918,   604,   595,   588,   597,
     269,   614,    10,   147,   144,   597,   602,   145,   146,   390,
     145,   146,   602,   144,   606,   607,   629,   609,   147,   400,
       2,   151,     4,     5,     6,   617,   603,   408,    10,    11,
      12,   621,   604,    15,    16,    17,   822,   118,    20,    88,
      61,    88,   828,    64,    65,   658,   638,    90,   699,   715,
     145,   146,    10,    90,    10,   331,   669,    90,     9,    91,
     336,    10,   443,   653,   333,   700,    48,    49,   703,   704,
      52,   452,    10,   116,   709,   710,   590,   643,   691,   116,
      62,   147,   147,   116,   916,   152,   918,   150,    10,   144,
     111,   112,   116,   144,    76,   147,   145,   146,   145,   146,
     932,   147,   606,    51,   147,    53,    54,    55,    56,   147,
     147,   147,   699,   147,   147,    90,   497,    90,   632,    61,
     121,   147,    64,    65,   147,    10,   722,   109,   720,   111,
     147,   400,   722,    10,   144,   411,    10,    10,   147,   408,
     121,   116,   734,   116,    92,   737,    71,   147,   424,   425,
      98,    99,   428,    56,    57,    58,    59,    62,   754,    64,
      65,    86,    87,    62,   754,    64,    65,   759,   803,   111,
     112,   784,   147,   144,   147,   123,    10,    55,   126,   147,
     147,   457,   774,   775,   460,   777,    55,   779,   780,   590,
     147,    63,    64,    65,   786,   147,   788,   789,   123,   124,
     125,   126,   127,   128,   147,   153,   111,   112,    71,    10,
     591,    10,   111,   112,   149,   490,   149,   492,   147,    51,
     601,    53,    54,    55,    56,   739,    15,     6,   497,   443,
     212,   632,   822,   579,   821,   920,   663,   924,   828,   111,
     112,   833,   716,   919,   503,     7,   522,   229,   230,   820,
     861,    51,   673,    53,    54,    55,    56,   198,    -1,    -1,
      92,   124,   125,   126,   127,   128,    98,    99,    -1,   258,
     252,   858,   254,   255,    -1,    -1,   258,   259,    -1,    -1,
      -1,   263,    -1,   896,   273,    -1,   268,   269,   277,   670,
     671,   123,    92,    -1,   126,    -1,    -1,    -1,    98,    99,
      -1,    -1,    -1,   684,    -1,   287,    -1,   899,   900,   901,
     902,   692,   917,    -1,   906,   907,   908,   149,   910,   911,
     918,    -1,    -1,   123,    -1,   917,   126,   919,   920,    -1,
     606,   944,    63,    64,    65,    -1,   717,   718,   739,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,    -1,   331,
      -1,   333,   334,    -1,   336,   736,    -1,    71,   634,    -1,
     952,   637,    -1,   955,   956,   957,   958,   643,   644,   750,
     751,   752,    86,    87,   966,    -1,    63,    64,    65,    -1,
     111,   112,   364,   676,    -1,   661,   679,    -1,    -1,    -1,
     372,   373,    -1,    -1,    63,    64,    65,    -1,   691,    -1,
      -1,   670,   671,    63,    64,    65,   388,    -1,   390,   391,
     124,   125,   126,   127,   128,   684,    -1,    -1,   400,    -1,
     696,    -1,   404,   692,   111,   112,   408,    63,    64,    65,
      63,    64,    65,   814,   815,    51,   418,    53,    54,    55,
      56,   430,   111,   112,   825,   434,    -1,    -1,   717,   718,
     439,   111,   112,    51,    -1,    53,    54,    55,    56,    -1,
     449,   443,    -1,    -1,    -1,   454,    -1,   736,    -1,    -1,
     452,    -1,    -1,   749,    -1,   111,   112,    -1,   111,   112,
     756,   750,   751,   752,   466,    -1,   468,    -1,   470,    40,
      41,    42,    43,    44,    92,   876,    -1,    -1,    -1,   774,
     775,   882,   777,   884,   779,   780,    -1,    -1,    -1,   890,
      -1,   786,    -1,   788,   789,   497,   792,    -1,    51,    -1,
      53,    54,    55,    56,   297,    -1,    51,    -1,    53,    54,
      55,    56,   305,    -1,     2,   308,     4,   310,   527,   312,
      -1,   314,    10,    11,    12,   814,   528,    -1,    16,    17,
      -1,    -1,    20,    -1,    -1,   848,   825,   850,    -1,    92,
      -1,   854,   838,    -1,    -1,    98,    99,    92,    -1,    -1,
     863,    -1,   865,    98,    99,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     123,    -1,    -1,   126,    62,    -1,    -1,    -1,   123,    -1,
      -1,   126,    71,    -1,    -1,    -1,    -1,    -1,   590,   591,
     599,    -1,    -1,   882,    -1,   884,   149,    86,    87,   601,
      -1,   890,    -1,    -1,   899,   900,   901,   902,    -1,    -1,
      -1,   906,   907,   908,   927,   910,   911,    -1,    -1,    -1,
     933,   109,   935,   111,    -1,   938,    -1,    -1,    -1,    -1,
     632,    -1,   121,   122,   123,   124,   125,   126,   127,   128,
      51,    -1,    53,    54,    55,    56,    -1,    -1,    51,   962,
      53,    54,    55,    56,    -1,    -1,    -1,   952,   667,    -1,
     955,   956,   957,   958,    -1,    -1,    -1,    -1,   670,   671,
      -1,   966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,   684,    -1,    -1,    -1,    -1,    98,    -1,    92,
     692,    -1,    -1,    -1,    -1,    98,    -1,   699,   700,    -1,
      -1,   703,   704,    -1,    -1,    -1,    -1,   709,   710,    -1,
      -1,    -1,    -1,    -1,    -1,   717,   718,    -1,   727,    -1,
      -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   736,    -1,    -1,   739,    -1,    -1,
      -1,   229,   230,    -1,    -1,    -1,    -1,    -1,   750,   751,
     752,    -1,    -1,    -1,    -1,   764,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,   254,   255,    -1,    -1,
     258,   259,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,
     268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   814,   815,    -1,    -1,    -1,    -1,    -1,   821,
      -1,    -1,    -1,   825,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,    -1,   331,    -1,   333,    -1,    -1,   336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   858,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   876,    -1,   364,    -1,    -1,    -1,
     882,    -1,   884,    -1,   372,   373,    -1,    -1,   890,    71,
      72,    73,    74,    75,    76,    77,    78,    -1,    80,    81,
     388,    -1,   390,   391,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,   400,    -1,    -1,   917,   404,    -1,    -1,    -1,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   443,    16,    17,    -1,    -1,
      20,    -1,    -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   470,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,   497,
      -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,
      -1,    -1,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    45,    46,    47,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    -1,    -1,    63,
      -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   590,   591,    -1,    89,    -1,    -1,    92,    93,
      -1,    95,    96,   601,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   632,   129,   130,   131,    -1,    -1,
      -1,    -1,     2,    -1,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,   152,   153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,   239,
     240,   241,   670,   671,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,   254,   255,   684,    -1,    48,    -1,
      -1,    -1,    52,    -1,   692,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   700,    -1,    -1,   703,   704,    -1,    -1,    -1,
      -1,   709,   710,    -1,    -1,    -1,    76,    -1,    -1,   717,
     718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   736,    -1,
      -1,   739,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   750,   751,   752,    -1,    -1,    -1,    -1,    -1,
      -1,   331,    -1,    -1,    -1,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   373,    -1,   803,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   814,   815,   388,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   825,    -1,    -1,
      -1,    -1,   402,    -1,   404,    -1,   406,   407,    -1,    -1,
      -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,
      -1,    -1,   212,    -1,   424,   425,    -1,    -1,   428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   876,    -1,
      -1,    -1,    -1,    -1,   882,    -1,   884,   457,    -1,    -1,
     460,    -1,   890,    -1,     2,    -1,     4,    -1,    -1,    -1,
     470,    -1,    -1,   263,    -1,    -1,    -1,    15,   268,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   917,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,
      -1,    -1,     2,    -1,     4,     5,     6,    -1,    -1,    -1,
      48,   511,   512,    -1,    -1,    15,    -1,    -1,    -1,    -1,
       0,    -1,   522,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,   321,    -1,    13,    14,    15,   326,    17,    -1,    -1,
      -1,    -1,    -1,   333,   334,    -1,    26,    27,    48,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     390,    -1,    -1,    -1,    -1,    -1,   606,    -1,    88,    -1,
     400,   111,    -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   634,    -1,    -1,   637,    -1,    -1,
      -1,    -1,    -1,   643,   644,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   661,   452,   143,   144,    -1,   146,    -1,    -1,   149,
     150,    -1,   152,   153,   212,    -1,   466,    -1,   468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   696,    -1,    -1,    -1,
     700,   701,    -1,   703,   704,    -1,    -1,   497,    -1,   709,
     710,    -1,   212,    -1,    -1,    -1,    -1,    -1,    -1,   719,
      -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,
     268,   269,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,
      -1,    -1,   742,   743,    -1,   745,   746,    -1,    -1,   749,
      -1,    -1,    -1,    -1,    -1,    -1,   756,    -1,    -1,    -1,
      -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,   268,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,    -1,    -1,   287,   326,    -1,
      -1,    -1,   792,    -1,    -1,   333,   796,    -1,   336,    -1,
      -1,   591,    -1,   803,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     830,    -1,    -1,   333,   334,    -1,    -1,    -1,   838,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     670,   671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     390,    -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,    -1,
     400,    -1,   692,    -1,    -1,   443,    -1,    -1,   408,   699,
      -1,    -1,    -1,    -1,   452,    -1,    -1,   917,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   717,   718,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,   443,    86,    87,   736,    -1,    -1,    -1,
      -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,   497,
     750,   751,   752,    -1,    -1,    -1,   466,    -1,   468,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   814,   815,    -1,    -1,   528,    -1,
      -1,   821,    -1,    -1,    -1,   825,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   601,    -1,    -1,    -1,    -1,   858,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,   876,    -1,    -1,    -1,
      -1,   591,   882,    -1,   884,    -1,    -1,    -1,    -1,    -1,
     890,   601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,   670,   671,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,   684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   692,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     670,   671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   717,
     718,    -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   692,    -1,    -1,    -1,    -1,    -1,   736,   699,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   750,   751,   752,    -1,    -1,   717,   718,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   736,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     750,   751,   752,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,   814,   815,    -1,    -1,
      -1,    -1,    -1,   821,    -1,    -1,    -1,   825,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,    -1,    -1,    -1,   814,   815,    -1,    -1,    -1,    -1,
      -1,   821,     0,    -1,    -1,   825,    -1,    -1,    -1,    -1,
       8,     9,    10,    -1,    -1,    13,    14,    15,   876,    17,
      -1,    -1,    -1,    -1,   882,    -1,   884,    -1,    -1,    27,
      28,    29,   890,    -1,    -1,    -1,    -1,    -1,   858,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   876,    -1,    -1,    -1,
      -1,    -1,   882,    -1,   884,    -1,    -1,    -1,    -1,    -1,
     890,    -1,    -1,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      88,    -1,    90,    91,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   144,   145,   146,   147,
       0,    -1,   150,   151,   152,   153,    -1,    -1,     8,     9,
      10,    -1,    -1,    13,    14,    15,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    26,    27,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    88,    -1,
      -1,    91,    -1,    -1,    -1,    -1,   117,    97,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   143,   144,   145,   146,   147,     0,   149,
     150,   151,   152,   153,    -1,    -1,     8,     9,    10,    -1,
      -1,    13,    14,    15,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    88,    -1,    -1,    91,
      -1,    -1,    -1,    -1,   117,    97,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,   145,   146,   147,     0,    -1,   150,   151,
     152,   153,    -1,    -1,     8,     9,    10,    -1,    -1,    13,
      14,    15,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    26,    27,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    88,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    97,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,
     144,   145,   146,   147,     0,   149,   150,   151,   152,   153,
      -1,    -1,     8,     9,    10,    -1,    -1,    13,    14,    15,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    88,    -1,    -1,    91,     0,    -1,    -1,    -1,
      -1,    97,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    26,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    88,    -1,    90,    -1,     0,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,   143,
     144,   145,   146,   147,    -1,    -1,   150,    -1,   152,   153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    88,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,   145,   146,   147,    -1,    -1,   150,    -1,
     152,   153,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    -1,    15,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,   152,   153,    10,    11,    12,    -1,    14,
      15,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    10,    11,    12,   152,   153,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,
      66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   129,   130,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    10,    11,    12,   152,   153,    15,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      47,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    11,    12,    -1,   152,   153,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   152,   153,     1,    -1,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,
      66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   129,   130,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    11,    12,    -1,   152,   153,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,
      -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   129,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   150,    -1,   152,   153,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,    -1,   152,   153,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    -1,
      -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      92,    93,    -1,    95,    96,    -1,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,     1,    -1,     3,     4,     5,     6,     7,
     152,   153,    10,    11,    12,    -1,    -1,    -1,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,
      -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   129,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,    -1,   152,   153,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,   129,
     130,   131,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,   153,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    -1,    -1,    63,
      -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,
      -1,    95,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,   130,   131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    11,    12,    -1,   152,   153,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,
      66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    11,    12,   129,   130,   131,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,   153,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,   152,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,   130,   131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    -1,    -1,    80,    81,    -1,    -1,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,    -1,   148,   149,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    26,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,   143,    -1,    11,    12,    -1,    -1,   149,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    26,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,   143,    -1,    11,    12,
      -1,    -1,   149,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,
      93,    -1,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,     7,   129,   130,   131,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,   149,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      92,    93,    -1,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,   129,   130,   131,
      11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,   149,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    -1,    -1,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    -1,    80,    81,    -1,    -1,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    -1,    80,    81,    -1,    -1,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    -1,
      -1,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    -1,    80,    81,
      -1,    -1,    84,    85,    86,    87,    -1,    -1,    71,    72,
      73,    74,    75,    76,    77,    -1,    98,    80,    81,   101,
      -1,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
      -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   148,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    52,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    80,    81,    -1,    -1,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,   148,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,     7,    -1,    -1,   129,    11,    12,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,   147,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,
      66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,   129,    11,    12,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,   147,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,   110,    -1,    -1,   113,   114,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      11,    12,   129,   130,   131,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,   129,   130,
     131,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,   110,    -1,    -1,   113,   114,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    11,    12,   129,   130,   131,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
     129,   130,   131,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    92,
      93,    -1,    95,    96,    -1,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,   110,    -1,    -1,
     113,   114,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,   129,   130,   131,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,   110,    -1,    -1,   113,   114,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,   129,   130,   131,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,   110,
      -1,    -1,   113,   114,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,   129,   130,
     131,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,   129,   130,   131,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
     129,   130,   131,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    92,
      93,    -1,    95,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,   129,   130,   131,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,   129,   130,   131,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,   129,   130,
     131,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,   129,   130,   131,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
     129,   130,   131,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    92,
      93,    -1,    95,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,   129,   130,   131,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,   129,   130,   131,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,   129,   130,
     131,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
      -1,    -1,    -1,    16,   129,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    92,
      93,    -1,    95,    96,    -1,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,    -1,    -1,    -1,    16,   129,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    92,    93,    -1,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    16,   129,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    92,    93,    -1,    95,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,
     129,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    92,    93,    -1,    95,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,   129,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    92,    93,    -1,
      95,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
      -1,    -1,    -1,    16,   129,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    -1,
      63,    -1,    -1,    66,    67,    -1,    71,    72,    73,    74,
      75,    76,    77,    -1,    -1,    80,    81,    -1,    -1,    -1,
      -1,    86,    87,    -1,    -1,    -1,    89,    -1,    -1,    92,
      93,    -1,    95,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    51,
      52,    -1,    -1,    55,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,    -1,   129,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    -1,    80,    81,
      -1,    -1,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    -1,    80,
      81,    -1,    -1,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      80,    81,    -1,    -1,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    80,    81,    -1,    -1,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,    51,    52,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    -1,    80,    81,    -1,    -1,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,    51,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    -1,    -1,    80,    81,    -1,    -1,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,    51,    52,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    80,    81,    -1,    -1,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,    51,    52,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   148,   149,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    -1,    -1,    80,    81,    -1,    -1,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,    51,    52,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    -1,    80,    81,    -1,    -1,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,    51,    52,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    -1,    -1,    80,    81,    -1,
      -1,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,    51,
      52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    -1,    80,    81,
      -1,    -1,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    -1,    80,
      81,    -1,    -1,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      80,    81,    -1,    -1,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    80,    81,    -1,    -1,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   155,   156,     0,     1,     3,     4,     5,     6,     7,
      11,    12,    16,    18,    19,    20,    21,    22,    23,    24,
      30,    31,    32,    33,    34,    35,    36,    39,    45,    46,
      47,    48,    49,    51,    52,    53,    54,    55,    56,    58,
      59,    60,    63,    66,    67,    69,    70,    89,    92,    93,
      95,    96,    98,   100,   101,   102,   103,   104,   105,   106,
     109,   129,   130,   131,   157,   158,   159,   164,   166,   167,
     169,   170,   173,   174,   176,   177,   178,   180,   181,   190,
     203,   221,   240,   241,   251,   252,   256,   257,   258,   265,
     266,   267,   269,   270,   271,   272,   273,   274,   297,   310,
     159,    21,    22,    30,    31,    32,    39,    51,    55,    86,
      89,    92,   129,   182,   183,   203,   221,   271,   274,   297,
     183,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    45,    46,    47,    48,    49,
      50,    51,    52,    55,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    80,    81,    84,    85,    86,    87,    98,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     130,   131,   148,   149,   184,   188,   189,   273,   292,    33,
      34,    35,    36,    48,    49,    51,    55,   101,   184,   185,
     186,   267,   204,    89,   167,   168,   181,   221,   271,   272,
     274,   168,   152,   153,   168,   301,   306,   307,   309,   208,
     210,    89,   174,   181,   221,   226,   271,   274,    57,    98,
      99,   130,   173,   190,   191,   196,   199,   201,   295,   296,
     196,   196,   149,   197,   198,   149,   193,   197,   149,   302,
     307,   185,   160,   143,   190,   221,   190,    55,     1,    92,
     162,   163,   164,   175,   176,   310,   167,   206,   192,   201,
     295,   310,   191,   294,   295,   310,    89,   147,   180,   221,
     271,   274,   207,    53,    54,    56,    63,   105,   184,   268,
      62,    64,    65,   111,   112,   253,   254,    63,   253,    63,
     253,    63,   253,    61,   253,    58,    59,   169,   190,   190,
     301,   309,    40,    41,    42,    43,    44,    37,    38,    28,
     238,   116,   147,    92,    98,   177,   116,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      86,    87,   117,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,    88,   145,   146,    88,   146,   300,    26,
     143,   242,    90,    90,   193,   197,   242,   167,    51,    55,
     182,    58,    59,     1,   120,   275,   306,    88,   145,   146,
     217,   293,   218,   300,   105,   147,   161,   162,    55,    13,
     222,   306,   116,    88,   145,   146,    90,    90,   222,   308,
     301,    17,   245,   152,   168,   168,    55,    88,   145,   146,
      25,   191,   191,   191,    91,   147,   200,   310,   147,   200,
     196,   302,   303,   196,   195,   196,   201,   295,   310,   167,
     303,   167,   165,   143,   162,    88,   146,    90,   164,   175,
     150,   301,   309,   303,   205,   303,   151,   147,   305,   307,
     147,   305,   144,   305,    55,   177,   178,   179,   147,    88,
     145,   146,    51,    53,    54,    55,    56,    92,    98,    99,
     123,   126,   149,   236,   278,   279,   280,   281,   282,   283,
     286,   287,   288,   289,   290,    63,   254,   255,   110,   113,
     114,   260,   261,   262,   263,    62,   254,    63,    63,    63,
      61,    71,    71,   159,   168,   168,   168,   168,   164,   167,
     167,   239,    98,   169,   191,   201,   202,   175,   147,   180,
     147,   166,   169,   181,   190,   191,   202,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,    51,    52,    55,   188,   193,   298,   299,
     195,    51,    52,    55,   188,   193,   298,    51,    55,   298,
     244,   243,   169,   190,   169,   190,    97,   171,   215,   306,
     276,   214,    51,    55,   182,   298,   195,   298,   161,   167,
     149,   277,   278,   219,   187,    10,     8,   247,   310,   162,
      13,   190,    51,    55,   195,    51,    55,   162,   259,   260,
     245,   201,    10,    27,   223,   306,   223,    51,    55,   195,
      51,    55,   212,   191,    98,   191,   199,   260,   295,   296,
     303,   150,   303,   147,   147,   303,   185,   157,   144,   190,
     303,   164,   303,   295,   177,   179,    51,    55,   195,    51,
      55,   116,    51,    92,    98,   227,   228,   229,   280,   278,
      29,   108,   237,   147,   291,   310,   147,   291,    51,   147,
     291,    51,    63,   162,   264,   261,   110,   263,   190,   190,
      79,   121,   231,   232,   310,   191,   147,   303,   179,   147,
     116,    44,   302,    90,    90,   193,   197,   302,   304,    90,
      90,   193,   194,   197,   310,   194,   197,   231,   231,    44,
     172,   306,   168,   161,   304,    10,   303,   278,   161,   306,
     184,   185,   191,   202,   248,   310,    15,   225,   310,    14,
     224,   225,    90,    90,   304,    90,    90,   225,    10,   147,
     222,   209,   211,   304,   168,   191,    98,   191,   200,   295,
     144,   305,   304,   191,   229,   147,   280,   147,   303,   233,
     302,   162,   162,   281,   286,   288,   290,   282,   283,   288,
     282,   144,   162,    51,   230,   233,   282,   284,   285,   288,
     290,   162,    98,   191,   179,   190,   118,   169,   190,   169,
     190,   171,   151,    90,   169,   190,   169,   190,   171,   242,
     238,   162,   162,   190,   231,   216,   306,    10,   303,    10,
     220,    91,   249,   310,   162,     9,   250,   310,   168,    10,
      90,    10,   191,   162,   162,   162,   223,   191,   147,   303,
     228,   147,    98,   227,   150,   152,    10,   144,   147,   291,
     147,   291,   147,   291,   147,   291,   291,   144,   116,   233,
     121,   147,   291,   147,   291,   147,   291,    10,   191,   190,
     169,   190,    10,   144,   162,   161,   277,    89,   181,   221,
     271,   274,   222,   162,   222,   225,   245,   246,    10,    10,
     213,   147,   228,   147,   280,    51,   234,   235,   279,   282,
     288,   282,   282,    89,   221,   121,   285,   288,   282,   284,
     288,   282,   144,    10,   161,    55,    88,   145,   146,   162,
     162,   162,   228,   147,   147,   302,   291,   147,   291,   291,
     291,    55,    88,   147,   291,   147,   291,   291,   147,   291,
     291,    10,    51,    55,   195,    51,    55,   247,   224,    10,
     228,   235,   282,    51,    55,   282,   288,   282,   282,   304,
     291,   291,   147,   291,   291,   291,   282,   291
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   154,   156,   155,   157,   158,   158,   158,   158,   159,
     160,   159,   161,   162,   163,   163,   163,   163,   165,   164,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     166,   166,   167,   167,   167,   167,   167,   167,   168,   169,
     169,   170,   170,   172,   171,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   174,   174,   175,   175,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     177,   177,   178,   178,   179,   179,   180,   180,   180,   180,
     180,   180,   180,   180,   181,   181,   181,   181,   181,   181,
     181,   181,   182,   182,   183,   183,   183,   184,   184,   184,
     184,   184,   185,   185,   186,   187,   186,   188,   188,   188,
     188,   188,   188,   188,   188,   188,   188,   188,   188,   188,
     188,   188,   188,   188,   188,   188,   188,   188,   188,   188,
     188,   188,   188,   188,   188,   188,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     191,   192,   192,   192,   192,   193,   194,   194,   195,   195,
     195,   195,   195,   196,   196,   196,   196,   196,   198,   197,
     199,   200,   200,   201,   201,   201,   201,   201,   201,   202,
     202,   202,   203,   203,   203,   203,   203,   203,   203,   203,
     204,   203,   205,   203,   206,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     207,   203,   203,   203,   208,   209,   203,   210,   211,   203,
     203,   203,   212,   213,   203,   214,   203,   215,   216,   203,
     217,   203,   218,   203,   219,   220,   203,   203,   203,   203,
     203,   221,   222,   222,   222,   223,   223,   224,   224,   225,
     225,   226,   226,   227,   227,   228,   228,   229,   229,   229,
     229,   229,   229,   229,   229,   229,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   231,   231,   232,   232,   232,   233,   233,   234,   234,
     235,   235,   236,   236,   237,   237,   239,   238,   240,   240,
     240,   240,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   243,   242,   244,   242,   245,   246,   246,   247,   247,
     248,   248,   248,   249,   249,   250,   250,   251,   251,   251,
     251,   252,   252,   252,   252,   253,   253,   254,   255,   254,
     254,   254,   256,   256,   257,   257,   258,   259,   259,   260,
     260,   261,   261,   262,   262,   263,   264,   263,   265,   265,
     266,   266,   267,   268,   268,   268,   268,   268,   268,   269,
     269,   270,   270,   270,   270,   271,   271,   271,   271,   271,
     272,   273,   273,   273,   273,   273,   273,   273,   274,   274,
     275,   276,   275,   275,   277,   277,   278,   278,   278,   278,
     278,   278,   278,   278,   278,   278,   278,   278,   278,   278,
     278,   279,   279,   279,   279,   280,   280,   281,   281,   282,
     282,   283,   284,   285,   285,   286,   286,   287,   287,   288,
     288,   289,   289,   290,   291,   291,   292,   293,   292,   294,
     294,   295,   295,   296,   296,   297,   297,   297,   298,   298,
     298,   298,   299,   299,   299,   300,   300,   301,   301,   302,
     302,   303,   304,   305,   305,   305,   306,   306,   308,   307,
     309,   309,   310
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     1,     3,     2,     1,
       0,     5,     4,     2,     1,     1,     3,     2,     0,     4,
       2,     3,     3,     3,     3,     3,     4,     1,     3,     3,
       6,     5,     5,     5,     5,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     2,     1,     1,     1,
       1,     1,     4,     0,     5,     2,     3,     4,     5,     4,
       5,     2,     2,     2,     2,     2,     1,     3,     1,     3,
       1,     2,     3,     5,     2,     4,     2,     4,     1,     3,
       1,     3,     2,     3,     1,     2,     1,     4,     3,     3,
       3,     3,     2,     1,     1,     4,     3,     3,     3,     3,
       2,     1,     1,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     5,     3,     5,
       6,     5,     5,     5,     5,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     3,     3,     6,     1,
       1,     1,     2,     4,     2,     3,     1,     1,     1,     1,
       2,     4,     2,     1,     2,     2,     4,     1,     0,     2,
       2,     2,     1,     1,     2,     3,     4,     4,     5,     3,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     4,     0,     4,     0,     3,     3,     3,     2,     3,
       3,     1,     4,     3,     1,     4,     3,     2,     1,     2,
       0,     4,     6,     6,     0,     0,     7,     0,     0,     7,
       5,     4,     0,     0,     9,     0,     6,     0,     0,     8,
       0,     5,     0,     6,     0,     0,     9,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     5,     1,
       2,     1,     1,     1,     3,     1,     3,     1,     4,     6,
       3,     5,     2,     4,     1,     3,     6,     8,     4,     6,
       4,     2,     6,     2,     4,     6,     2,     4,     2,     4,
       1,     1,     1,     3,     1,     4,     1,     4,     1,     3,
       1,     1,     4,     1,     3,     3,     0,     5,     2,     4,
       5,     5,     2,     4,     4,     3,     3,     3,     2,     1,
       4,     0,     5,     0,     5,     5,     1,     1,     6,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     2,     1,     0,     4,
       1,     2,     2,     3,     2,     3,     1,     0,     1,     1,
       2,     1,     2,     1,     2,     1,     0,     4,     2,     3,
       1,     4,     2,     1,     1,     1,     1,     1,     2,     2,
       3,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     4,     2,     3,     2,     6,     8,     4,     6,
       4,     6,     2,     4,     6,     2,     4,     2,     4,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     3,     1,     3,     1,     3,     1,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     0,     4,     1,
       2,     1,     3,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     0,
       1,     2,     2,     0,     1,     1,     1,     1,     0,     3,
       1,     2,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (p, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, p); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_state *p)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (p);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_state *p)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parser_state *p)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , p);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, p); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_state *p)
{
  YYUSE (yyvaluep);
  YYUSE (p);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_state *p)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, p);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 1146 "src/parse.y" /* yacc.c:1646  */
    {
		     p->lstate = EXPR_BEG;
		     if (!p->locals) p->locals = cons(0,0);
		   }
#line 5149 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 1151 "src/parse.y" /* yacc.c:1646  */
    {
		      p->tree = new_scope(p, (yyvsp[0].nd));
		    }
#line 5157 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 1157 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 5165 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 1163 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 5173 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 1167 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, (yyvsp[0].nd));
		    }
#line 5181 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 1171 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), newline_node((yyvsp[0].nd)));
		    }
#line 5189 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 1175 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 5197 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 1182 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = local_switch(p);
		    }
#line 5205 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 1186 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "BEGIN not supported");
		      local_resume(p, (yyvsp[-3].nd));
		      (yyval.nd) = 0;
		    }
#line 5215 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 1197 "src/parse.y" /* yacc.c:1646  */
    {
		      if ((yyvsp[-2].nd)) {
			(yyval.nd) = new_rescue(p, (yyvsp[-3].nd), (yyvsp[-2].nd), (yyvsp[-1].nd));
		      }
		      else if ((yyvsp[-1].nd)) {
			yywarn(p, "else without rescue is useless");
			(yyval.nd) = push((yyvsp[-3].nd), (yyvsp[-1].nd));
		      }
		      else {
			(yyval.nd) = (yyvsp[-3].nd);
		      }
		      if ((yyvsp[0].nd)) {
			if ((yyval.nd)) {
			  (yyval.nd) = new_ensure(p, (yyval.nd), (yyvsp[0].nd));
			}
			else {
			  (yyval.nd) = push((yyvsp[0].nd), new_nil(p));
			}
		      }
		    }
#line 5240 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 1220 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 5248 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 1226 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 5256 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 1230 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, (yyvsp[0].nd));
		    }
#line 5264 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 1234 "src/parse.y" /* yacc.c:1646  */
    {
			(yyval.nd) = push((yyvsp[-2].nd), newline_node((yyvsp[0].nd)));
		    }
#line 5272 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 1238 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_begin(p, (yyvsp[0].nd));
		    }
#line 5280 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 1243 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_FNAME;}
#line 5286 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 1244 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_alias(p, (yyvsp[-2].id), (yyvsp[0].id));
		    }
#line 5294 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 1248 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 5302 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 1252 "src/parse.y" /* yacc.c:1646  */
    {
			(yyval.nd) = new_if(p, cond((yyvsp[0].nd)), (yyvsp[-2].nd), 0);
		    }
#line 5310 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 1256 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_unless(p, cond((yyvsp[0].nd)), (yyvsp[-2].nd), 0);
		    }
#line 5318 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 1260 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_while(p, cond((yyvsp[0].nd)), (yyvsp[-2].nd));
		    }
#line 5326 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 1264 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_until(p, cond((yyvsp[0].nd)), (yyvsp[-2].nd));
		    }
#line 5334 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 1268 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_rescue(p, (yyvsp[-2].nd), list1(list3(0, 0, (yyvsp[0].nd))), 0);
		    }
#line 5342 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 1272 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "END not suported");
		      (yyval.nd) = new_postexe(p, (yyvsp[-1].nd));
		    }
#line 5351 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 1278 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_masgn(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5359 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 1282 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, (yyvsp[-2].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5367 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 1286 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-5].nd), intern("[]",2), (yyvsp[-3].nd)), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5375 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 1290 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5383 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 1294 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5391 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 1298 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.nd) = 0;
		    }
#line 5400 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 1303 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5408 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 1307 "src/parse.y" /* yacc.c:1646  */
    {
		      backref_error(p, (yyvsp[-2].nd));
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 5417 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 1312 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_asgn(p, (yyvsp[-2].nd), new_array(p, (yyvsp[0].nd)));
		    }
#line 5425 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 1316 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_masgn(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5433 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 1320 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_masgn(p, (yyvsp[-2].nd), new_array(p, (yyvsp[0].nd)));
		    }
#line 5441 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1327 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_asgn(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5449 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1331 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_asgn(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5457 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1339 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_and(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5465 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1343 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_or(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5473 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1347 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, cond((yyvsp[0].nd)), "!");
		    }
#line 5481 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1351 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, cond((yyvsp[0].nd)), "!");
		    }
#line 5489 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 1358 "src/parse.y" /* yacc.c:1646  */
    {
		      if (!(yyvsp[0].nd)) (yyval.nd) = new_nil(p);
		      else (yyval.nd) = (yyvsp[0].nd);
		    }
#line 5498 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1373 "src/parse.y" /* yacc.c:1646  */
    {
		      local_nest(p);
		    }
#line 5506 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1379 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_block(p, (yyvsp[-2].nd), (yyvsp[-1].nd));
		      local_unnest(p);
		    }
#line 5515 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1386 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_fcall(p, (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5523 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1390 "src/parse.y" /* yacc.c:1646  */
    {
		      args_with_block(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      (yyval.nd) = new_fcall(p, (yyvsp[-2].id), (yyvsp[-1].nd));
		    }
#line 5532 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1395 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5540 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1399 "src/parse.y" /* yacc.c:1646  */
    {
		      args_with_block(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      (yyval.nd) = new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), (yyvsp[-1].nd));
		   }
#line 5549 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1404 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 5557 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1408 "src/parse.y" /* yacc.c:1646  */
    {
		      args_with_block(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      (yyval.nd) = new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), (yyvsp[-1].nd));
		    }
#line 5566 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1413 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_super(p, (yyvsp[0].nd));
		    }
#line 5574 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1417 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_yield(p, (yyvsp[0].nd));
		    }
#line 5582 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1421 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_return(p, ret_args(p, (yyvsp[0].nd)));
		    }
#line 5590 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1425 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_break(p, ret_args(p, (yyvsp[0].nd)));
		    }
#line 5598 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1429 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_next(p, ret_args(p, (yyvsp[0].nd)));
		    }
#line 5606 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1435 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 5614 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1439 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 5622 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1446 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[-1].nd));
		    }
#line 5630 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1452 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 5638 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1456 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(push((yyvsp[-1].nd),(yyvsp[0].nd)));
		    }
#line 5646 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1460 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list2((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5654 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1464 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-4].nd), (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5662 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1468 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list2((yyvsp[-1].nd), new_nil(p));
		    }
#line 5670 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1472 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-3].nd), new_nil(p), (yyvsp[0].nd));
		    }
#line 5678 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1476 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list2(0, (yyvsp[0].nd));
		    }
#line 5686 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1480 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 5694 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1484 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list2(0, new_nil(p));
		    }
#line 5702 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1488 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, new_nil(p), (yyvsp[0].nd));
		    }
#line 5710 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1495 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 5718 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1501 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[-1].nd));
		    }
#line 5726 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1505 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[-1].nd));
		    }
#line 5734 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1511 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 5742 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1515 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-1].nd), (yyvsp[0].nd));
		    }
#line 5750 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1521 "src/parse.y" /* yacc.c:1646  */
    {
		      assignable(p, (yyvsp[0].nd));
		    }
#line 5758 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1525 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), intern("[]",2), (yyvsp[-1].nd));
		    }
#line 5766 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1529 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5774 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1533 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5782 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1537 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5790 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1541 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.nd) = new_colon2(p, (yyvsp[-2].nd), (yyvsp[0].id));
		    }
#line 5800 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1547 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.nd) = new_colon3(p, (yyvsp[0].id));
		    }
#line 5810 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1553 "src/parse.y" /* yacc.c:1646  */
    {
		      backref_error(p, (yyvsp[0].nd));
		      (yyval.nd) = 0;
		    }
#line 5819 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1560 "src/parse.y" /* yacc.c:1646  */
    {
		      assignable(p, (yyvsp[0].nd));
		    }
#line 5827 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1564 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), intern("[]",2), (yyvsp[-1].nd));
		    }
#line 5835 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1568 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5843 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1572 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5851 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1576 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 5859 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1580 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.nd) = new_colon2(p, (yyvsp[-2].nd), (yyvsp[0].id));
		    }
#line 5869 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1586 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.nd) = new_colon3(p, (yyvsp[0].id));
		    }
#line 5879 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1592 "src/parse.y" /* yacc.c:1646  */
    {
		      backref_error(p, (yyvsp[0].nd));
		      (yyval.nd) = 0;
		    }
#line 5888 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1599 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "class/module name must be CONSTANT");
		    }
#line 5896 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1606 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((node*)1, nsym((yyvsp[0].id)));
		    }
#line 5904 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1610 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((node*)0, nsym((yyvsp[0].id)));
		    }
#line 5912 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1614 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((yyvsp[-2].nd), nsym((yyvsp[0].id)));
		    }
#line 5920 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1623 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lstate = EXPR_ENDFN;
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 5929 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1628 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lstate = EXPR_ENDFN;
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 5938 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1639 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_undef(p, (yyvsp[0].id));
		    }
#line 5946 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1642 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_FNAME;}
#line 5952 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1643 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-3].nd), nsym((yyvsp[0].id)));
		    }
#line 5960 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1648 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('|'); }
#line 5966 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1649 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('^'); }
#line 5972 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1650 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('&'); }
#line 5978 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1651 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("<=>",3); }
#line 5984 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1652 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("==",2); }
#line 5990 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1653 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("===",3); }
#line 5996 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1654 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("=~",2); }
#line 6002 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1655 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("!~",2); }
#line 6008 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1656 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('>'); }
#line 6014 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1657 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern(">=",2); }
#line 6020 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1658 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('<'); }
#line 6026 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1659 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("<=",2); }
#line 6032 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1660 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("!=",2); }
#line 6038 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1661 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("<<",2); }
#line 6044 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1662 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern(">>",2); }
#line 6050 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1663 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('+'); }
#line 6056 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1664 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('-'); }
#line 6062 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1665 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('*'); }
#line 6068 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1666 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('*'); }
#line 6074 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1667 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('/'); }
#line 6080 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1668 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('%'); }
#line 6086 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1669 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("**",2); }
#line 6092 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1670 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('!'); }
#line 6098 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1671 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('~'); }
#line 6104 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1672 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("+@",2); }
#line 6110 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1673 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("-@",2); }
#line 6116 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1674 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("[]",2); }
#line 6122 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1675 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern("[]=",3); }
#line 6128 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1676 "src/parse.y" /* yacc.c:1646  */
    { (yyval.id) = intern_c('`'); }
#line 6134 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1694 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_asgn(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6142 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1698 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_asgn(p, (yyvsp[-4].nd), new_rescue(p, (yyvsp[-2].nd), list1(list3(0, 0, (yyvsp[0].nd))), 0));
		    }
#line 6150 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1702 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, (yyvsp[-2].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 6158 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1706 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, (yyvsp[-4].nd), (yyvsp[-3].id), new_rescue(p, (yyvsp[-2].nd), list1(list3(0, 0, (yyvsp[0].nd))), 0));
		    }
#line 6166 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1710 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-5].nd), intern("[]",2), (yyvsp[-3].nd)), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 6174 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1714 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 6182 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1718 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 6190 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1722 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_op_asgn(p, new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), 0), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 6198 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1726 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 6207 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1731 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 6216 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1736 "src/parse.y" /* yacc.c:1646  */
    {
		      backref_error(p, (yyvsp[-2].nd));
		      (yyval.nd) = new_begin(p, 0);
		    }
#line 6225 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1741 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_dot2(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6233 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1745 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_dot3(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6241 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1749 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "+", (yyvsp[0].nd));
		    }
#line 6249 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1753 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "-", (yyvsp[0].nd));
		    }
#line 6257 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1757 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "*", (yyvsp[0].nd));
		    }
#line 6265 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1761 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "/", (yyvsp[0].nd));
		    }
#line 6273 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1765 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "%", (yyvsp[0].nd));
		    }
#line 6281 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1769 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "**", (yyvsp[0].nd));
		    }
#line 6289 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1773 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, call_bin_op(p, (yyvsp[-2].nd), "**", (yyvsp[0].nd)), "-@");
		    }
#line 6297 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1777 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, call_bin_op(p, (yyvsp[-2].nd), "**", (yyvsp[0].nd)), "-@");
		    }
#line 6305 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1781 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, (yyvsp[0].nd), "+@");
		    }
#line 6313 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1785 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, (yyvsp[0].nd), "-@");
		    }
#line 6321 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1789 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "|", (yyvsp[0].nd));
		    }
#line 6329 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1793 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "^", (yyvsp[0].nd));
		    }
#line 6337 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1797 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "&", (yyvsp[0].nd));
		    }
#line 6345 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1801 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "<=>", (yyvsp[0].nd));
		    }
#line 6353 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1805 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), ">", (yyvsp[0].nd));
		    }
#line 6361 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1809 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), ">=", (yyvsp[0].nd));
		    }
#line 6369 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1813 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "<", (yyvsp[0].nd));
		    }
#line 6377 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1817 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "<=", (yyvsp[0].nd));
		    }
#line 6385 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1821 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "==", (yyvsp[0].nd));
		    }
#line 6393 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1825 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "===", (yyvsp[0].nd));
		    }
#line 6401 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1829 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "!=", (yyvsp[0].nd));
		    }
#line 6409 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1833 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "=~", (yyvsp[0].nd));
		    }
#line 6417 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1837 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "!~", (yyvsp[0].nd));
		    }
#line 6425 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1841 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, cond((yyvsp[0].nd)), "!");
		    }
#line 6433 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1845 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, cond((yyvsp[0].nd)), "~");
		    }
#line 6441 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1849 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), "<<", (yyvsp[0].nd));
		    }
#line 6449 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1853 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_bin_op(p, (yyvsp[-2].nd), ">>", (yyvsp[0].nd));
		    }
#line 6457 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1857 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_and(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6465 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1861 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_or(p, (yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6473 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1865 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_if(p, cond((yyvsp[-5].nd)), (yyvsp[-3].nd), (yyvsp[0].nd));
		    }
#line 6481 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1869 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 6489 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1875 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		      if (!(yyval.nd)) (yyval.nd) = new_nil(p);
		    }
#line 6498 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1883 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 6506 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1887 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-3].nd), new_hash(p, (yyvsp[-1].nd)));
		    }
#line 6514 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1891 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(new_hash(p, (yyvsp[-1].nd)), 0);
		    }
#line 6522 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1897 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 6530 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1909 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((yyvsp[-1].nd),0);
		    }
#line 6538 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1913 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(push((yyvsp[-3].nd), new_hash(p, (yyvsp[-1].nd))), 0);
		    }
#line 6546 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1917 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(list1(new_hash(p, (yyvsp[-1].nd))), 0);
		    }
#line 6554 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1923 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(list1((yyvsp[0].nd)), 0);
		    }
#line 6562 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1927 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((yyvsp[-1].nd), (yyvsp[0].nd));
		    }
#line 6570 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1931 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(list1(new_hash(p, (yyvsp[-1].nd))), (yyvsp[0].nd));
		    }
#line 6578 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1935 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(push((yyvsp[-3].nd), new_hash(p, (yyvsp[-1].nd))), (yyvsp[0].nd));
		    }
#line 6586 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1939 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(0, (yyvsp[0].nd));
		    }
#line 6594 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1944 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.stack) = p->cmdarg_stack;
		      CMDARG_PUSH(1);
		    }
#line 6603 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1949 "src/parse.y" /* yacc.c:1646  */
    {
		      p->cmdarg_stack = (yyvsp[-1].stack);
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 6612 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1956 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_block_arg(p, (yyvsp[0].nd));
		    }
#line 6620 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1962 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 6628 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1966 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 6636 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1972 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((yyvsp[0].nd), 0);
		    }
#line 6644 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1976 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(new_splat(p, (yyvsp[0].nd)), 0);
		    }
#line 6652 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1980 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6660 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1984 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-3].nd), new_splat(p, (yyvsp[0].nd)));
		    }
#line 6668 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1988 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-3].nd), (yyvsp[0].nd));
		    }
#line 6676 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1992 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-4].nd), new_splat(p, (yyvsp[0].nd)));
		    }
#line 6684 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1998 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 6692 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 2002 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-3].nd), new_splat(p, (yyvsp[0].nd)));
		    }
#line 6700 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2006 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(new_splat(p, (yyvsp[0].nd)));
		    }
#line 6708 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2019 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_fcall(p, (yyvsp[0].id), 0);
		    }
#line 6716 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2023 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyvsp[0].stack) = p->cmdarg_stack;
		      p->cmdarg_stack = 0;
		    }
#line 6725 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2029 "src/parse.y" /* yacc.c:1646  */
    {
		      p->cmdarg_stack = (yyvsp[-3].stack);
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 6734 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2033 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_ENDARG;}
#line 6740 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2034 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-2].nd);
		    }
#line 6748 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2037 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_ENDARG;}
#line 6754 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2038 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 6762 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2042 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 6770 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2046 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_colon2(p, (yyvsp[-2].nd), (yyvsp[0].id));
		    }
#line 6778 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2050 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_colon3(p, (yyvsp[0].id));
		    }
#line 6786 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2054 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_array(p, (yyvsp[-1].nd));
		    }
#line 6794 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2058 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_hash(p, (yyvsp[-1].nd));
		    }
#line 6802 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2062 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_return(p, 0);
		    }
#line 6810 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2066 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_yield(p, (yyvsp[-1].nd));
		    }
#line 6818 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2070 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_yield(p, 0);
		    }
#line 6826 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2074 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_yield(p, 0);
		    }
#line 6834 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2078 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, cond((yyvsp[-1].nd)), "!");
		    }
#line 6842 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2082 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = call_uni_op(p, new_nil(p), "!");
		    }
#line 6850 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2086 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_fcall(p, (yyvsp[-1].id), cons(0, (yyvsp[0].nd)));
		    }
#line 6858 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2091 "src/parse.y" /* yacc.c:1646  */
    {
		      call_with_block(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 6867 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2096 "src/parse.y" /* yacc.c:1646  */
    {
		      local_nest(p);
		      (yyval.num) = p->lpar_beg;
		      p->lpar_beg = ++p->paren_nest;
		    }
#line 6877 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2103 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lpar_beg = (yyvsp[-2].num);
		      (yyval.nd) = new_lambda(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      local_unnest(p);
		    }
#line 6887 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2112 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_if(p, cond((yyvsp[-4].nd)), (yyvsp[-2].nd), (yyvsp[-1].nd));
		    }
#line 6895 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2119 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_unless(p, cond((yyvsp[-4].nd)), (yyvsp[-2].nd), (yyvsp[-1].nd));
		    }
#line 6903 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2122 "src/parse.y" /* yacc.c:1646  */
    {COND_PUSH(1);}
#line 6909 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2122 "src/parse.y" /* yacc.c:1646  */
    {COND_POP();}
#line 6915 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2125 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_while(p, cond((yyvsp[-4].nd)), (yyvsp[-1].nd));
		    }
#line 6923 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2128 "src/parse.y" /* yacc.c:1646  */
    {COND_PUSH(1);}
#line 6929 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2128 "src/parse.y" /* yacc.c:1646  */
    {COND_POP();}
#line 6935 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2131 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_until(p, cond((yyvsp[-4].nd)), (yyvsp[-1].nd));
		    }
#line 6943 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2137 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_case(p, (yyvsp[-3].nd), (yyvsp[-1].nd));
		    }
#line 6951 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2141 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_case(p, 0, (yyvsp[-1].nd));
		    }
#line 6959 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2145 "src/parse.y" /* yacc.c:1646  */
    {COND_PUSH(1);}
#line 6965 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2147 "src/parse.y" /* yacc.c:1646  */
    {COND_POP();}
#line 6971 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2150 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_for(p, (yyvsp[-7].nd), (yyvsp[-4].nd), (yyvsp[-1].nd));
		    }
#line 6979 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2154 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "class definition in method body");
		      (yyval.nd) = local_switch(p);
		    }
#line 6989 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2161 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_class(p, (yyvsp[-4].nd), (yyvsp[-3].nd), (yyvsp[-1].nd));
		      local_resume(p, (yyvsp[-2].nd));
		    }
#line 6998 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2166 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.num) = p->in_def;
		      p->in_def = 0;
		    }
#line 7007 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2171 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(local_switch(p), (node*)(intptr_t)p->in_single);
		      p->in_single = 0;
		    }
#line 7016 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2177 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_sclass(p, (yyvsp[-5].nd), (yyvsp[-1].nd));
		      local_resume(p, (yyvsp[-2].nd)->car);
		      p->in_def = (yyvsp[-4].num);
		      p->in_single = (int)(intptr_t)(yyvsp[-2].nd)->cdr;
		    }
#line 7027 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2184 "src/parse.y" /* yacc.c:1646  */
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "module definition in method body");
		      (yyval.nd) = local_switch(p);
		    }
#line 7037 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2191 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_module(p, (yyvsp[-3].nd), (yyvsp[-1].nd));
		      local_resume(p, (yyvsp[-2].nd));
		    }
#line 7046 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2196 "src/parse.y" /* yacc.c:1646  */
    {
		      p->in_def++;
		      (yyval.nd) = local_switch(p);
		    }
#line 7055 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2203 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_def(p, (yyvsp[-4].id), (yyvsp[-2].nd), (yyvsp[-1].nd));
		      local_resume(p, (yyvsp[-3].nd));
		      p->in_def--;
		    }
#line 7065 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2208 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_FNAME;}
#line 7071 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2209 "src/parse.y" /* yacc.c:1646  */
    {
		      p->in_single++;
		      p->lstate = EXPR_ENDFN; /* force for args */
		      (yyval.nd) = local_switch(p);
		    }
#line 7081 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2217 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_sdef(p, (yyvsp[-7].nd), (yyvsp[-4].id), (yyvsp[-2].nd), (yyvsp[-1].nd));
		      local_resume(p, (yyvsp[-3].nd));
		      p->in_single--;
		    }
#line 7091 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2223 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_break(p, 0);
		    }
#line 7099 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2227 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_next(p, 0);
		    }
#line 7107 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2231 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_redo(p);
		    }
#line 7115 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2235 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_retry(p);
		    }
#line 7123 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2241 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		      if (!(yyval.nd)) (yyval.nd) = new_nil(p);
		    }
#line 7132 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2260 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_if(p, cond((yyvsp[-3].nd)), (yyvsp[-1].nd), (yyvsp[0].nd));
		    }
#line 7140 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2267 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7148 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2273 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(list1((yyvsp[0].nd)));
		    }
#line 7156 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2280 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_arg(p, (yyvsp[0].id));
		    }
#line 7164 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2284 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_masgn(p, (yyvsp[-1].nd), 0);
		    }
#line 7172 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2290 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 7180 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2294 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 7188 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2300 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[0].nd),0,0);
		    }
#line 7196 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2304 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-3].nd), new_arg(p, (yyvsp[0].id)), 0);
		    }
#line 7204 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2308 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-5].nd), new_arg(p, (yyvsp[-2].id)), (yyvsp[0].nd));
		    }
#line 7212 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2312 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-2].nd), (node*)-1, 0);
		    }
#line 7220 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2316 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3((yyvsp[-4].nd), (node*)-1, (yyvsp[0].nd));
		    }
#line 7228 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2320 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, new_arg(p, (yyvsp[0].id)), 0);
		    }
#line 7236 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2324 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, new_arg(p, (yyvsp[-2].id)), (yyvsp[0].nd));
		    }
#line 7244 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2328 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, (node*)-1, 0);
		    }
#line 7252 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2332 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list3(0, (node*)-1, (yyvsp[0].nd));
		    }
#line 7260 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2338 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), (yyvsp[-3].nd), (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 7268 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2342 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-7].nd), (yyvsp[-5].nd), (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7276 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2346 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-3].nd), (yyvsp[-1].nd), 0, 0, (yyvsp[0].id));
		    }
#line 7284 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2350 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), (yyvsp[-3].nd), 0, (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7292 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2354 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-3].nd), 0, (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 7300 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2358 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-1].nd), 0, 1, 0, 0);
		    }
#line 7308 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2362 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), 0, (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7316 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2366 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-1].nd), 0, 0, 0, (yyvsp[0].id));
		    }
#line 7324 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2370 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-3].nd), (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 7332 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2374 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-5].nd), (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7340 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2378 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-1].nd), 0, 0, (yyvsp[0].id));
		    }
#line 7348 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2382 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-3].nd), 0, (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7356 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2386 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 7364 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2390 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 7372 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2394 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, 0, 0, (yyvsp[0].id));
		    }
#line 7380 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2401 "src/parse.y" /* yacc.c:1646  */
    {
		      p->cmd_start = TRUE;
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7389 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2408 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, 0);
		      (yyval.nd) = 0;
		    }
#line 7398 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2413 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, 0);
		      (yyval.nd) = 0;
		    }
#line 7407 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2418 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-2].nd);
		    }
#line 7415 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2425 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 7423 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2429 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 7431 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2439 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[0].id));
		      new_bv(p, (yyvsp[0].id));
		    }
#line 7440 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2447 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-2].nd);
		    }
#line 7448 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2451 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7456 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2457 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 7464 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2461 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 7472 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2467 "src/parse.y" /* yacc.c:1646  */
    {
		      local_nest(p);
		    }
#line 7480 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2473 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_block(p,(yyvsp[-2].nd),(yyvsp[-1].nd));
		      local_unnest(p);
		    }
#line 7489 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2480 "src/parse.y" /* yacc.c:1646  */
    {
		      if ((yyvsp[-1].nd)->car == (node*)NODE_YIELD) {
			yyerror(p, "block given to yield");
		      }
		      else {
			call_with_block(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		      }
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 7503 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2490 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 7511 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2494 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), (yyvsp[-1].nd));
		      call_with_block(p, (yyval.nd), (yyvsp[0].nd));
		    }
#line 7520 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2499 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-4].nd), (yyvsp[-2].id), (yyvsp[-1].nd));
		      call_with_block(p, (yyval.nd), (yyvsp[0].nd));
		    }
#line 7529 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2506 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_fcall(p, (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 7537 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2510 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 7545 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2514 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), (yyvsp[-1].id), (yyvsp[0].nd));
		    }
#line 7553 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2518 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), (yyvsp[0].id), 0);
		    }
#line 7561 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2522 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), intern("call",4), (yyvsp[0].nd));
		    }
#line 7569 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2526 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-2].nd), intern("call",4), (yyvsp[0].nd));
		    }
#line 7577 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2530 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_super(p, (yyvsp[0].nd));
		    }
#line 7585 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2534 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_zsuper(p);
		    }
#line 7593 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2538 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_call(p, (yyvsp[-3].nd), intern("[]",2), (yyvsp[-1].nd));
		    }
#line 7601 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2544 "src/parse.y" /* yacc.c:1646  */
    {
		      local_nest(p);
		    }
#line 7609 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2549 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_block(p,(yyvsp[-2].nd),(yyvsp[-1].nd));
		      local_unnest(p);
		    }
#line 7618 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2554 "src/parse.y" /* yacc.c:1646  */
    {
		      local_nest(p);
		    }
#line 7626 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2559 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_block(p,(yyvsp[-2].nd),(yyvsp[-1].nd));
		      local_unnest(p);
		    }
#line 7635 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2568 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(cons((yyvsp[-3].nd), (yyvsp[-1].nd)), (yyvsp[0].nd));
		    }
#line 7643 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2574 "src/parse.y" /* yacc.c:1646  */
    {
		      if ((yyvsp[0].nd)) {
			(yyval.nd) = cons(cons(0, (yyvsp[0].nd)), 0);
		      }
		      else {
			(yyval.nd) = 0;
		      }
		    }
#line 7656 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2588 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(list3((yyvsp[-4].nd), (yyvsp[-3].nd), (yyvsp[-1].nd)));
		      if ((yyvsp[0].nd)) (yyval.nd) = append((yyval.nd), (yyvsp[0].nd));
		    }
#line 7665 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2596 "src/parse.y" /* yacc.c:1646  */
    {
			(yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 7673 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2604 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7681 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2611 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7689 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2626 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		    }
#line 7697 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2630 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_dstr(p, push((yyvsp[-1].nd), (yyvsp[0].nd)));
		    }
#line 7705 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2637 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = append((yyvsp[-1].nd), (yyvsp[0].nd));
		    }
#line 7713 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2643 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 7721 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2647 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = p->lex_strterm;
		      p->lex_strterm = NULL;
		    }
#line 7730 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2653 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lex_strterm = (yyvsp[-2].nd);
		      (yyval.nd) = list2((yyvsp[-3].nd), (yyvsp[-1].nd));
		    }
#line 7739 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2658 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(new_literal_delim(p));
		    }
#line 7747 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2662 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1(new_literal_delim(p));
		    }
#line 7755 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2668 "src/parse.y" /* yacc.c:1646  */
    {
			(yyval.nd) = (yyvsp[0].nd);
		    }
#line 7763 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2672 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_dxstr(p, push((yyvsp[-1].nd), (yyvsp[0].nd)));
		    }
#line 7771 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2678 "src/parse.y" /* yacc.c:1646  */
    {
			(yyval.nd) = (yyvsp[0].nd);
		    }
#line 7779 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2682 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_dregx(p, (yyvsp[-1].nd), (yyvsp[0].nd));
		    }
#line 7787 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2699 "src/parse.y" /* yacc.c:1646  */
    {
		      parser_heredoc_info * inf = parsing_heredoc_inf(p);
		      inf->doc = push(inf->doc, new_str(p, "", 0));
		      heredoc_end(p);
		    }
#line 7797 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2705 "src/parse.y" /* yacc.c:1646  */
    {
		      heredoc_end(p);
		    }
#line 7805 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2715 "src/parse.y" /* yacc.c:1646  */
    {
		      parser_heredoc_info * inf = parsing_heredoc_inf(p);
		      inf->doc = push(inf->doc, (yyvsp[0].nd));
		      heredoc_treat_nextline(p);
		    }
#line 7815 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2721 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = p->lex_strterm;
		      p->lex_strterm = NULL;
		    }
#line 7824 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2727 "src/parse.y" /* yacc.c:1646  */
    {
		      parser_heredoc_info * inf = parsing_heredoc_inf(p);
		      p->lex_strterm = (yyvsp[-2].nd);
		      inf->doc = push(push(inf->doc, (yyvsp[-3].nd)), (yyvsp[-1].nd));
		    }
#line 7834 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2735 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_words(p, list1((yyvsp[0].nd)));
		    }
#line 7842 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2739 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_words(p, push((yyvsp[-1].nd), (yyvsp[0].nd)));
		    }
#line 7850 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2746 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_sym(p, (yyvsp[0].id));
		    }
#line 7858 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2750 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lstate = EXPR_END;
		      (yyval.nd) = new_dsym(p, push((yyvsp[-1].nd), (yyvsp[0].nd)));
		    }
#line 7867 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2757 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lstate = EXPR_END;
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 7876 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2768 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.id) = new_strsym(p, (yyvsp[0].nd));
		    }
#line 7884 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2772 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.id) = new_strsym(p, (yyvsp[0].nd));
		    }
#line 7892 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2778 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_symbols(p, list1((yyvsp[0].nd)));
		    }
#line 7900 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2782 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_symbols(p, push((yyvsp[-1].nd), (yyvsp[0].nd)));
		    }
#line 7908 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2790 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = negate_lit(p, (yyvsp[0].nd));
		    }
#line 7916 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2794 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = negate_lit(p, (yyvsp[0].nd));
		    }
#line 7924 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2800 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_lvar(p, (yyvsp[0].id));
		    }
#line 7932 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2804 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_ivar(p, (yyvsp[0].id));
		    }
#line 7940 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2808 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_gvar(p, (yyvsp[0].id));
		    }
#line 7948 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2812 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_cvar(p, (yyvsp[0].id));
		    }
#line 7956 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2816 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_const(p, (yyvsp[0].id));
		    }
#line 7964 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2822 "src/parse.y" /* yacc.c:1646  */
    {
		      assignable(p, (yyvsp[0].nd));
		    }
#line 7972 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2828 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = var_reference(p, (yyvsp[0].nd));
		    }
#line 7980 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2832 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_nil(p);
		    }
#line 7988 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2836 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_self(p);
   		    }
#line 7996 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2840 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_true(p);
   		    }
#line 8004 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2844 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_false(p);
   		    }
#line 8012 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2848 "src/parse.y" /* yacc.c:1646  */
    {
		      if (!p->filename) {
			p->filename = "(null)";
		      }
		      (yyval.nd) = new_str(p, p->filename, strlen(p->filename));
		    }
#line 8023 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2855 "src/parse.y" /* yacc.c:1646  */
    {
		      char buf[16];

		      snprintf(buf, sizeof(buf), "%d", p->lineno);
		      (yyval.nd) = new_int(p, buf, 10);
		    }
#line 8034 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2868 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 8042 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2872 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lstate = EXPR_BEG;
		      p->cmd_start = TRUE;
		    }
#line 8051 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2877 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 8059 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2881 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerrok;
		      (yyval.nd) = 0;
		    }
#line 8068 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2888 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		      p->lstate = EXPR_BEG;
		      p->cmd_start = TRUE;
		    }
#line 8078 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2894 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 8086 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2900 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), (yyvsp[-3].nd), (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 8094 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2904 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-7].nd), (yyvsp[-5].nd), (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8102 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2908 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-3].nd), (yyvsp[-1].nd), 0, 0, (yyvsp[0].id));
		    }
#line 8110 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2912 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), (yyvsp[-3].nd), 0, (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8118 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2916 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-3].nd), 0, (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 8126 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2920 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-5].nd), 0, (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8134 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2924 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, (yyvsp[-1].nd), 0, 0, 0, (yyvsp[0].id));
		    }
#line 8142 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2928 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-3].nd), (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 8150 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2932 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-5].nd), (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8158 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2936 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-1].nd), 0, 0, (yyvsp[0].id));
		    }
#line 8166 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2940 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, (yyvsp[-3].nd), 0, (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8174 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2944 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, (yyvsp[-1].id), 0, (yyvsp[0].id));
		    }
#line 8182 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2948 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, (yyvsp[-3].id), (yyvsp[-1].nd), (yyvsp[0].id));
		    }
#line 8190 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2952 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_args(p, 0, 0, 0, 0, (yyvsp[0].id));
		    }
#line 8198 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2956 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, 0);
		      (yyval.nd) = new_args(p, 0, 0, 0, 0, 0);
		    }
#line 8207 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2963 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "formal argument cannot be a constant");
		      (yyval.nd) = 0;
		    }
#line 8216 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2968 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "formal argument cannot be an instance variable");
		      (yyval.nd) = 0;
		    }
#line 8225 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2973 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "formal argument cannot be a global variable");
		      (yyval.nd) = 0;
		    }
#line 8234 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2978 "src/parse.y" /* yacc.c:1646  */
    {
		      yyerror(p, "formal argument cannot be a class variable");
		      (yyval.nd) = 0;
		    }
#line 8243 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2985 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.id) = 0;
		    }
#line 8251 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2989 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[0].id));
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 8260 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2996 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_arg(p, (yyvsp[0].id));
		    }
#line 8268 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3000 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = new_masgn(p, (yyvsp[-1].nd), 0);
		    }
#line 8276 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3006 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 8284 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3010 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 8292 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3016 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[-2].id));
		      (yyval.nd) = cons(nsym((yyvsp[-2].id)), (yyvsp[0].nd));
		    }
#line 8301 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3023 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[-2].id));
		      (yyval.nd) = cons(nsym((yyvsp[-2].id)), (yyvsp[0].nd));
		    }
#line 8310 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3030 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 8318 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3034 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 8326 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3040 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 8334 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3044 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 8342 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3054 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[0].id));
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 8351 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3059 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, 0);
		      (yyval.id) = -1;
		    }
#line 8360 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3070 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, (yyvsp[0].id));
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 8369 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3077 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.id) = (yyvsp[0].id);
		    }
#line 8377 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3081 "src/parse.y" /* yacc.c:1646  */
    {
		      local_add_f(p, 0);
		      (yyval.id) = 0;
		    }
#line 8386 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3088 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[0].nd);
		      if (!(yyval.nd)) (yyval.nd) = new_nil(p);
		    }
#line 8395 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3092 "src/parse.y" /* yacc.c:1646  */
    {p->lstate = EXPR_BEG;}
#line 8401 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3093 "src/parse.y" /* yacc.c:1646  */
    {
		      if ((yyvsp[-1].nd) == 0) {
			yyerror(p, "can't define singleton method for ().");
		      }
		      else {
			switch ((enum node_type)(int)(intptr_t)(yyvsp[-1].nd)->car) {
			case NODE_STR:
			case NODE_DSTR:
			case NODE_XSTR:
			case NODE_DXSTR:
			case NODE_DREGX:
			case NODE_MATCH:
			case NODE_FLOAT:
			case NODE_ARRAY:
			case NODE_HEREDOC:
			  yyerror(p, "can't define singleton method for literals");
			default:
			  break;
			}
		      }
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 8428 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3119 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = (yyvsp[-1].nd);
		    }
#line 8436 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3125 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = list1((yyvsp[0].nd));
		    }
#line 8444 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3129 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = push((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 8452 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3135 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons((yyvsp[-2].nd), (yyvsp[0].nd));
		    }
#line 8460 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3139 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = cons(new_sym(p, (yyvsp[-1].id)), (yyvsp[0].nd));
		    }
#line 8468 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3183 "src/parse.y" /* yacc.c:1646  */
    {yyerrok;}
#line 8474 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3188 "src/parse.y" /* yacc.c:1646  */
    {
		      p->lineno++;
		      p->column = 0;
		    }
#line 8483 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3195 "src/parse.y" /* yacc.c:1646  */
    {yyerrok;}
#line 8489 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3199 "src/parse.y" /* yacc.c:1646  */
    {
		      (yyval.nd) = 0;
		    }
#line 8497 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
    break;


#line 8501 "/home/iurt/rpmbuild/BUILD/TSC-2.0.0/mruby/mruby/build/host/src/y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (p, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (p, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, p);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, p);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (p, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, p);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, p);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3203 "src/parse.y" /* yacc.c:1906  */

#define yylval  (*((YYSTYPE*)(p->ylval)))

static void
yyerror(parser_state *p, const char *s)
{
  char* c;
  int n;

  if (! p->capture_errors) {
#ifdef ENABLE_STDIO
    if (p->filename) {
      fprintf(stderr, "%s:%d:%d: %s\n", p->filename, p->lineno, p->column, s);
    }
    else {
      fprintf(stderr, "line %d:%d: %s\n", p->lineno, p->column, s);
    }
#endif
  }
  else if (p->nerr < sizeof(p->error_buffer) / sizeof(p->error_buffer[0])) {
    n = strlen(s);
    c = (char *)parser_palloc(p, n + 1);
    memcpy(c, s, n + 1);
    p->error_buffer[p->nerr].message = c;
    p->error_buffer[p->nerr].lineno = p->lineno;
    p->error_buffer[p->nerr].column = p->column;
  }
  p->nerr++;
}

static void
yyerror_i(parser_state *p, const char *fmt, int i)
{
  char buf[256];

  snprintf(buf, sizeof(buf), fmt, i);
  yyerror(p, buf);
}

static void
yywarn(parser_state *p, const char *s)
{
  char* c;
  int n;

  if (! p->capture_errors) {
#ifdef ENABLE_STDIO
    if (p->filename) {
      fprintf(stderr, "%s:%d:%d: %s\n", p->filename, p->lineno, p->column, s);
    }
    else {
      fprintf(stderr, "line %d:%d: %s\n", p->lineno, p->column, s);
    }
#endif
  }
  else if (p->nwarn < sizeof(p->warn_buffer) / sizeof(p->warn_buffer[0])) {
    n = strlen(s);
    c = (char *)parser_palloc(p, n + 1);
    memcpy(c, s, n + 1);
    p->warn_buffer[p->nwarn].message = c;
    p->warn_buffer[p->nwarn].lineno = p->lineno;
    p->warn_buffer[p->nwarn].column = p->column;
  }
  p->nwarn++;
}

static void
yywarning(parser_state *p, const char *s)
{
  yywarn(p, s);
}

static void
yywarning_s(parser_state *p, const char *fmt, const char *s)
{
  char buf[256];

  snprintf(buf, sizeof(buf), fmt, s);
  yywarning(p, buf);
}

static void
backref_error(parser_state *p, node *n)
{
  int c;

  c = (int)(intptr_t)n->car;

  if (c == NODE_NTH_REF) {
    yyerror_i(p, "can't set variable $%d", (int)(intptr_t)n->cdr);
  } else if (c == NODE_BACK_REF) {
    yyerror_i(p, "can't set variable $%c", (int)(intptr_t)n->cdr);
  } else {
    mrb_bug(p->mrb, "Internal error in backref_error() : n=>car == %d", c);
  }
}

static int peeks(parser_state *p, const char *s);
static int skips(parser_state *p, const char *s);

static inline int
nextc(parser_state *p)
{
  int c;

  if (p->pb) {
    node *tmp;

    c = (int)(intptr_t)p->pb->car;
    tmp = p->pb;
    p->pb = p->pb->cdr;
    cons_free(tmp);
  }
  else {
#ifdef ENABLE_STDIO
    if (p->f) {
      if (feof(p->f)) goto eof;
      c = fgetc(p->f);
      if (c == EOF) goto eof;
    }
    else
#endif
    if (!p->s || p->s >= p->send) {
       goto eof;
    }
    else {
      c = (unsigned char)*p->s++;
    }
  }
  p->column++;
  return c;

 eof:
  if (!p->cxt) return -1;
  else {
    if (p->cxt->partial_hook(p) < 0)
      return -1;
    return -2;
  }
}

static void
pushback(parser_state *p, int c)
{
  if (c < 0) return;
  p->column--;
  p->pb = cons((node*)(intptr_t)c, p->pb);
}

static void
skip(parser_state *p, char term)
{
  int c;

  for (;;) {
    c = nextc(p);
    if (c < 0) break;
    if (c == term) break;
  }
}

static int
peek_n(parser_state *p, int c, int n)
{
  node *list = 0;
  int c0;

  do {
    c0 = nextc(p);
    if (c0 < 0) return FALSE;
    list = push(list, (node*)(intptr_t)c0);
  } while(n--);
  if (p->pb) {
    p->pb = append(p->pb, (node*)list);
  }
  else {
    p->pb = list;
  }
  if (c0 == c) return TRUE;
  return FALSE;
}
#define peek(p,c) peek_n((p), (c), 0)

static int
peeks(parser_state *p, const char *s)
{
  int len = strlen(s);

#ifdef ENABLE_STDIO
  if (p->f) {
    int n = 0;
    while (*s) {
      if (!peek_n(p, *s++, n++)) return FALSE;
    }
    return TRUE;
  }
  else
#endif
  if (p->s && p->s + len >= p->send) {
    if (memcmp(p->s, s, len) == 0) return TRUE;
  }
  return FALSE;
}

static int
skips(parser_state *p, const char *s)
{
  int c;

  for (;;) {
    // skip until first char
    for (;;) {
      c = nextc(p);
      if (c < 0) return c;
      if (c == *s) break;
    }
    s++;
    if (peeks(p, s)) {
      int len = strlen(s);

      while (len--) {
	nextc(p);
      }
      return TRUE;
    }
	else{
      s--;
    }
  }
  return FALSE;
}


static int
newtok(parser_state *p)
{
  p->bidx = 0;
  return p->column - 1;
}

static void
tokadd(parser_state *p, int c)
{
  if (p->bidx < MRB_PARSER_BUF_SIZE) {
    p->buf[p->bidx++] = c;
  }
}

static int
toklast(parser_state *p)
{
  return p->buf[p->bidx-1];
}

static void
tokfix(parser_state *p)
{
  if (p->bidx >= MRB_PARSER_BUF_SIZE) {
    yyerror(p, "string too long (truncated)");
  }
  p->buf[p->bidx] = '\0';
}

static const char*
tok(parser_state *p)
{
  return p->buf;
}

static int
toklen(parser_state *p)
{
  return p->bidx;
}

#define IS_ARG() (p->lstate == EXPR_ARG || p->lstate == EXPR_CMDARG)
#define IS_END() (p->lstate == EXPR_END || p->lstate == EXPR_ENDARG || p->lstate == EXPR_ENDFN)
#define IS_BEG() (p->lstate == EXPR_BEG || p->lstate == EXPR_MID || p->lstate == EXPR_VALUE || p->lstate == EXPR_CLASS)
#define IS_SPCARG(c) (IS_ARG() && space_seen && !ISSPACE(c))
#define IS_LABEL_POSSIBLE() ((p->lstate == EXPR_BEG && !cmd_state) || IS_ARG())
#define IS_LABEL_SUFFIX(n) (peek_n(p, ':',(n)) && !peek_n(p, ':', (n)+1))

static int
scan_oct(const int *start, int len, int *retlen)
{
  const int *s = start;
  int retval = 0;

  /* mrb_assert(len <= 3) */
  while (len-- && *s >= '0' && *s <= '7') {
    retval <<= 3;
    retval |= *s++ - '0';
  }
  *retlen = s - start;

  return retval;
}

static int
scan_hex(const int *start, int len, int *retlen)
{
  static const char hexdigit[] = "0123456789abcdef0123456789ABCDEF";
  register const int *s = start;
  register int retval = 0;
  char *tmp;

  /* mrb_assert(len <= 2) */
  while (len-- && *s && (tmp = (char*)strchr(hexdigit, *s))) {
    retval <<= 4;
    retval |= (tmp - hexdigit) & 15;
    s++;
  }
  *retlen = s - start;

  return retval;
}

static int
read_escape(parser_state *p)
{
  int c;

  switch (c = nextc(p)) {
  case '\\':	/* Backslash */
    return c;

  case 'n':	/* newline */
    return '\n';

  case 't':	/* horizontal tab */
    return '\t';

  case 'r':	/* carriage-return */
    return '\r';

  case 'f':	/* form-feed */
    return '\f';

  case 'v':	/* vertical tab */
    return '\13';

  case 'a':	/* alarm(bell) */
    return '\007';

  case 'e':	/* escape */
    return 033;

  case '0': case '1': case '2': case '3': /* octal constant */
  case '4': case '5': case '6': case '7':
    {
      int buf[3];
      int i;

      buf[0] = c;
      for (i=1; i<3; i++) {
	buf[i] = nextc(p);
	if (buf[i] < 0) goto eof;
	if (buf[i] < '0' || '7' < buf[i]) {
	  pushback(p, buf[i]);
	  break;
	}
      }
      c = scan_oct(buf, i, &i);
    }
    return c;

  case 'x':	/* hex constant */
    {
      int buf[2];
      int i;

      for (i=0; i<2; i++) {
	buf[i] = nextc(p);
	if (buf[i] < 0) goto eof;
	if (!ISXDIGIT(buf[i])) {
	  pushback(p, buf[i]);
	  break;
	}
      }
      c = scan_hex(buf, i, &i);
      if (i == 0) {
	yyerror(p, "Invalid escape character syntax");
	return 0;
      }
    }
    return c;

  case 'b':	/* backspace */
    return '\010';

  case 's':	/* space */
    return ' ';

  case 'M':
    if ((c = nextc(p)) != '-') {
      yyerror(p, "Invalid escape character syntax");
      pushback(p, c);
      return '\0';
    }
    if ((c = nextc(p)) == '\\') {
      return read_escape(p) | 0x80;
    }
    else if (c < 0) goto eof;
    else {
      return ((c & 0xff) | 0x80);
    }

  case 'C':
    if ((c = nextc(p)) != '-') {
      yyerror(p, "Invalid escape character syntax");
      pushback(p, c);
      return '\0';
    }
  case 'c':
    if ((c = nextc(p))== '\\') {
      c = read_escape(p);
    }
    else if (c == '?')
      return 0177;
    else if (c < 0) goto eof;
    return c & 0x9f;

  eof:
  case -1:
  case -2:
    yyerror(p, "Invalid escape character syntax");
    return '\0';

  default:
    return c;
  }
}


static int
parse_string(parser_state *p)
{
  int c;
  string_type type = (string_type)(intptr_t)p->lex_strterm->car;
  int nest_level = (intptr_t)p->lex_strterm->cdr->car;
  int beg = (intptr_t)p->lex_strterm->cdr->cdr->car;
  int end = (intptr_t)p->lex_strterm->cdr->cdr->cdr;
  parser_heredoc_info *hinf = (type & STR_FUNC_HEREDOC) ? parsing_heredoc_inf(p) : NULL;

  newtok(p);
  while ((c = nextc(p)) != end || nest_level != 0) {
    if (hinf && (c == '\n' || c < 0)) {
      int line_head;
      tokadd(p, '\n');
      tokfix(p);
      p->lineno++;
      p->column = 0;
      line_head = hinf->line_head;
      hinf->line_head = TRUE;
      if (line_head) {
	/* check whether end of heredoc */
	const char *s = tok(p);
	int len = toklen(p);
	if (hinf->allow_indent) {
	  while (ISSPACE(*s) && len > 0) {
	    ++s;
	    --len;
	  }
	}
	if ((len-1 == hinf->term_len) && (strncmp(s, hinf->term, len-1) == 0)) {
	  return tHEREDOC_END;
	}
      }
      if (c < 0) {
	char buf[256];
	snprintf(buf, sizeof(buf), "can't find heredoc delimiter \"%s\" anywhere before EOF", hinf->term);
	yyerror(p, buf);
	return 0;
      }
      yylval.nd = new_str(p, tok(p), toklen(p));
      return tHD_STRING_MID;
    }
    if (c < 0) {
      yyerror(p, "unterminated string meets end of file");
      return 0;
    }
    else if (c == beg) {
      nest_level++;
      p->lex_strterm->cdr->car = (node*)(intptr_t)nest_level;
    }
    else if (c == end) {
      nest_level--;
      p->lex_strterm->cdr->car = (node*)(intptr_t)nest_level;
    }
    else if (c == '\\') {
      c = nextc(p);
      if (type & STR_FUNC_EXPAND) {
	if (c == end || c == beg) {
	  tokadd(p, c);
	}
	else if ((c == '\n') && (type & STR_FUNC_ARRAY)) {
	  p->lineno++;
	  p->column = 0;
	  tokadd(p, '\n');
	}
	else {
	  if (type & STR_FUNC_REGEXP) {
	    tokadd(p, '\\');
	    if (c >= 0)
	      tokadd(p, c);
	  } else {
	    pushback(p, c);
	    tokadd(p, read_escape(p));
	  }
	  if (hinf)
	    hinf->line_head = FALSE;
	}
      } else {
	if (c != beg && c != end) {
	  switch (c) {
	  case '\n':
	    p->lineno++;
	    p->column = 0;
	    break;

	  case '\\':
	    break;

	  default:
	    if (! ISSPACE(c))
	      tokadd(p, '\\');
	  }
	}
	tokadd(p, c);
      }
      continue;
    }
    else if ((c == '#') && (type & STR_FUNC_EXPAND)) {
      c = nextc(p);
      if (c == '{') {
	tokfix(p);
	p->lstate = EXPR_BEG;
	p->cmd_start = TRUE;
	yylval.nd = new_str(p, tok(p), toklen(p));
	if (hinf) {
	  hinf->line_head = FALSE;
	  return tHD_STRING_PART;
	}
	return tSTRING_PART;
      }
      tokadd(p, '#');
      pushback(p, c);
      continue;
    }
    if ((type & STR_FUNC_ARRAY) && ISSPACE(c)) {
      if (toklen(p) == 0) {
	do {
	  if (c == '\n') {
	    p->lineno++;
	    p->column = 0;
	    heredoc_treat_nextline(p);
	    if (p->parsing_heredoc != NULL) {
	      return tHD_LITERAL_DELIM;
	    }
	  }
	} while (ISSPACE(c = nextc(p)));
	pushback(p, c);
	return tLITERAL_DELIM;
      } else {
	pushback(p, c);
	tokfix(p);
	yylval.nd = new_str(p, tok(p), toklen(p));
	return tSTRING_MID;
      }
    }

    tokadd(p, c);

  }

  tokfix(p);
  p->lstate = EXPR_END;
  end_strterm(p);

  if (type & STR_FUNC_XQUOTE) {
    yylval.nd = new_xstr(p, tok(p), toklen(p));
    return tXSTRING;
  }

  if (type & STR_FUNC_REGEXP) {
    int f = 0;
    int c;
    char *s = strndup(tok(p), toklen(p));
    char flags[3];
    char *flag = flags;
    char *dup;

    newtok(p);
    while (c = nextc(p), c >= 0 && ISALPHA(c)) {
      switch (c) {
      case 'i': f |= 1; break;
      case 'x': f |= 2; break;
      case 'm': f |= 4; break;
      default: tokadd(p, c); break;
      }
    }
    pushback(p, c);
    if (toklen(p)) {
      char msg[128];
      tokfix(p);
      snprintf(msg, sizeof(msg), "unknown regexp option%s - %s",
	  toklen(p) > 1 ? "s" : "", tok(p));
      yyerror(p, msg);
    }
    if (f != 0) {
      if (f & 1) *flag++ = 'i';
      if (f & 2) *flag++ = 'x';
      if (f & 4) *flag++ = 'm';
      dup = strndup(flags, (size_t)(flag - flags));
    }
    else {
      dup = NULL;
    }
    yylval.nd = new_regx(p, s, dup);

    return tREGEXP;
  }

  yylval.nd = new_str(p, tok(p), toklen(p));
  return tSTRING;
}


static int
heredoc_identifier(parser_state *p)
{
  int c;
  int type = str_heredoc;
  int indent = FALSE;
  int quote = FALSE;
  node *newnode;
  parser_heredoc_info *info;

  c = nextc(p);
  if (ISSPACE(c) || c == '=') {
    pushback(p, c);
    return 0;
  }
  if (c == '-') {
    indent = TRUE;
    c = nextc(p);
  }
  if (c == '\'' || c == '"') {
    int term = c;
    if (c == '\'')
      quote = TRUE;
    newtok(p);
    while ((c = nextc(p)) >= 0 && c != term) {
      if (c == '\n') {
	c = -1;
	break;
      }
      tokadd(p, c);
    }
    if (c < 0) {
      yyerror(p, "unterminated here document identifier");
      return 0;
    }
  } else {
    if (c < 0) {
      return 0;                 /* missing here document identifier */
    }
    if (! identchar(c)) {
      pushback(p, c);
      if (indent) pushback(p, '-');
      return 0;
    }
    newtok(p);
    do {
      tokadd(p, c);
    } while ((c = nextc(p)) >= 0 && identchar(c));
    pushback(p, c);
  }
  tokfix(p);
  newnode = new_heredoc(p);
  info = (parser_heredoc_info*)newnode->cdr;
  info->term = strndup(tok(p), toklen(p));
  info->term_len = toklen(p);
  if (! quote)
    type |= STR_FUNC_EXPAND;
  info->type = (string_type)type;
  info->allow_indent = indent;
  info->line_head = TRUE;
  info->doc = NULL;
  p->heredocs_from_nextline = push(p->heredocs_from_nextline, newnode);
  p->lstate = EXPR_END;

  yylval.nd = newnode;
  return tHEREDOC_BEG;
}

static int
arg_ambiguous(parser_state *p)
{
  yywarning(p, "ambiguous first argument; put parentheses or even spaces");
  return 1;
}

#include "lex.def"

static int
parser_yylex(parser_state *p)
{
  register int c;
  int space_seen = 0;
  int cmd_state;
  enum mrb_lex_state_enum last_state;
  int token_column;

  if (p->lex_strterm) {
    if (is_strterm_type(p, STR_FUNC_HEREDOC)) {
      if (p->parsing_heredoc != NULL)
	return parse_string(p);
    }
    else
      return parse_string(p);
  }
  cmd_state = p->cmd_start;
  p->cmd_start = FALSE;
 retry:
  last_state = p->lstate;
  switch (c = nextc(p)) {
  case '\0':    /* NUL */
  case '\004':  /* ^D */
  case '\032':  /* ^Z */
    return 0;
  case -1:      /* end of script. */
    if (p->heredocs_from_nextline)
      goto maybe_heredoc;
    return 0;

  /* white spaces */
  case ' ': case '\t': case '\f': case '\r':
  case '\13':   /* '\v' */
    space_seen = 1;
    goto retry;

  case '#':     /* it's a comment */
    skip(p, '\n');
  /* fall through */
  case -2:      /* end of partial script. */
  case '\n':
  maybe_heredoc:
    heredoc_treat_nextline(p);
    switch (p->lstate) {
    case EXPR_BEG:
    case EXPR_FNAME:
    case EXPR_DOT:
    case EXPR_CLASS:
    case EXPR_VALUE:
      p->lineno++;
      p->column = 0;
      if (p->parsing_heredoc != NULL) {
	return parse_string(p);
      }
      goto retry;
    default:
      break;
    }
    if (p->parsing_heredoc != NULL) {
      return '\n';
    }
    while ((c = nextc(p))) {
      switch (c) {
      case ' ': case '\t': case '\f': case '\r':
      case '\13': /* '\v' */
	space_seen = 1;
	break;
      case '.':
	if ((c = nextc(p)) != '.') {
	  pushback(p, c);
	  pushback(p, '.');
	  goto retry;
	}
      case -1:			/* EOF */
      case -2:			/* end of partial script */
	goto normal_newline;
      default:
	pushback(p, c);
	goto normal_newline;
      }
    }
  normal_newline:
    p->cmd_start = TRUE;
    p->lstate = EXPR_BEG;
    return '\n';

  case '*':
    if ((c = nextc(p)) == '*') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("**",2);
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      c = tPOW;
    }
    else {
      if (c == '=') {
	yylval.id = intern_c('*');
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      if (IS_SPCARG(c)) {
	yywarning(p, "`*' interpreted as argument prefix");
	c = tSTAR;
      }
      else if (IS_BEG()) {
	c = tSTAR;
      }
      else {
	c = '*';
      }
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    return c;

  case '!':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return '!';
      }
    }
    else {
      p->lstate = EXPR_BEG;
    }
    if (c == '=') {
      return tNEQ;
    }
    if (c == '~') {
      return tNMATCH;
    }
    pushback(p, c);
    return '!';

  case '=':
    if (p->column == 1) {
      if (peeks(p, "begin\n")) {
	skips(p, "\n=end\n");
      goto retry;
      }
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    if ((c = nextc(p)) == '=') {
      if ((c = nextc(p)) == '=') {
	return tEQQ;
      }
      pushback(p, c);
      return tEQ;
    }
    if (c == '~') {
      return tMATCH;
    }
    else if (c == '>') {
      return tASSOC;
    }
    pushback(p, c);
    return '=';

  case '<':
    last_state = p->lstate;
    c = nextc(p);
    if (c == '<' &&
	p->lstate != EXPR_DOT &&
	p->lstate != EXPR_CLASS &&
	!IS_END() &&
	(!IS_ARG() || space_seen)) {
      int token = heredoc_identifier(p);
      if (token)
	return token;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
      if (p->lstate == EXPR_CLASS) {
	p->cmd_start = TRUE;
      }
    }
    if (c == '=') {
      if ((c = nextc(p)) == '>') {
	return tCMP;
      }
      pushback(p, c);
      return tLEQ;
    }
    if (c == '<') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("<<",2);
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tLSHFT;
    }
    pushback(p, c);
    return '<';

  case '>':
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    if ((c = nextc(p)) == '=') {
      return tGEQ;
    }
    if (c == '>') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern(">>",2);
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tRSHFT;
    }
    pushback(p, c);
    return '>';

  case '"':
    p->lex_strterm = new_strterm(p, str_dquote, '"', 0);
    return tSTRING_BEG;

  case '\'':
    p->lex_strterm = new_strterm(p, str_squote, '\'', 0);
    return parse_string(p);

  case '`':
    if (p->lstate == EXPR_FNAME) {
      p->lstate = EXPR_ENDFN;
      return '`';
    }
    if (p->lstate == EXPR_DOT) {
      if (cmd_state)
	p->lstate = EXPR_CMDARG;
      else
	p->lstate = EXPR_ARG;
      return '`';
    }
    p->lex_strterm = new_strterm(p, str_xquote, '`', 0);
    return tXSTRING_BEG;

  case '?':
    if (IS_END()) {
      p->lstate = EXPR_VALUE;
      return '?';
    }
    c = nextc(p);
    if (c < 0) {
      yyerror(p, "incomplete character syntax");
      return 0;
    }
    if (isspace(c)) {
      if (!IS_ARG()) {
	int c2;
	switch (c) {
	case ' ':
	  c2 = 's';
	  break;
	case '\n':
	  c2 = 'n';
	  break;
	case '\t':
	  c2 = 't';
	  break;
	case '\v':
	  c2 = 'v';
	  break;
	case '\r':
	  c2 = 'r';
	  break;
	case '\f':
	  c2 = 'f';
	  break;
	default:
	  c2 = 0;
	  break;
	}
	if (c2) {
	  char buf[256];
	  snprintf(buf, sizeof(buf), "invalid character syntax; use ?\\%c", c2);
	  yyerror(p, buf);
	}
      }
    ternary:
      pushback(p, c);
      p->lstate = EXPR_VALUE;
      return '?';
    }
    token_column = newtok(p);
    // need support UTF-8 if configured
    if ((isalnum(c) || c == '_')) {
      int c2 = nextc(p);
      pushback(p, c2);
      if ((isalnum(c2) || c2 == '_')) {
	goto ternary;
      }
    }
    if (c == '\\') {
      c = nextc(p);
      if (c == 'u') {
#if 0
	tokadd_utf8(p);
#endif
      }
      else {
	pushback(p, c);
	c = read_escape(p);
	tokadd(p, c);
      }
    }
    else {
      tokadd(p, c);
    }
    tokfix(p);
    yylval.nd = new_str(p, tok(p), toklen(p));
    p->lstate = EXPR_END;
    return tCHAR;

  case '&':
    if ((c = nextc(p)) == '&') {
      p->lstate = EXPR_BEG;
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("&&",2);
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tANDOP;
    }
    else if (c == '=') {
      yylval.id = intern_c('&');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    pushback(p, c);
    if (IS_SPCARG(c)) {
      yywarning(p, "`&' interpreted as argument prefix");
      c = tAMPER;
    }
    else if (IS_BEG()) {
      c = tAMPER;
    }
    else {
      c = '&';
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    return c;

  case '|':
    if ((c = nextc(p)) == '|') {
      p->lstate = EXPR_BEG;
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("||",2);
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tOROP;
    }
    if (c == '=') {
      yylval.id = intern_c('|');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    }
    else {
      p->lstate = EXPR_BEG;
    }
    pushback(p, c);
    return '|';

  case '+':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return tUPLUS;
      }
      pushback(p, c);
      return '+';
    }
    if (c == '=') {
      yylval.id = intern_c('+');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (IS_BEG() || (IS_SPCARG(c) && arg_ambiguous(p))) {
      p->lstate = EXPR_BEG;
      pushback(p, c);
      if (c >= 0 && ISDIGIT(c)) {
	c = '+';
	goto start_num;
      }
      return tUPLUS;
    }
    p->lstate = EXPR_BEG;
    pushback(p, c);
    return '+';

  case '-':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return tUMINUS;
      }
      pushback(p, c);
      return '-';
    }
    if (c == '=') {
      yylval.id = intern_c('-');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (c == '>') {
      p->lstate = EXPR_ENDFN;
      return tLAMBDA;
    }
    if (IS_BEG() || (IS_SPCARG(c) && arg_ambiguous(p))) {
      p->lstate = EXPR_BEG;
      pushback(p, c);
      if (c >= 0 && ISDIGIT(c)) {
	return tUMINUS_NUM;
      }
      return tUMINUS;
    }
    p->lstate = EXPR_BEG;
    pushback(p, c);
    return '-';

  case '.':
    p->lstate = EXPR_BEG;
    if ((c = nextc(p)) == '.') {
      if ((c = nextc(p)) == '.') {
	return tDOT3;
      }
      pushback(p, c);
      return tDOT2;
    }
    pushback(p, c);
    if (c >= 0 && ISDIGIT(c)) {
      yyerror(p, "no .<digit> floating literal anymore; put 0 before dot");
    }
    p->lstate = EXPR_DOT;
    return '.';

  start_num:
  case '0': case '1': case '2': case '3': case '4':
  case '5': case '6': case '7': case '8': case '9':
    {
      int is_float, seen_point, seen_e, nondigit;

      is_float = seen_point = seen_e = nondigit = 0;
      p->lstate = EXPR_END;
      token_column = newtok(p);
      if (c == '-' || c == '+') {
	tokadd(p, c);
	c = nextc(p);
      }
      if (c == '0') {
#define no_digits() do {yyerror(p,"numeric literal without digits"); return 0;} while (0)
	int start = toklen(p);
	c = nextc(p);
	if (c == 'x' || c == 'X') {
	  /* hexadecimal */
	  c = nextc(p);
	  if (c >= 0 && ISXDIGIT(c)) {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (!ISXDIGIT(c)) break;
	      nondigit = 0;
	      tokadd(p, tolower(c));
	    } while ((c = nextc(p)) >= 0);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.nd = new_int(p, tok(p), 16);
	  return tINTEGER;
	}
	if (c == 'b' || c == 'B') {
	  /* binary */
	  c = nextc(p);
	  if (c == '0' || c == '1') {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (c != '0' && c != '1') break;
	      nondigit = 0;
	      tokadd(p, c);
	    } while ((c = nextc(p)) >= 0);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.nd = new_int(p, tok(p), 2);
	  return tINTEGER;
	}
	if (c == 'd' || c == 'D') {
	  /* decimal */
	  c = nextc(p);
	  if (c >= 0 && ISDIGIT(c)) {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (!ISDIGIT(c)) break;
	      nondigit = 0;
	      tokadd(p, c);
	    } while ((c = nextc(p)) >= 0);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.nd = new_int(p, tok(p), 10);
	  return tINTEGER;
	}
	if (c == '_') {
	  /* 0_0 */
	  goto octal_number;
	}
	if (c == 'o' || c == 'O') {
	  /* prefixed octal */
	  c = nextc(p);
	  if (c < 0 || c == '_' || !ISDIGIT(c)) {
	    no_digits();
	  }
	}
	if (c >= '0' && c <= '7') {
	  /* octal */
	octal_number:
	  do {
	    if (c == '_') {
	      if (nondigit) break;
	      nondigit = c;
	      continue;
	    }
	    if (c < '0' || c > '9') break;
	    if (c > '7') goto invalid_octal;
	    nondigit = 0;
	    tokadd(p, c);
	  } while ((c = nextc(p)) >= 0);

	  if (toklen(p) > start) {
	    pushback(p, c);
	    tokfix(p);
	    if (nondigit) goto trailing_uc;
	    yylval.nd = new_int(p, tok(p), 8);
	    return tINTEGER;
	  }
	  if (nondigit) {
	    pushback(p, c);
	    goto trailing_uc;
	  }
	}
	if (c > '7' && c <= '9') {
	invalid_octal:
	  yyerror(p, "Invalid octal digit");
	}
	else if (c == '.' || c == 'e' || c == 'E') {
	  tokadd(p, '0');
	}
	else {
	  pushback(p, c);
	  yylval.nd = new_int(p, "0", 10);
	  return tINTEGER;
	}
      }

      for (;;) {
	switch (c) {
	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
	  nondigit = 0;
	  tokadd(p, c);
	  break;

	case '.':
	  if (nondigit) goto trailing_uc;
	  if (seen_point || seen_e) {
	    goto decode_num;
	  }
	  else {
	    int c0 = nextc(p);
	    if (c0 < 0 || !ISDIGIT(c0)) {
	      pushback(p, c0);
	      goto decode_num;
	    }
	    c = c0;
	  }
	  tokadd(p, '.');
	  tokadd(p, c);
	  is_float++;
	  seen_point++;
	  nondigit = 0;
	  break;

	case 'e':
	case 'E':
	  if (nondigit) {
	    pushback(p, c);
	    c = nondigit;
	    goto decode_num;
	  }
	  if (seen_e) {
	    goto decode_num;
	  }
	  tokadd(p, c);
	  seen_e++;
	  is_float++;
	  nondigit = c;
	  c = nextc(p);
	  if (c != '-' && c != '+') continue;
	  tokadd(p, c);
	  nondigit = c;
	  break;

	case '_':	/* `_' in number just ignored */
	  if (nondigit) goto decode_num;
	  nondigit = c;
	  break;

	default:
	  goto decode_num;
	}
	c = nextc(p);
      }

    decode_num:
      pushback(p, c);
      if (nondigit) {
      trailing_uc:
	yyerror_i(p, "trailing `%c' in number", nondigit);
      }
      tokfix(p);
      if (is_float) {
	double d;
	char *endp;

	errno = 0;
	d = strtod(tok(p), &endp);
	if (d == 0 && endp == tok(p)) {
	  yywarning_s(p, "corrupted float value %s", tok(p));
	}
	else if (errno == ERANGE) {
	  yywarning_s(p, "float %s out of range", tok(p));
	  errno = 0;
	}
	yylval.nd = new_float(p, tok(p));
	return tFLOAT;
      }
      yylval.nd = new_int(p, tok(p), 10);
      return tINTEGER;
    }

  case ')':
  case ']':
    p->paren_nest--;
  case '}':
    COND_LEXPOP();
    CMDARG_LEXPOP();
    if (c == ')')
      p->lstate = EXPR_ENDFN;
    else
      p->lstate = EXPR_ENDARG;
    return c;

  case ':':
    c = nextc(p);
    if (c == ':') {
      if (IS_BEG() || p->lstate == EXPR_CLASS || IS_SPCARG(-1)) {
	p->lstate = EXPR_BEG;
	return tCOLON3;
      }
      p->lstate = EXPR_DOT;
      return tCOLON2;
    }
    if (IS_END() || ISSPACE(c)) {
      pushback(p, c);
      p->lstate = EXPR_BEG;
      return ':';
    }
    pushback(p, c);
    p->lstate = EXPR_FNAME;
    return tSYMBEG;

  case '/':
    if (IS_BEG()) {
      p->lex_strterm = new_strterm(p, str_regexp, '/', 0);
      return tREGEXP_BEG;
    }
    if ((c = nextc(p)) == '=') {
      yylval.id = intern_c('/');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    pushback(p, c);
    if (IS_SPCARG(c)) {
      p->lex_strterm = new_strterm(p, str_regexp, '/', 0);
      return tREGEXP_BEG;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    return '/';

  case '^':
    if ((c = nextc(p)) == '=') {
      yylval.id = intern_c('^');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    pushback(p, c);
    return '^';

  case ';':
    p->lstate = EXPR_BEG;
    return ';';

  case ',':
    p->lstate = EXPR_BEG;
    return ',';

  case '~':
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      if ((c = nextc(p)) != '@') {
	pushback(p, c);
      }
      p->lstate = EXPR_ARG;
    }
    else {
      p->lstate = EXPR_BEG;
    }
    return '~';

  case '(':
    if (IS_BEG()) {
      c = tLPAREN;
    }
    else if (IS_SPCARG(-1)) {
      c = tLPAREN_ARG;
    }
    p->paren_nest++;
    COND_PUSH(0);
    CMDARG_PUSH(0);
    p->lstate = EXPR_BEG;
    return c;

  case '[':
    p->paren_nest++;
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if ((c = nextc(p)) == ']') {
	if ((c = nextc(p)) == '=') {
	  return tASET;
	}
	pushback(p, c);
	return tAREF;
      }
      pushback(p, c);
      return '[';
    }
    else if (IS_BEG()) {
      c = tLBRACK;
    }
    else if (IS_ARG() && space_seen) {
      c = tLBRACK;
    }
    p->lstate = EXPR_BEG;
    COND_PUSH(0);
    CMDARG_PUSH(0);
    return c;

  case '{':
    if (p->lpar_beg && p->lpar_beg == p->paren_nest) {
      p->lstate = EXPR_BEG;
      p->lpar_beg = 0;
      p->paren_nest--;
      COND_PUSH(0);
      CMDARG_PUSH(0);
      return tLAMBEG;
    }
    if (IS_ARG() || p->lstate == EXPR_END || p->lstate == EXPR_ENDFN)
      c = '{';          /* block (primary) */
    else if (p->lstate == EXPR_ENDARG)
      c = tLBRACE_ARG;  /* block (expr) */
    else
      c = tLBRACE;      /* hash */
    COND_PUSH(0);
    CMDARG_PUSH(0);
    p->lstate = EXPR_BEG;
    return c;

  case '\\':
    c = nextc(p);
    if (c == '\n') {
      p->lineno++;
      p->column = 0;
      space_seen = 1;
      goto retry; /* skip \\n */
    }
    pushback(p, c);
    return '\\';

  case '%':
    if (IS_BEG()) {
      int term;
      int paren;

      c = nextc(p);
    quotation:
      if (c < 0 || !ISALNUM(c)) {
	term = c;
	c = 'Q';
      }
      else {
	term = nextc(p);
	if (isalnum(term)) {
	  yyerror(p, "unknown type of %string");
	  return 0;
	}
      }
      if (c < 0 || term < 0) {
	yyerror(p, "unterminated quoted string meets end of file");
	return 0;
      }
      paren = term;
      if (term == '(') term = ')';
      else if (term == '[') term = ']';
      else if (term == '{') term = '}';
      else if (term == '<') term = '>';
      else paren = 0;

      switch (c) {
      case 'Q':
	p->lex_strterm = new_strterm(p, str_dquote, term, paren);
	return tSTRING_BEG;

      case 'q':
	p->lex_strterm = new_strterm(p, str_squote, term, paren);
	return parse_string(p);

      case 'W':
	p->lex_strterm = new_strterm(p, str_dword, term, paren);
	return tWORDS_BEG;

      case 'w':
	p->lex_strterm = new_strterm(p, str_sword, term, paren);
	return tWORDS_BEG;

      case 'x':
	p->lex_strterm = new_strterm(p, str_xquote, term, paren);
	return tXSTRING_BEG;

      case 'r':
	p->lex_strterm = new_strterm(p, str_regexp, term, paren);
	return tREGEXP_BEG;

      case 's':
	p->lex_strterm = new_strterm(p, str_ssym, term, paren);
	return tSYMBEG;

      case 'I':
	p->lex_strterm = new_strterm(p, str_dsymbols, term, paren);
	return tSYMBOLS_BEG;

      case 'i':
	p->lex_strterm = new_strterm(p, str_ssymbols, term, paren);
	return tSYMBOLS_BEG;

      default:
	yyerror(p, "unknown type of %string");
	return 0;
      }
    }
    if ((c = nextc(p)) == '=') {
      yylval.id = intern_c('%');
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (IS_SPCARG(c)) {
      goto quotation;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    } else {
      p->lstate = EXPR_BEG;
    }
    pushback(p, c);
    return '%';

  case '$':
    p->lstate = EXPR_END;
    token_column = newtok(p);
    c = nextc(p);
    if (c < 0) {
      yyerror(p, "incomplete global variable syntax");
      return 0;
    }
    switch (c) {
    case '_':     /* $_: last read line string */
      c = nextc(p);
      if (c >= 0 && identchar(c)) { /* if there is more after _ it is a variable */
	tokadd(p, '$');
	tokadd(p, c);
	break;
      }
      pushback(p, c);
      c = '_';
      /* fall through */
    case '~':     /* $~: match-data */
    case '*':     /* $*: argv */
    case '$':     /* $$: pid */
    case '?':     /* $?: last status */
    case '!':     /* $!: error string */
    case '@':     /* $@: error position */
    case '/':     /* $/: input record separator */
    case '\\':    /* $\: output record separator */
    case ';':     /* $;: field separator */
    case ',':     /* $,: output field separator */
    case '.':     /* $.: last read line number */
    case '=':     /* $=: ignorecase */
    case ':':     /* $:: load path */
    case '<':     /* $<: reading filename */
    case '>':     /* $>: default output handle */
    case '\"':    /* $": already loaded files */
      tokadd(p, '$');
      tokadd(p, c);
      tokfix(p);
      yylval.id = intern_cstr(tok(p));
      return tGVAR;

    case '-':
      tokadd(p, '$');
      tokadd(p, c);
      c = nextc(p);
      pushback(p, c);
    gvar:
      tokfix(p);
      yylval.id = intern_cstr(tok(p));
      return tGVAR;

    case '&':     /* $&: last match */
    case '`':     /* $`: string before last match */
    case '\'':    /* $': string after last match */
    case '+':     /* $+: string matches last pattern */
      if (last_state == EXPR_FNAME) {
	tokadd(p, '$');
	tokadd(p, c);
	goto gvar;
      }
      yylval.nd = new_back_ref(p, c);
      return tBACK_REF;

    case '1': case '2': case '3':
    case '4': case '5': case '6':
    case '7': case '8': case '9':
      do {
	tokadd(p, c);
	c = nextc(p);
      } while (c >= 0 && isdigit(c));
      pushback(p, c);
      if (last_state == EXPR_FNAME) goto gvar;
      tokfix(p);
      yylval.nd = new_nth_ref(p, atoi(tok(p)));
      return tNTH_REF;

    default:
      if (!identchar(c)) {
	pushback(p,  c);
	return '$';
      }
    case '0':
      tokadd(p, '$');
    }
    break;

  case '@':
    c = nextc(p);
    token_column = newtok(p);
    tokadd(p, '@');
    if (c == '@') {
      tokadd(p, '@');
      c = nextc(p);
    }
    if (c < 0) {
      if (p->bidx == 1) {
	yyerror(p, "incomplete instance variable syntax");
      }
      else {
	yyerror(p, "incomplete class variable syntax");
      }
      return 0;
    }
    else if (isdigit(c)) {
      if (p->bidx == 1) {
	yyerror_i(p, "`@%c' is not allowed as an instance variable name", c);
      }
      else {
	yyerror_i(p, "`@@%c' is not allowed as a class variable name", c);
      }
      return 0;
    }
    if (!identchar(c)) {
      pushback(p, c);
      return '@';
    }
    break;

  case '_':
    token_column = newtok(p);
    break;

  default:
    if (!identchar(c)) {
      yyerror_i(p,  "Invalid char `\\x%02X' in expression", c);
      goto retry;
    }

    token_column = newtok(p);
    break;
  }

  do {
    tokadd(p, c);
    c = nextc(p);
    if (c < 0) break;
  } while (identchar(c));
  if (token_column == 0 && toklen(p) == 7 && (c < 0 || c == '\n') &&
      strncmp(tok(p), "__END__", toklen(p)) == 0)
    return -1;

  switch (tok(p)[0]) {
  case '@': case '$':
    pushback(p, c);
    break;
  default:
    if ((c == '!' || c == '?') && !peek(p, '=')) {
      tokadd(p, c);
    }
    else {
      pushback(p, c);
    }
  }
  tokfix(p);
  {
    int result = 0;

    last_state = p->lstate;
    switch (tok(p)[0]) {
    case '$':
      p->lstate = EXPR_END;
      result = tGVAR;
      break;
    case '@':
      p->lstate = EXPR_END;
      if (tok(p)[1] == '@')
	result = tCVAR;
      else
	result = tIVAR;
      break;

    default:
      if (toklast(p) == '!' || toklast(p) == '?') {
	result = tFID;
      }
      else {
	if (p->lstate == EXPR_FNAME) {
	  if ((c = nextc(p)) == '=' && !peek(p, '~') && !peek(p, '>') &&
	      (!peek(p, '=') || (peek_n(p, '>', 1)))) {
	    result = tIDENTIFIER;
	    tokadd(p, c);
	    tokfix(p);
	  }
	  else {
	    pushback(p, c);
	  }
	}
	if (result == 0 && isupper((int)(unsigned char)tok(p)[0])) {
	  result = tCONSTANT;
	}
	else {
	  result = tIDENTIFIER;
	}
      }

      if (IS_LABEL_POSSIBLE()) {
	if (IS_LABEL_SUFFIX(0)) {
	  p->lstate = EXPR_BEG;
	  nextc(p);
	  tokfix(p);
	  yylval.id = intern_cstr(tok(p));
	  return tLABEL;
	}
      }
      if (p->lstate != EXPR_DOT) {
	const struct kwtable *kw;

	/* See if it is a reserved word.  */
	kw = mrb_reserved_word(tok(p), toklen(p));
	if (kw) {
	  enum mrb_lex_state_enum state = p->lstate;
	  p->lstate = kw->state;
	  if (state == EXPR_FNAME) {
	    yylval.id = intern_cstr(kw->name);
	    return kw->id[0];
	  }
	  if (p->lstate == EXPR_BEG) {
	    p->cmd_start = TRUE;
	  }
	  if (kw->id[0] == keyword_do) {
	    if (p->lpar_beg && p->lpar_beg == p->paren_nest) {
	      p->lpar_beg = 0;
	      p->paren_nest--;
	      return keyword_do_LAMBDA;
	    }
	    if (COND_P()) return keyword_do_cond;
	    if (CMDARG_P() && state != EXPR_CMDARG)
	      return keyword_do_block;
	    if (state == EXPR_ENDARG || state == EXPR_BEG)
	      return keyword_do_block;
	    return keyword_do;
	  }
	  if (state == EXPR_BEG || state == EXPR_VALUE)
	    return kw->id[0];
	  else {
	    if (kw->id[0] != kw->id[1])
	      p->lstate = EXPR_BEG;
	    return kw->id[1];
	  }
	}
      }

      if (IS_BEG() || p->lstate == EXPR_DOT || IS_ARG()) {
	if (cmd_state) {
	  p->lstate = EXPR_CMDARG;
	}
	else {
	  p->lstate = EXPR_ARG;
	}
      }
      else if (p->lstate == EXPR_FNAME) {
	p->lstate = EXPR_ENDFN;
      }
      else {
	p->lstate = EXPR_END;
      }
    }
    {
      mrb_sym ident = intern_cstr(tok(p));

      yylval.id = ident;
#if 0
      if (last_state != EXPR_DOT && islower(tok(p)[0]) && lvar_defined(ident)) {
	p->lstate = EXPR_END;
      }
#endif
    }
    return result;
  }
}

static int
yylex(void *lval, parser_state *p)
{
  int t;

  p->ylval = lval;
  t = parser_yylex(p);

  return t;
}

static void
parser_init_cxt(parser_state *p, mrbc_context *cxt)
{
  if (!cxt) return;
  if (cxt->lineno) p->lineno = cxt->lineno;
  if (cxt->filename) mrb_parser_set_filename(p, cxt->filename);
  if (cxt->syms) {
    int i;

    p->locals = cons(0,0);
    for (i=0; i<cxt->slen; i++) {
      local_add_f(p, cxt->syms[i]);
    }
  }
  p->capture_errors = cxt->capture_errors;
  if (cxt->partial_hook) {
    p->cxt = cxt;
  }
}

static void
parser_update_cxt(parser_state *p, mrbc_context *cxt)
{
  node *n, *n0;
  int i = 0;

  if (!cxt) return;
  if ((int)(intptr_t)p->tree->car != NODE_SCOPE) return;
  n0 = n = p->tree->cdr->car;
  while (n) {
    i++;
    n = n->cdr;
  }
  cxt->syms = (mrb_sym *)mrb_realloc(p->mrb, cxt->syms, i*sizeof(mrb_sym));
  cxt->slen = i;
  for (i=0, n=n0; n; i++,n=n->cdr) {
    cxt->syms[i] = sym(n->car);
  }
}

void codedump_all(mrb_state*, struct RProc*);
void parser_dump(mrb_state *mrb, node *tree, int offset);

void
mrb_parser_parse(parser_state *p, mrbc_context *c)
{
  if (setjmp(p->jmp) != 0) {
    yyerror(p, "memory allocation error");
    p->nerr++;
    p->tree = 0;
    return;
  }

  p->cmd_start = TRUE;
  p->in_def = p->in_single = FALSE;
  p->nerr = p->nwarn = 0;
  p->lex_strterm = NULL;

  parser_init_cxt(p, c);
  yyparse(p);
  if (!p->tree) {
    p->tree = new_nil(p);
  }
  parser_update_cxt(p, c);
  if (c && c->dump_result) {
    parser_dump(p->mrb, p->tree, 0);
  }
}

parser_state*
mrb_parser_new(mrb_state *mrb)
{
  mrb_pool *pool;
  parser_state *p;
  static const parser_state parser_state_zero = { 0 };

  pool = mrb_pool_open(mrb);
  if (!pool) return 0;
  p = (parser_state *)mrb_pool_alloc(pool, sizeof(parser_state));
  if (!p) return 0;

  *p = parser_state_zero;
  p->mrb = mrb;
  p->pool = pool;
  p->in_def = p->in_single = 0;

  p->s = p->send = NULL;
#ifdef ENABLE_STDIO
  p->f = NULL;
#endif

  p->cmd_start = TRUE;
  p->in_def = p->in_single = FALSE;

  p->capture_errors = 0;
  p->lineno = 1;
  p->column = 0;
#if defined(PARSER_TEST) || defined(PARSER_DEBUG)
  yydebug = 1;
#endif

  p->lex_strterm = NULL;
  p->all_heredocs = p->parsing_heredoc = NULL;
  p->lex_strterm_before_heredoc = NULL;

  p->current_filename_index = -1;
  p->filename_table = NULL;
  p->filename_table_length = 0;

  return p;
}

void
mrb_parser_free(parser_state *p) {
  mrb_pool_close(p->pool);
}

mrbc_context*
mrbc_context_new(mrb_state *mrb)
{
  mrbc_context *c;

  c = (mrbc_context *)mrb_calloc(mrb, 1, sizeof(mrbc_context));
  return c;
}

void
mrbc_context_free(mrb_state *mrb, mrbc_context *cxt)
{
  mrb_free(mrb, cxt->syms);
  mrb_free(mrb, cxt);
}

const char*
mrbc_filename(mrb_state *mrb, mrbc_context *c, const char *s)
{
  if (s) {
    int len = strlen(s);
    char *p = (char *)mrb_alloca(mrb, len + 1);

    memcpy(p, s, len + 1);
    c->filename = p;
  }
  return c->filename;
}

void
mrbc_partial_hook(mrb_state *mrb, mrbc_context *c, int (*func)(struct mrb_parser_state*), void *data)
{
  c->partial_hook = func;
  c->partial_data = data;
}

void
mrb_parser_set_filename(struct mrb_parser_state *p, const char *f)
{
  mrb_sym sym;
  size_t len;
  size_t i;
  mrb_sym* new_table;

  sym = mrb_intern_cstr(p->mrb, f);
  p->filename = mrb_sym2name_len(p->mrb, sym, &len);
  p->lineno = (p->filename_table_length > 0)? 0 : 1;
  
  for(i = 0; i < p->filename_table_length; ++i) {
    if(p->filename_table[i] == sym) {
      p->current_filename_index = i;
      return;
    }
  }

  p->current_filename_index = p->filename_table_length++;

  new_table = parser_palloc(p, sizeof(mrb_sym) * p->filename_table_length);
  if (p->filename_table) {
    memcpy(new_table, p->filename_table, sizeof(mrb_sym) * p->filename_table_length);
  }
  p->filename_table = new_table;
  p->filename_table[p->filename_table_length - 1] = sym;
}

char const* mrb_parser_get_filename(struct mrb_parser_state* p, uint16_t idx) {
  if (idx >= p->filename_table_length) { return NULL; }
  else {
    size_t len;
    return mrb_sym2name_len(p->mrb, p->filename_table[idx], &len);
  }
}

#ifdef ENABLE_STDIO
parser_state*
mrb_parse_file(mrb_state *mrb, FILE *f, mrbc_context *c)
{
  parser_state *p;

  p = mrb_parser_new(mrb);
  if (!p) return 0;
  p->s = p->send = NULL;
  p->f = f;

  mrb_parser_parse(p, c);
  return p;
}
#endif

parser_state*
mrb_parse_nstring(mrb_state *mrb, const char *s, int len, mrbc_context *c)
{
  parser_state *p;

  p = mrb_parser_new(mrb);
  if (!p) return 0;
  p->s = s;
  p->send = s + len;

  mrb_parser_parse(p, c);
  return p;
}

parser_state*
mrb_parse_string(mrb_state *mrb, const char *s, mrbc_context *c)
{
  return mrb_parse_nstring(mrb, s, strlen(s), c);
}

static mrb_value
load_exec(mrb_state *mrb, parser_state *p, mrbc_context *c)
{
  struct RClass *target = mrb->object_class;
  struct RProc *proc;
  mrb_value v;

  if (!p) {
    return mrb_undef_value();
  }
  if (!p->tree || p->nerr) {
    if (p->capture_errors) {
      char buf[256];
      int n;

      n = snprintf(buf, sizeof(buf), "line %d: %s\n",
      p->error_buffer[0].lineno, p->error_buffer[0].message);
      mrb->exc = mrb_obj_ptr(mrb_exc_new(mrb, E_SYNTAX_ERROR, buf, n));
      mrb_parser_free(p);
      return mrb_undef_value();
    }
    else {
      static const char msg[] = "syntax error";
      mrb->exc = mrb_obj_ptr(mrb_exc_new(mrb, E_SYNTAX_ERROR, msg, sizeof(msg) - 1));
      mrb_parser_free(p);
      return mrb_undef_value();
    }
  }
  proc = mrb_generate_code(mrb, p);
  mrb_parser_free(p);
  if (proc == NULL) {
    static const char msg[] = "codegen error";
    mrb->exc = mrb_obj_ptr(mrb_exc_new(mrb, E_SCRIPT_ERROR, msg, sizeof(msg) - 1));
    return mrb_undef_value();
  }
  if (c) {
    if (c->dump_result) codedump_all(mrb, proc);
    if (c->no_exec) return mrb_obj_value(proc);
    if (c->target_class) {
      target = c->target_class;
    }
  }
  proc->target_class = target;
  if (mrb->c->ci) {
    mrb->c->ci->target_class = target;
  }
  v = mrb_context_run(mrb, proc, mrb_top_self(mrb), 0);
  if (mrb->exc) return mrb_nil_value();
  return v;
}

#ifdef ENABLE_STDIO
mrb_value
mrb_load_file_cxt(mrb_state *mrb, FILE *f, mrbc_context *c)
{
  return load_exec(mrb, mrb_parse_file(mrb, f, c), c);
}

mrb_value
mrb_load_file(mrb_state *mrb, FILE *f)
{
  return mrb_load_file_cxt(mrb, f, NULL);
}
#endif

mrb_value
mrb_load_nstring_cxt(mrb_state *mrb, const char *s, int len, mrbc_context *c)
{
  return load_exec(mrb, mrb_parse_nstring(mrb, s, len, c), c);
}

mrb_value
mrb_load_nstring(mrb_state *mrb, const char *s, int len)
{
  return mrb_load_nstring_cxt(mrb, s, len, NULL);
}

mrb_value
mrb_load_string_cxt(mrb_state *mrb, const char *s, mrbc_context *c)
{
  return mrb_load_nstring_cxt(mrb, s, strlen(s), c);
}

mrb_value
mrb_load_string(mrb_state *mrb, const char *s)
{
  return mrb_load_string_cxt(mrb, s, NULL);
}

#ifdef ENABLE_STDIO

static void
dump_prefix(int offset)
{
  while (offset--) {
    putc(' ', stdout);
    putc(' ', stdout);
  }
}

static void
dump_recur(mrb_state *mrb, node *tree, int offset)
{
  while (tree) {
    parser_dump(mrb, tree->car, offset);
    tree = tree->cdr;
  }
}

#endif

void
parser_dump(mrb_state *mrb, node *tree, int offset)
{
#ifdef ENABLE_STDIO
  int n;

  if (!tree) return;
 again:
  dump_prefix(offset);
  n = (int)(intptr_t)tree->car;
  tree = tree->cdr;
  switch (n) {
  case NODE_BEGIN:
    printf("NODE_BEGIN:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_RESCUE:
    printf("NODE_RESCUE:\n");
    if (tree->car) {
      dump_prefix(offset+1);
      printf("body:\n");
      parser_dump(mrb, tree->car, offset+2);
    }
    tree = tree->cdr;
    if (tree->car) {
      node *n2 = tree->car;

      dump_prefix(offset+1);
      printf("rescue:\n");
      while (n2) {
	node *n3 = n2->car;
	if (n3->car) {
	  dump_prefix(offset+2);
	  printf("handle classes:\n");
	  dump_recur(mrb, n3->car, offset+3);
	}
	if (n3->cdr->car) {
	  dump_prefix(offset+2);
	  printf("exc_var:\n");
	  parser_dump(mrb, n3->cdr->car, offset+3);
	}
	if (n3->cdr->cdr->car) {
	  dump_prefix(offset+2);
	  printf("rescue body:\n");
	  parser_dump(mrb, n3->cdr->cdr->car, offset+3);
	}
	n2 = n2->cdr;
      }
    }
    tree = tree->cdr;
    if (tree->car) {
      dump_prefix(offset+1);
      printf("else:\n");
      parser_dump(mrb, tree->car, offset+2);
    }
    break;

  case NODE_ENSURE:
    printf("NODE_ENSURE:\n");
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("ensure:\n");
    parser_dump(mrb, tree->cdr->cdr, offset+2);
    break;

  case NODE_LAMBDA:
    printf("NODE_BLOCK:\n");
    goto block;

  case NODE_BLOCK:
  block:
    printf("NODE_BLOCK:\n");
    tree = tree->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, sym(n2->car->car)));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, sym(n->car)));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, sym(n)));
      }
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car, offset+2);
    break;

  case NODE_IF:
    printf("NODE_IF:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("then:\n");
    parser_dump(mrb, tree->cdr->car, offset+2);
    if (tree->cdr->cdr->car) {
      dump_prefix(offset+1);
      printf("else:\n");
      parser_dump(mrb, tree->cdr->cdr->car, offset+2);
    }
    break;

  case NODE_AND:
    printf("NODE_AND:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_OR:
    printf("NODE_OR:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_CASE:
    printf("NODE_CASE:\n");
    if (tree->car) {
      parser_dump(mrb, tree->car, offset+1);
    }
    tree = tree->cdr;
    while (tree) {
      dump_prefix(offset+1);
      printf("case:\n");
      dump_recur(mrb, tree->car->car, offset+2);
      dump_prefix(offset+1);
      printf("body:\n");
      parser_dump(mrb, tree->car->cdr, offset+2);
      tree = tree->cdr;
    }
    break;

  case NODE_WHILE:
    printf("NODE_WHILE:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_UNTIL:
    printf("NODE_UNTIL:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_FOR:
    printf("NODE_FOR:\n");
    dump_prefix(offset+1);
    printf("var:\n");
    {
      node *n2 = tree->car;

      if (n2->car) {
	dump_prefix(offset+2);
	printf("pre:\n");
	dump_recur(mrb, n2->car, offset+3);
      }
      n2 = n2->cdr;
      if (n2) {
	if (n2->car) {
	  dump_prefix(offset+2);
	  printf("rest:\n");
	  parser_dump(mrb, n2->car, offset+3);
	}
	n2 = n2->cdr;
	if (n2) {
	  if (n2->car) {
	    dump_prefix(offset+2);
	    printf("post:\n");
	    dump_recur(mrb, n2->car, offset+3);
	  }
	}
      }
    }
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("in:\n");
    parser_dump(mrb, tree->car, offset+2);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("do:\n");
    parser_dump(mrb, tree->car, offset+2);
    break;

  case NODE_SCOPE:
    printf("NODE_SCOPE:\n");
    {
      node *n2 = tree->car;

      if (n2  && (n2->car || n2->cdr)) {
	dump_prefix(offset+1);
	printf("local variables:\n");
	dump_prefix(offset+2);
	while (n2) {
	  if (n2->car) {
	    if (n2 != tree->car) printf(", ");
	    printf("%s", mrb_sym2name(mrb, sym(n2->car)));
	  }
	  n2 = n2->cdr;
	}
	printf("\n");
      }
    }
    tree = tree->cdr;
    offset++;
    goto again;

  case NODE_FCALL:
  case NODE_CALL:
    printf("NODE_CALL:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("method='%s' (%d)\n",
    mrb_sym2name(mrb, sym(tree->cdr->car)),
    (int)(intptr_t)tree->cdr->car);
    tree = tree->cdr->cdr->car;
    if (tree) {
      dump_prefix(offset+1);
      printf("args:\n");
      dump_recur(mrb, tree->car, offset+2);
      if (tree->cdr) {
	dump_prefix(offset+1);
	printf("block:\n");
	parser_dump(mrb, tree->cdr, offset+2);
      }
    }
    break;

  case NODE_DOT2:
    printf("NODE_DOT2:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_DOT3:
    printf("NODE_DOT3:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_COLON2:
    printf("NODE_COLON2:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("::%s\n", mrb_sym2name(mrb, sym(tree->cdr)));
    break;

  case NODE_COLON3:
    printf("NODE_COLON3:\n");
    dump_prefix(offset+1);
    printf("::%s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_ARRAY:
    printf("NODE_ARRAY:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_HASH:
    printf("NODE_HASH:\n");
    while (tree) {
      dump_prefix(offset+1);
      printf("key:\n");
      parser_dump(mrb, tree->car->car, offset+2);
      dump_prefix(offset+1);
      printf("value:\n");
      parser_dump(mrb, tree->car->cdr, offset+2);
      tree = tree->cdr;
    }
    break;

  case NODE_SPLAT:
    printf("NODE_SPLAT:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_ASGN:
    printf("NODE_ASGN:\n");
    dump_prefix(offset+1);
    printf("lhs:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("rhs:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_MASGN:
    printf("NODE_MASGN:\n");
    dump_prefix(offset+1);
    printf("mlhs:\n");
    {
      node *n2 = tree->car;

      if (n2->car) {
	dump_prefix(offset+2);
	printf("pre:\n");
	dump_recur(mrb, n2->car, offset+3);
      }
      n2 = n2->cdr;
      if (n2) {
	if (n2->car) {
	  dump_prefix(offset+2);
	  printf("rest:\n");
	  if (n2->car == (node*)-1) {
	    dump_prefix(offset+2);
	    printf("(empty)\n");
	  }
	  else {
	    parser_dump(mrb, n2->car, offset+3);
	  }
	}
	n2 = n2->cdr;
	if (n2) {
	  if (n2->car) {
	    dump_prefix(offset+2);
	    printf("post:\n");
	    dump_recur(mrb, n2->car, offset+3);
	  }
	}
      }
    }
    dump_prefix(offset+1);
    printf("rhs:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_OP_ASGN:
    printf("NODE_OP_ASGN:\n");
    dump_prefix(offset+1);
    printf("lhs:\n");
    parser_dump(mrb, tree->car, offset+2);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("op='%s' (%d)\n", mrb_sym2name(mrb, sym(tree->car)), (int)(intptr_t)tree->car);
    tree = tree->cdr;
    parser_dump(mrb, tree->car, offset+1);
    break;

  case NODE_SUPER:
    printf("NODE_SUPER:\n");
    if (tree) {
      dump_prefix(offset+1);
      printf("args:\n");
      dump_recur(mrb, tree->car, offset+2);
      if (tree->cdr) {
	dump_prefix(offset+1);
	printf("block:\n");
	parser_dump(mrb, tree->cdr, offset+2);
      }
    }
    break;

  case NODE_ZSUPER:
    printf("NODE_ZSUPER\n");
    break;

  case NODE_RETURN:
    printf("NODE_RETURN:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_YIELD:
    printf("NODE_YIELD:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_BREAK:
    printf("NODE_BREAK:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_NEXT:
    printf("NODE_NEXT:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_REDO:
    printf("NODE_REDO\n");
    break;

  case NODE_RETRY:
    printf("NODE_RETRY\n");
    break;

  case NODE_LVAR:
    printf("NODE_LVAR %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_GVAR:
    printf("NODE_GVAR %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_IVAR:
    printf("NODE_IVAR %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_CVAR:
    printf("NODE_CVAR %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_CONST:
    printf("NODE_CONST %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_MATCH:
    printf("NODE_MATCH:\n");
    dump_prefix(offset + 1);
    printf("lhs:\n");
    parser_dump(mrb, tree->car, offset + 2);
    dump_prefix(offset + 1);
    printf("rhs:\n");
    parser_dump(mrb, tree->cdr, offset + 2);
    break;

  case NODE_BACK_REF:
    printf("NODE_BACK_REF: $%c\n", (int)(intptr_t)tree);
    break;

  case NODE_NTH_REF:
    printf("NODE_NTH_REF: $%d\n", (int)(intptr_t)tree);
    break;

  case NODE_ARG:
    printf("NODE_ARG %s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_BLOCK_ARG:
    printf("NODE_BLOCK_ARG:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_INT:
    printf("NODE_INT %s base %d\n", (char*)tree->car, (int)(intptr_t)tree->cdr->car);
    break;

  case NODE_FLOAT:
    printf("NODE_FLOAT %s\n", (char*)tree);
    break;

  case NODE_NEGATE:
    printf("NODE_NEGATE\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_STR:
    printf("NODE_STR \"%s\" len %d\n", (char*)tree->car, (int)(intptr_t)tree->cdr);
    break;

  case NODE_DSTR:
    printf("NODE_DSTR\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_XSTR:
    printf("NODE_XSTR \"%s\" len %d\n", (char*)tree->car, (int)(intptr_t)tree->cdr);
    break;

  case NODE_DXSTR:
    printf("NODE_DXSTR\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_REGX:
    printf("NODE_REGX /%s/%s\n", (char*)tree->car, (char*)tree->cdr);
    break;

  case NODE_DREGX:
    printf("NODE_DREGX\n");
    dump_recur(mrb, tree->car, offset+1);
    dump_prefix(offset);
    printf("tail: %s\n", (char*)tree->cdr->cdr->car);
    dump_prefix(offset);
    printf("opt: %s\n", (char*)tree->cdr->cdr->cdr);
    break;

  case NODE_SYM:
    printf("NODE_SYM :%s\n", mrb_sym2name(mrb, sym(tree)));
    break;

  case NODE_SELF:
    printf("NODE_SELF\n");
    break;

  case NODE_NIL:
    printf("NODE_NIL\n");
    break;

  case NODE_TRUE:
    printf("NODE_TRUE\n");
    break;

  case NODE_FALSE:
    printf("NODE_FALSE\n");
    break;

  case NODE_ALIAS:
    printf("NODE_ALIAS %s %s:\n",
	    mrb_sym2name(mrb, sym(tree->car)),
	    mrb_sym2name(mrb, sym(tree->cdr)));
    break;

  case NODE_UNDEF:
    printf("NODE_UNDEF");
    {
      node *t = tree;
      while (t) {
	printf(" %s", mrb_sym2name(mrb, sym(t->car)));
	t = t->cdr;
      }
    }
    printf(":\n");
    break;

  case NODE_CLASS:
    printf("NODE_CLASS:\n");
    if (tree->car->car == (node*)0) {
      dump_prefix(offset+1);
      printf(":%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    else if (tree->car->car == (node*)1) {
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    else {
      parser_dump(mrb, tree->car->car, offset+1);
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    if (tree->cdr->car) {
      dump_prefix(offset+1);
      printf("super:\n");
      parser_dump(mrb, tree->cdr->car, offset+2);
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->cdr->car->cdr, offset+2);
    break;

  case NODE_MODULE:
    printf("NODE_MODULE:\n");
    if (tree->car->car == (node*)0) {
      dump_prefix(offset+1);
      printf(":%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    else if (tree->car->car == (node*)1) {
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    else {
      parser_dump(mrb, tree->car->car, offset+1);
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, sym(tree->car->cdr)));
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car->cdr, offset+2);
    break;

  case NODE_SCLASS:
    printf("NODE_SCLASS:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car->cdr, offset+2);
    break;

  case NODE_DEF:
    printf("NODE_DEF:\n");
    dump_prefix(offset+1);
    printf("%s\n", mrb_sym2name(mrb, sym(tree->car)));
    tree = tree->cdr;
    {
      node *n2 = tree->car;

      if (n2 && (n2->car || n2->cdr)) {
	dump_prefix(offset+1);
	printf("local variables:\n");
	dump_prefix(offset+2);
	while (n2) {
	  if (n2->car) {
	    if (n2 != tree->car) printf(", ");
	    printf("%s", mrb_sym2name(mrb, sym(n2->car)));
	  }
	  n2 = n2->cdr;
	}
	printf("\n");
      }
    }
    tree = tree->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, sym(n2->car->car)));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, sym(n->car)));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, sym(n)));
      }
    }
    parser_dump(mrb, tree->cdr->car, offset+1);
    break;

  case NODE_SDEF:
    printf("NODE_SDEF:\n");
    parser_dump(mrb, tree->car, offset+1);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf(":%s\n", mrb_sym2name(mrb, sym(tree->car)));
    tree = tree->cdr->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, sym(n2->car->car)));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, sym(n->car)));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, sym(n)));
      }
    }
    tree = tree->cdr;
    parser_dump(mrb, tree->car, offset+1);
    break;

  case NODE_POSTEXE:
    printf("NODE_POSTEXE:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_HEREDOC:
    printf("NODE_HEREDOC:\n");
    parser_dump(mrb, ((parser_heredoc_info*)tree)->doc, offset+1);
    break;

  default:
    printf("node type: %d (0x%x)\n", (int)n, (int)n);
    break;
  }
#endif
}
